`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_wb.v"












































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 141 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_wb.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 143 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_wb.v"

 
module uart_wb (clk, wb_rst_i, 
	wb_we_i, wb_stb_i, wb_cyc_i, wb_ack_o, wb_adr_i,
	wb_adr_int, wb_dat_i, wb_dat_o, wb_dat8_i, wb_dat8_o, wb_dat32_o, wb_sel_i,
	we_o, re_o 
);

input 		  clk;


input 		  wb_rst_i;
input 		  wb_we_i;
input 		  wb_stb_i;
input 		  wb_cyc_i;
input [3:0]   wb_sel_i;
input [ 5-1:0] 	wb_adr_i; 







 
input [31:0]  wb_dat_i; 
output [31:0] wb_dat_o;
reg [31:0] 	  wb_dat_o;
wire [31:0]   wb_dat_i;
reg [31:0] 	  wb_dat_is;
 

output [ 5-1:0]	wb_adr_int; 
input [7:0]   wb_dat8_o; 
output [7:0]  wb_dat8_i;
input [31:0]  wb_dat32_o; 
output 		  wb_ack_o;
output 		  we_o;
output 		  re_o;

wire 			  we_o;
reg 			  wb_ack_o;
reg [7:0] 	  wb_dat8_i;
wire [7:0] 	  wb_dat8_o;
wire [ 5-1:0]	wb_adr_int; 
reg [ 5-1:0]	wb_adr_is;
reg 								wb_we_is;
reg 								wb_cyc_is;
reg 								wb_stb_is;
reg [3:0] 						wb_sel_is;
wire [3:0]   wb_sel_i;
reg 			 wre ;


reg [1:0] 	 wbstate;
always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) begin
		wb_ack_o <= #1 1'b0;
		wbstate <= #1 0;
		wre <= #1 1'b1;
	end else
		case (wbstate)
			0: begin
				if (wb_stb_is & wb_cyc_is) begin
					wre <= #1 0;
					wbstate <= #1 1;
					wb_ack_o <= #1 1;
				end else begin
					wre <= #1 1;
					wb_ack_o <= #1 0;
				end
			end
			1: begin
			   wb_ack_o <= #1 0;
				wbstate <= #1 2;
				wre <= #1 0;
			end
			2,3: begin
				wb_ack_o <= #1 0;
				wbstate <= #1 0;
				wre <= #1 0;
			end
		endcase

assign we_o =  wb_we_is & wb_stb_is & wb_cyc_is & wre ; 
assign re_o = ~wb_we_is & wb_stb_is & wb_cyc_is & wre ; 


always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) begin
		wb_adr_is <= #1 0;
		wb_we_is <= #1 0;
		wb_cyc_is <= #1 0;
		wb_stb_is <= #1 0;
		wb_dat_is <= #1 0;
		wb_sel_is <= #1 0;
	end else begin
		wb_adr_is <= #1 wb_adr_i;
		wb_we_is <= #1 wb_we_i;
		wb_cyc_is <= #1 wb_cyc_i;
		wb_stb_is <= #1 wb_stb_i;
		wb_dat_is <= #1 wb_dat_i;
		wb_sel_is <= #1 wb_sel_i;
	end













 

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i)
		wb_dat_o <= #1 0;
	else if (re_o)
		case (wb_sel_is)
			4'b0001: wb_dat_o <= #1 {24'b0, wb_dat8_o};
			4'b0010: wb_dat_o <= #1 {16'b0, wb_dat8_o, 8'b0};
			4'b0100: wb_dat_o <= #1 {8'b0, wb_dat8_o, 16'b0};
			4'b1000: wb_dat_o <= #1 {wb_dat8_o, 24'b0};
			4'b1111: wb_dat_o <= #1 wb_dat32_o; 
 			default: wb_dat_o <= #1 0;
		endcase 

reg [1:0] wb_adr_int_lsb;

always @(wb_sel_is or wb_dat_is)
begin
	case (wb_sel_is)
		4'b0001 : wb_dat8_i = wb_dat_is[7:0];
		4'b0010 : wb_dat8_i = wb_dat_is[15:8];
		4'b0100 : wb_dat8_i = wb_dat_is[23:16];
		4'b1000 : wb_dat8_i = wb_dat_is[31:24];
		default : wb_dat8_i = wb_dat_is[7:0];
	endcase 

  








	case (wb_sel_is)
		4'b0001 : wb_adr_int_lsb = 2'h3;
		4'b0010 : wb_adr_int_lsb = 2'h2;
		4'b0100 : wb_adr_int_lsb = 2'h1;
		4'b1000 : wb_adr_int_lsb = 2'h0;
		default : wb_adr_int_lsb = 2'h0;
	endcase 
  
end

assign wb_adr_int = {wb_adr_is[ 5-1:2], wb_adr_int_lsb};

 

endmodule












`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\raminfr.v"





















































































module raminfr   
        (clk, we, a, dpra, di, dpo); 

parameter addr_width = 4;
parameter data_width = 8;
parameter depth = 16;

input clk;   
input we;   
input  [addr_width-1:0] a;   
input  [addr_width-1:0] dpra;   
input  [data_width-1:0] di;   

output [data_width-1:0] dpo;   
reg    [data_width-1:0] ram [depth-1:0]; 

wire [data_width-1:0] dpo;
wire  [data_width-1:0] di;   
wire  [addr_width-1:0] a;   
wire  [addr_width-1:0] dpra;   
 
  always @(posedge clk) begin   
    if (we)   
      ram[a] <= di;   
  end   

  assign dpo = ram[dpra];   
endmodule 



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\timescale.v"































































`timescale 1ns/10ps


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_debug_if.v"






















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 87 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_debug_if.v"



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 90 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_debug_if.v"


module uart_debug_if (

wb_dat32_o, 

wb_adr_i, ier, iir, fcr, mcr, lcr, msr, 
lsr, rf_count, tf_count, tstate, rstate
) ;

input [ 5-1:0] 		wb_adr_i;
output [31:0] 							wb_dat32_o;
input [3:0] 							ier;
input [3:0] 							iir;
input [1:0] 							fcr;  
input [4:0] 							mcr;
input [7:0] 							lcr;
input [7:0] 							msr;
input [7:0] 							lsr;
input [ 5-1:0] rf_count;
input [ 5-1:0] tf_count;
input [2:0] 							tstate;
input [3:0] 							rstate;


wire [ 5-1:0] 		wb_adr_i;
reg [31:0] 								wb_dat32_o;

always @(fcr or ier or iir or lcr or lsr or mcr or msr
			or rf_count or rstate or tf_count or tstate or wb_adr_i)
	case (wb_adr_i)
		                      
		5'b01000: wb_dat32_o = {msr,lcr,iir,ier,lsr};
		               
		5'b01100: wb_dat32_o = {8'b0, fcr,mcr, rf_count, rstate, tf_count, tstate};
		default: wb_dat32_o = 0;
	endcase 

endmodule 



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 











































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_receiver.v"



































































































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 196 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_receiver.v"



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 199 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_receiver.v"


module uart_receiver (clk, wb_rst_i, lcr, rf_pop, srx_pad_i, enable, 
	counter_t, rf_count, rf_data_out, rf_error_bit, rf_overrun, rx_reset, lsr_mask, rstate, rf_push_pulse);

input				clk;
input				wb_rst_i;
input	[7:0]	lcr;
input				rf_pop;
input				srx_pad_i;
input				enable;
input				rx_reset;
input       lsr_mask;

output	[9:0]			counter_t;
output	[ 5-1:0]	rf_count;
output	[ 11-1:0]	rf_data_out;
output				rf_overrun;
output				rf_error_bit;
output [3:0] 		rstate;
output 				rf_push_pulse;

reg	[3:0]	rstate;
reg	[3:0]	rcounter16;
reg	[2:0]	rbit_counter;
reg	[7:0]	rshift;			
reg		rparity;		
reg		rparity_error;
reg		rframing_error;		
reg		rbit_in;
reg		rparity_xor;
reg	[7:0]	counter_b;	
reg   rf_push_q;


reg	[ 11-1:0]	rf_data_in;
wire	[ 11-1:0]	rf_data_out;
wire      rf_push_pulse;
reg				rf_push;
wire				rf_pop;
wire				rf_overrun;
wire	[ 5-1:0]	rf_count;
wire				rf_error_bit; 
wire 				break_error = (counter_b == 0);


uart_rfifo #( 11) fifo_rx(
	.clk(		clk		), 
	.wb_rst_i(	wb_rst_i	),
	.data_in(	rf_data_in	),
	.data_out(	rf_data_out	),
	.push(		rf_push_pulse		),
	.pop(		rf_pop		),
	.overrun(	rf_overrun	),
	.count(		rf_count	),
	.error_bit(	rf_error_bit	),
	.fifo_reset(	rx_reset	),
	.reset_status(lsr_mask)
);

wire 		rcounter16_eq_7 = (rcounter16 == 4'd7);
wire		rcounter16_eq_0 = (rcounter16 == 4'd0);
wire		rcounter16_eq_1 = (rcounter16 == 4'd1);

wire [3:0] rcounter16_minus_1 = rcounter16 - 1'b1;

parameter  sr_idle 					= 4'd0;
parameter  sr_rec_start 			= 4'd1;
parameter  sr_rec_bit 				= 4'd2;
parameter  sr_rec_parity			= 4'd3;
parameter  sr_rec_stop 				= 4'd4;
parameter  sr_check_parity 		= 4'd5;
parameter  sr_rec_prepare 			= 4'd6;
parameter  sr_end_bit				= 4'd7;
parameter  sr_ca_lc_parity	      = 4'd8;
parameter  sr_wait1 					= 4'd9;
parameter  sr_push 					= 4'd10;


always @(posedge clk or posedge wb_rst_i)
begin
  if (wb_rst_i)
  begin
     rstate 			<= #1 sr_idle;
	  rbit_in 				<= #1 1'b0;
	  rcounter16 			<= #1 0;
	  rbit_counter 		<= #1 0;
	  rparity_xor 		<= #1 1'b0;
	  rframing_error 	<= #1 1'b0;
	  rparity_error 		<= #1 1'b0;
	  rparity 				<= #1 1'b0;
	  rshift 				<= #1 0;
	  rf_push 				<= #1 1'b0;
	  rf_data_in 			<= #1 0;
  end
  else
  if (enable)
  begin
	case (rstate)
	sr_idle : begin
			rf_push 			  <= #1 1'b0;
			rf_data_in 	  <= #1 0;
			rcounter16 	  <= #1 4'b1110;
			if (srx_pad_i==1'b0 & ~break_error)   
			begin
				rstate 		  <= #1 sr_rec_start;
			end
		end
	sr_rec_start :	begin
  			rf_push 			  <= #1 1'b0;
				if (rcounter16_eq_7)    
					if (srx_pad_i==1'b1)   
						rstate <= #1 sr_idle;
					else            
						rstate <= #1 sr_rec_prepare;
				rcounter16 <= #1 rcounter16_minus_1;
			end
	sr_rec_prepare:begin
				case (lcr[1:0])  
				2'b00 : rbit_counter <= #1 3'b100;
				2'b01 : rbit_counter <= #1 3'b101;
				2'b10 : rbit_counter <= #1 3'b110;
				2'b11 : rbit_counter <= #1 3'b111;
				endcase
				if (rcounter16_eq_0)
				begin
					rstate		<= #1 sr_rec_bit;
					rcounter16	<= #1 4'b1110;
					rshift		<= #1 0;
				end
				else
					rstate <= #1 sr_rec_prepare;
				rcounter16 <= #1 rcounter16_minus_1;
			end
	sr_rec_bit :	begin
				if (rcounter16_eq_0)
					rstate <= #1 sr_end_bit;
				if (rcounter16_eq_7) 
					case (lcr[1:0])  
					2'b00 : rshift[4:0]  <= #1 {srx_pad_i, rshift[4:1]};
					2'b01 : rshift[5:0]  <= #1 {srx_pad_i, rshift[5:1]};
					2'b10 : rshift[6:0]  <= #1 {srx_pad_i, rshift[6:1]};
					2'b11 : rshift[7:0]  <= #1 {srx_pad_i, rshift[7:1]};
					endcase
				rcounter16 <= #1 rcounter16_minus_1;
			end
	sr_end_bit :   begin
				if (rbit_counter==3'b0) 
					if (lcr[ 3]) 
						rstate <= #1 sr_rec_parity;
					else
					begin
						rstate <= #1 sr_rec_stop;
						rparity_error <= #1 1'b0;  
					end
				else		
				begin
					rstate <= #1 sr_rec_bit;
					rbit_counter <= #1 rbit_counter - 1'b1;
				end
				rcounter16 <= #1 4'b1110;
			end
	sr_rec_parity: begin
				if (rcounter16_eq_7)	
				begin
					rparity <= #1 srx_pad_i;
					rstate <= #1 sr_ca_lc_parity;
				end
				rcounter16 <= #1 rcounter16_minus_1;
			end
	sr_ca_lc_parity : begin    
				rcounter16  <= #1 rcounter16_minus_1;
				rparity_xor <= #1 ^{rshift,rparity}; 
				rstate      <= #1 sr_check_parity;
			  end
	sr_check_parity: begin	  
				case ({lcr[ 4],lcr[ 5]})
					2'b00: rparity_error <= #1  rparity_xor == 0;  
					2'b01: rparity_error <= #1 ~rparity;      
					2'b10: rparity_error <= #1  rparity_xor == 1;   
					2'b11: rparity_error <= #1  rparity;	  
				endcase
				rcounter16 <= #1 rcounter16_minus_1;
				rstate <= #1 sr_wait1;
			  end
	sr_wait1 :	if (rcounter16_eq_0)
			begin
				rstate <= #1 sr_rec_stop;
				rcounter16 <= #1 4'b1110;
			end
			else
				rcounter16 <= #1 rcounter16_minus_1;
	sr_rec_stop :	begin
				if (rcounter16_eq_7)	
				begin
					rframing_error <= #1 !srx_pad_i; 
					rstate <= #1 sr_push;
				end
				rcounter16 <= #1 rcounter16_minus_1;
			end
	sr_push :	begin


        if(srx_pad_i | break_error)
          begin
            if(break_error)
        		  rf_data_in 	<= #1 {8'b0, 3'b100}; 
            else
        			rf_data_in  <= #1 {rshift, 1'b0, rparity_error, rframing_error};
      		  rf_push 		  <= #1 1'b1;
    				rstate        <= #1 sr_idle;
          end
        else if(~rframing_error)  
          begin
       			rf_data_in  <= #1 {rshift, 1'b0, rparity_error, rframing_error};
      		  rf_push 		  <= #1 1'b1;
      			rcounter16 	  <= #1 4'b1110;
    				rstate 		  <= #1 sr_rec_start;
          end
                      
			end
	default : rstate <= #1 sr_idle;
	endcase
  end  
end 

always @ (posedge clk or posedge wb_rst_i)
begin
  if(wb_rst_i)
    rf_push_q <= 0;
  else
    rf_push_q <= #1 rf_push;
end

assign rf_push_pulse = rf_push & ~rf_push_q;

  




reg 	[9:0]	toc_value; 

always @(lcr)
	case (lcr[3:0])
		4'b0000										: toc_value = 447; 
		4'b0100										: toc_value = 479; 
		4'b0001,	4'b1000							: toc_value = 511; 
		4'b1100										: toc_value = 543; 
		4'b0010, 4'b0101, 4'b1001				: toc_value = 575; 
		4'b0011, 4'b0110, 4'b1010, 4'b1101	: toc_value = 639; 
		4'b0111, 4'b1011, 4'b1110				: toc_value = 703; 
		4'b1111										: toc_value = 767; 
	endcase 

wire [7:0] 	brc_value; 
assign 		brc_value = toc_value[9:2]; 

always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
		counter_b <= #1 8'd159;
	else
	if (srx_pad_i)
		counter_b <= #1 brc_value; 
	else
	if(enable & counter_b != 8'b0)            
		counter_b <= #1 counter_b - 1;  
end 



reg	[9:0]	counter_t;	

always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
		counter_t <= #1 10'd639; 
	else
		if(rf_push_pulse || rf_pop || rf_count == 0) 
			counter_t <= #1 toc_value;
		else
		if (enable && counter_t != 10'b0)  
			counter_t <= #1 counter_t - 1;		
end
	
endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_regs.v"


































































































































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 227 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_regs.v"



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 230 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_regs.v"





module uart_regs (clk,
	wb_rst_i, wb_addr_i, wb_dat_i, wb_dat_o, wb_we_i, wb_re_i, 


	modem_inputs,
	stx_pad_o, srx_pad_i,




ier, iir, fcr, mcr, lcr, msr, lsr, rf_count, tf_count, tstate, rstate,
				
	rts_pad_o, dtr_pad_o, int_o




	);

input 									clk;
input 									wb_rst_i;
input [ 5-1:0] 		wb_addr_i;
input [7:0] 							wb_dat_i;
output [7:0] 							wb_dat_o;
input 									wb_we_i;
input 									wb_re_i;

output 									stx_pad_o;
input 									srx_pad_i;

input [3:0] 							modem_inputs;
output 									rts_pad_o;
output 									dtr_pad_o;
output 									int_o;







output [3:0]							ier;
output [3:0]							iir;
output [1:0]							fcr;  
output [4:0]							mcr;
output [7:0]							lcr;
output [7:0]							msr;
output [7:0] 							lsr;
output [ 5-1:0] 	rf_count;
output [ 5-1:0] 	tf_count;
output [2:0] 							tstate;
output [3:0] 							rstate;



wire [3:0] 								modem_inputs;
reg 										enable;





wire 										stx_pad_o;		
wire 										srx_pad_i;
wire 										srx_pad;

reg [7:0] 								wb_dat_o;

wire [ 5-1:0] 		wb_addr_i;
wire [7:0] 								wb_dat_i;


reg [3:0] 								ier;
reg [3:0] 								iir;
reg [1:0] 								fcr;  
reg [4:0] 								mcr;
reg [7:0] 								lcr;
reg [7:0] 								msr;
reg [15:0] 								dl;  
reg [7:0] 								scratch; 
reg 										start_dlc; 
reg 										lsr_mask_d; 
reg 										msi_reset; 

reg [15:0] 								dlc;  
reg 										int_o;

reg [3:0] 								trigger_level; 
reg 										rx_reset;
reg 										tx_reset;

wire 										dlab;			   
wire 										cts_pad_i, dsr_pad_i, ri_pad_i, dcd_pad_i; 
wire 										loopback;		   
wire 										cts, dsr, ri, dcd;	   
wire                    cts_c, dsr_c, ri_c, dcd_c; 
wire 										rts_pad_o, dtr_pad_o;		   


wire [7:0] 								lsr;
wire 										lsr0, lsr1, lsr2, lsr3, lsr4, lsr5, lsr6, lsr7;
reg										lsr0r, lsr1r, lsr2r, lsr3r, lsr4r, lsr5r, lsr6r, lsr7r;
wire 										lsr_mask; 





assign 									lsr[7:0] = { lsr7r, lsr6r, lsr5r, lsr4r, lsr3r, lsr2r, lsr1r, lsr0r };

assign 									{cts_pad_i, dsr_pad_i, ri_pad_i, dcd_pad_i} = modem_inputs;
assign 									{cts, dsr, ri, dcd} = ~{cts_pad_i,dsr_pad_i,ri_pad_i,dcd_pad_i};

assign                  {cts_c, dsr_c, ri_c, dcd_c} = loopback ? {mcr[ 1],mcr[ 0],mcr[ 2],mcr[ 3]}
                                                               : {cts_pad_i,dsr_pad_i,ri_pad_i,dcd_pad_i};

assign 									dlab = lcr[ 7];
assign 									loopback = mcr[4];


assign 									rts_pad_o = mcr[ 1];
assign 									dtr_pad_o = mcr[ 0];


wire 										rls_int;  
wire 										rda_int;  
wire 										ti_int;   
wire										thre_int; 
wire 										ms_int;   


reg 										tf_push;
reg 										rf_pop;
wire [ 11-1:0] 	rf_data_out;
wire 										rf_error_bit; 
wire [ 5-1:0] 	rf_count;
wire [ 5-1:0] 	tf_count;
wire [2:0] 								tstate;
wire [3:0] 								rstate;
wire [9:0] 								counter_t;

wire                      thre_set_en; 
reg  [7:0]                block_cnt;   
reg  [7:0]                block_value; 


wire serial_out;

uart_transmitter transmitter(clk, wb_rst_i, lcr, tf_push, wb_dat_i, enable, serial_out, tstate, tf_count, tx_reset, lsr_mask);

  
  uart_sync_flops    i_uart_sync_flops
  (
    .rst_i           (wb_rst_i),
    .clk_i           (clk),
    .stage1_rst_i    (1'b0),
    .stage1_clk_en_i (1'b1),
    .async_dat_i     (srx_pad_i),
    .sync_dat_o      (srx_pad)
  );
  defparam i_uart_sync_flops.width      = 1;
  defparam i_uart_sync_flops.init_value = 1'b1;


wire serial_in = loopback ? serial_out : srx_pad;
assign stx_pad_o = loopback ? 1'b1 : serial_out;


uart_receiver receiver(clk, wb_rst_i, lcr, rf_pop, serial_in, enable, 
	counter_t, rf_count, rf_data_out, rf_error_bit, rf_overrun, rx_reset, lsr_mask, rstate, rf_push_pulse);



always @(dl or dlab or ier or iir or scratch
			or lcr or lsr or msr or rf_data_out or wb_addr_i or wb_re_i)   
begin
	case (wb_addr_i)
		  5 'd0   : wb_dat_o = dlab ? dl[ 7 : 0] : rf_data_out[10:3];
		  5 'd1	: wb_dat_o = dlab ? dl[ 15 : 8] : ier;
		  5 'd2	: wb_dat_o = {4'b1100,iir};
		  5 'd3	: wb_dat_o = lcr;
		  5 'd5	: wb_dat_o = lsr;
		  5 'd6	: wb_dat_o = msr;
		  5 'd7	: wb_dat_o = scratch;
		default:  wb_dat_o = 8'b0; 
	endcase 
end 



always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
		rf_pop <= #1 0; 
	else
	if (rf_pop)	
		rf_pop <= #1 0;
	else
	if (wb_re_i && wb_addr_i ==   5 'd0 && !dlab)
		rf_pop <= #1 1; 
end

wire 	lsr_mask_condition;
wire 	iir_read;
wire  msr_read;
wire	fifo_read;
wire	fifo_write;

assign lsr_mask_condition = (wb_re_i && wb_addr_i ==   5 'd5 && !dlab);
assign iir_read = (wb_re_i && wb_addr_i ==   5 'd2 && !dlab);
assign msr_read = (wb_re_i && wb_addr_i ==   5 'd6 && !dlab);
assign fifo_read = (wb_re_i && wb_addr_i ==   5 'd0 && !dlab);
assign fifo_write = (wb_we_i && wb_addr_i ==   5 'd0 && !dlab);


always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
		lsr_mask_d <= #1 0;
	else 
		lsr_mask_d <= #1 lsr_mask_condition;
end


assign lsr_mask = lsr_mask_condition && ~lsr_mask_d;


always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
		msi_reset <= #1 1;
	else
	if (msi_reset)
		msi_reset <= #1 0;
	else
	if (msr_read)
		msi_reset <= #1 1; 
end






always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i)
		lcr <= #1 8'b00000011; 
	else
	if (wb_we_i && wb_addr_i==  5 'd3)
		lcr <= #1 wb_dat_i;


always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i)
	begin
		ier <= #1 4'b0000; 
		dl[ 15 : 8] <= #1 8'b0;
	end
	else
	if (wb_we_i && wb_addr_i==  5 'd1)
		if (dlab)
		begin
			dl[ 15 : 8] <= #1 wb_dat_i;
		end
		else
			ier <= #1 wb_dat_i[3:0]; 



always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) begin
		fcr <= #1 2'b11; 
		rx_reset <= #1 0;
		tx_reset <= #1 0;
	end else
	if (wb_we_i && wb_addr_i==  5 'd2) begin
		fcr <= #1 wb_dat_i[7:6];
		rx_reset <= #1 wb_dat_i[1];
		tx_reset <= #1 wb_dat_i[2];
	end else begin
		rx_reset <= #1 0;
		tx_reset <= #1 0;
	end


always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i)
		mcr <= #1 5'b0; 
	else
	if (wb_we_i && wb_addr_i==  5 'd4)
			mcr <= #1 wb_dat_i[4:0];



always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i)
		scratch <= #1 0; 
	else
	if (wb_we_i && wb_addr_i==  5 'd7)
		scratch <= #1 wb_dat_i;


always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i)
	begin
		dl[ 7 : 0]  <= #1 8'b0;
		tf_push   <= #1 1'b0;
		start_dlc <= #1 1'b0;
	end
	else
	if (wb_we_i && wb_addr_i==  5 'd0)
		if (dlab)
		begin
			dl[ 7 : 0] <= #1 wb_dat_i;
			start_dlc <= #1 1'b1; 
			tf_push <= #1 1'b0;
		end
		else
		begin
			tf_push   <= #1 1'b1;
			start_dlc <= #1 1'b0;
		end 
	else
	begin
		start_dlc <= #1 1'b0;
		tf_push   <= #1 1'b0;
	end 


always @(fcr)
	case (fcr[ 1 : 0])
		2'b00 : trigger_level = 1;
		2'b01 : trigger_level = 4;
		2'b10 : trigger_level = 8;
		2'b11 : trigger_level = 14;
	endcase 
	





reg [3:0] delayed_modem_signals;
always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
	  begin
  		msr <= #1 0;
	  	delayed_modem_signals[3:0] <= #1 0;
	  end
	else begin
		msr[ 3: 0] <= #1 msi_reset ? 4'b0 :
			msr[ 3: 0] | ({dcd, ri, dsr, cts} ^ delayed_modem_signals[3:0]);
		msr[ 7: 4] <= #1 {dcd_c, ri_c, dsr_c, cts_c};
		delayed_modem_signals[3:0] <= #1 {dcd, ri, dsr, cts};
	end
end





assign lsr0 = (rf_count==0 && rf_push_pulse);  
assign lsr1 = rf_overrun;     
assign lsr2 = rf_data_out[1]; 
assign lsr3 = rf_data_out[0]; 
assign lsr4 = rf_data_out[2]; 
assign lsr5 = (tf_count==5'b0 && thre_set_en);  
assign lsr6 = (tf_count==5'b0 && thre_set_en && (tstate ==  0)); 
assign lsr7 = rf_error_bit | rf_overrun;


reg 	 lsr0_d;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr0_d <= #1 0;
	else lsr0_d <= #1 lsr0;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr0r <= #1 0;
	else lsr0r <= #1 (rf_count==1 && rf_pop && !rf_push_pulse || rx_reset) ? 0 : 
					  lsr0r || (lsr0 && ~lsr0_d); 


reg lsr1_d; 

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr1_d <= #1 0;
	else lsr1_d <= #1 lsr1;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr1r <= #1 0;
	else	lsr1r <= #1	lsr_mask ? 0 : lsr1r || (lsr1 && ~lsr1_d); 


reg lsr2_d; 

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr2_d <= #1 0;
	else lsr2_d <= #1 lsr2;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr2r <= #1 0;
	else lsr2r <= #1 lsr_mask ? 0 : lsr2r || (lsr2 && ~lsr2_d); 


reg lsr3_d; 

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr3_d <= #1 0;
	else lsr3_d <= #1 lsr3;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr3r <= #1 0;
	else lsr3r <= #1 lsr_mask ? 0 : lsr3r || (lsr3 && ~lsr3_d); 


reg lsr4_d; 

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr4_d <= #1 0;
	else lsr4_d <= #1 lsr4;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr4r <= #1 0;
	else lsr4r <= #1 lsr_mask ? 0 : lsr4r || (lsr4 && ~lsr4_d);


reg lsr5_d;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr5_d <= #1 1;
	else lsr5_d <= #1 lsr5;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr5r <= #1 1;
	else lsr5r <= #1 (fifo_write) ? 0 :  lsr5r || (lsr5 && ~lsr5_d);


reg lsr6_d;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr6_d <= #1 1;
	else lsr6_d <= #1 lsr6;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr6r <= #1 1;
	else lsr6r <= #1 (fifo_write) ? 0 : lsr6r || (lsr6 && ~lsr6_d);


reg lsr7_d;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr7_d <= #1 0;
	else lsr7_d <= #1 lsr7;

always @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) lsr7r <= #1 0;
	else lsr7r <= #1 lsr_mask ? 0 : lsr7r || (lsr7 && ~lsr7_d);


always @(posedge clk or posedge wb_rst_i) 
begin
	if (wb_rst_i)
		dlc <= #1 0;
	else
		if (start_dlc | ~ (|dlc))
  			dlc <= #1 dl - 1;               
		else
			dlc <= #1 dlc - 1;              
end


always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
		enable <= #1 1'b0;
	else
		if (|dl & ~(|dlc))     
			enable <= #1 1'b1;
		else
			enable <= #1 1'b0;
end


always @(lcr)
  case (lcr[3:0])
    4'b0000                             : block_value =  95; 
    4'b0100                             : block_value = 103; 
    4'b0001, 4'b1000                    : block_value = 111; 
    4'b1100                             : block_value = 119; 
    4'b0010, 4'b0101, 4'b1001           : block_value = 127; 
    4'b0011, 4'b0110, 4'b1010, 4'b1101  : block_value = 143; 
    4'b0111, 4'b1011, 4'b1110           : block_value = 159; 
    4'b1111                             : block_value = 175; 
  endcase 


always @(posedge clk or posedge wb_rst_i)
begin
  if (wb_rst_i)
    block_cnt <= #1 8'd0;
  else
  if(lsr5r & fifo_write)  
    block_cnt <= #1 block_value;
  else
  if (enable & block_cnt != 8'b0)  
    block_cnt <= #1 block_cnt - 1;  
end 


assign thre_set_en = ~(|block_cnt);






assign rls_int  = ier[ 2] && (lsr[ 1] || lsr[ 2] || lsr[ 3] || lsr[ 4]);
assign rda_int  = ier[ 0] && (rf_count >= {1'b0,trigger_level});
assign thre_int = ier[ 1] && lsr[ 5];
assign ms_int   = ier[ 3] && (| msr[3:0]);
assign ti_int   = ier[ 0] && (counter_t == 10'b0) && (|rf_count);

reg 	 rls_int_d;
reg 	 thre_int_d;
reg 	 ms_int_d;
reg 	 ti_int_d;
reg 	 rda_int_d;


always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) rls_int_d <= #1 0;
	else rls_int_d <= #1 rls_int;

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) rda_int_d <= #1 0;
	else rda_int_d <= #1 rda_int;

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) thre_int_d <= #1 0;
	else thre_int_d <= #1 thre_int;

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) ms_int_d <= #1 0;
	else ms_int_d <= #1 ms_int;

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) ti_int_d <= #1 0;
	else ti_int_d <= #1 ti_int;



wire 	 rls_int_rise;
wire 	 thre_int_rise;
wire 	 ms_int_rise;
wire 	 ti_int_rise;
wire 	 rda_int_rise;

assign rda_int_rise    = rda_int & ~rda_int_d;
assign rls_int_rise 	  = rls_int & ~rls_int_d;
assign thre_int_rise   = thre_int & ~thre_int_d;
assign ms_int_rise 	  = ms_int & ~ms_int_d;
assign ti_int_rise 	  = ti_int & ~ti_int_d;


reg 	rls_int_pnd;
reg	rda_int_pnd;
reg 	thre_int_pnd;
reg 	ms_int_pnd;
reg 	ti_int_pnd;


always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) rls_int_pnd <= #1 0; 
	else 
		rls_int_pnd <= #1 lsr_mask ? 0 :  						
							rls_int_rise ? 1 :						
							rls_int_pnd && ier[ 2];	

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) rda_int_pnd <= #1 0; 
	else 
		rda_int_pnd <= #1 ((rf_count == {1'b0,trigger_level}) && fifo_read) ? 0 :  	
							rda_int_rise ? 1 :						
							rda_int_pnd && ier[ 0];	

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) thre_int_pnd <= #1 0; 
	else 
		thre_int_pnd <= #1 fifo_write || (iir_read & ~iir[ 0] & iir[ 3 : 1] ==  3'b001)? 0 : 
							thre_int_rise ? 1 :
							thre_int_pnd && ier[ 1];

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) ms_int_pnd <= #1 0; 
	else 
		ms_int_pnd <= #1 msr_read ? 0 : 
							ms_int_rise ? 1 :
							ms_int_pnd && ier[ 3];

always  @(posedge clk or posedge wb_rst_i)
	if (wb_rst_i) ti_int_pnd <= #1 0; 
	else 
		ti_int_pnd <= #1 fifo_read ? 0 : 
							ti_int_rise ? 1 :
							ti_int_pnd && ier[ 0];



always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)	
		int_o <= #1 1'b0;
	else
		int_o <= #1 
					rls_int_pnd		?	~lsr_mask					:
					rda_int_pnd		? 1								:
					ti_int_pnd		? ~fifo_read					:
					thre_int_pnd	? !(fifo_write & iir_read) :
					ms_int_pnd		? ~msr_read						:
					0;	
end



always @(posedge clk or posedge wb_rst_i)
begin
	if (wb_rst_i)
		iir <= #1 1;
	else
	if (rls_int_pnd)  
	begin
		iir[ 3 : 1] <= #1  3'b011;	
		iir[ 0] <= #1 1'b0;		
	end else 
	if (rda_int)
	begin
		iir[ 3 : 1] <= #1  3'b010;
		iir[ 0] <= #1 1'b0;
	end
	else if (ti_int_pnd)
	begin
		iir[ 3 : 1] <= #1  3'b110;
		iir[ 0] <= #1 1'b0;
	end
	else if (thre_int_pnd)
	begin
		iir[ 3 : 1] <= #1  3'b001;
		iir[ 0] <= #1 1'b0;
	end
	else if (ms_int_pnd)
	begin
		iir[ 3 : 1] <= #1  3'b000;
		iir[ 0] <= #1 1'b0;
	end else	
	begin
		iir[ 3 : 1] <= #1 0;
		iir[ 0] <= #1 1'b1;
	end
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_rfifo.v"



















































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 148 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_rfifo.v"



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 151 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_rfifo.v"


module uart_rfifo (clk, 
	wb_rst_i, data_in, data_out,

	push, 
	pop,   

	overrun,
	count,
	error_bit,
	fifo_reset,
	reset_status
	);



parameter fifo_width =  8;
parameter fifo_depth =  16;
parameter fifo_pointer_w =  4;
parameter fifo_counter_w =  5;

input				clk;
input				wb_rst_i;
input				push;
input				pop;
input	[fifo_width-1:0]	data_in;
input				fifo_reset;
input       reset_status;

output	[fifo_width-1:0]	data_out;
output				overrun;
output	[fifo_counter_w-1:0]	count;
output				error_bit;

wire	[fifo_width-1:0]	data_out;
wire [7:0] data8_out;

reg	[2:0]	fifo[fifo_depth-1:0];


reg	[fifo_pointer_w-1:0]	top;
reg	[fifo_pointer_w-1:0]	bottom;

reg	[fifo_counter_w-1:0]	count;
reg				overrun;

wire [fifo_pointer_w-1:0] top_plus_1 = top + 1'b1;

raminfr #(fifo_pointer_w,8,fifo_depth) rfifo  
        (.clk(clk), 
			.we(push), 
			.a(top), 
			.dpra(bottom), 
			.di(data_in[fifo_width-1:fifo_width-8]), 
			.dpo(data8_out)
		); 

always @(posedge clk or posedge wb_rst_i) 
begin
	if (wb_rst_i)
	begin
		top		<= #1 0;
		bottom		<= #1 1'b0;
		count		<= #1 0;
		fifo[0] <= #1 0;
		fifo[1] <= #1 0;
		fifo[2] <= #1 0;
		fifo[3] <= #1 0;
		fifo[4] <= #1 0;
		fifo[5] <= #1 0;
		fifo[6] <= #1 0;
		fifo[7] <= #1 0;
		fifo[8] <= #1 0;
		fifo[9] <= #1 0;
		fifo[10] <= #1 0;
		fifo[11] <= #1 0;
		fifo[12] <= #1 0;
		fifo[13] <= #1 0;
		fifo[14] <= #1 0;
		fifo[15] <= #1 0;
	end
	else
	if (fifo_reset) begin
		top		<= #1 0;
		bottom		<= #1 1'b0;
		count		<= #1 0;
		fifo[0] <= #1 0;
		fifo[1] <= #1 0;
		fifo[2] <= #1 0;
		fifo[3] <= #1 0;
		fifo[4] <= #1 0;
		fifo[5] <= #1 0;
		fifo[6] <= #1 0;
		fifo[7] <= #1 0;
		fifo[8] <= #1 0;
		fifo[9] <= #1 0;
		fifo[10] <= #1 0;
		fifo[11] <= #1 0;
		fifo[12] <= #1 0;
		fifo[13] <= #1 0;
		fifo[14] <= #1 0;
		fifo[15] <= #1 0;
	end
  else
	begin
		case ({push, pop})
		2'b10 : if (count<fifo_depth)  
			begin
				top       <= #1 top_plus_1;
				fifo[top] <= #1 data_in[2:0];
				count     <= #1 count + 1'b1;
			end
		2'b01 : if(count>0)
			begin
        fifo[bottom] <= #1 0;
				bottom   <= #1 bottom + 1'b1;
				count	 <= #1 count - 1'b1;
			end
		2'b11 : begin
				bottom   <= #1 bottom + 1'b1;
				top       <= #1 top_plus_1;
				fifo[top] <= #1 data_in[2:0];
		        end
    default: ;
		endcase
	end
end   

always @(posedge clk or posedge wb_rst_i) 
begin
  if (wb_rst_i)
    overrun   <= #1 1'b0;
  else
  if(fifo_reset | reset_status) 
    overrun   <= #1 1'b0;
  else
  if(push & ~pop & (count==fifo_depth))
    overrun   <= #1 1'b1;
end   



assign data_out = {data8_out,fifo[bottom]};




wire	[2:0]	word0 = fifo[0];
wire	[2:0]	word1 = fifo[1];
wire	[2:0]	word2 = fifo[2];
wire	[2:0]	word3 = fifo[3];
wire	[2:0]	word4 = fifo[4];
wire	[2:0]	word5 = fifo[5];
wire	[2:0]	word6 = fifo[6];
wire	[2:0]	word7 = fifo[7];

wire	[2:0]	word8 = fifo[8];
wire	[2:0]	word9 = fifo[9];
wire	[2:0]	word10 = fifo[10];
wire	[2:0]	word11 = fifo[11];
wire	[2:0]	word12 = fifo[12];
wire	[2:0]	word13 = fifo[13];
wire	[2:0]	word14 = fifo[14];
wire	[2:0]	word15 = fifo[15];


assign	error_bit = |(word0[2:0]  | word1[2:0]  | word2[2:0]  | word3[2:0]  |
            		      word4[2:0]  | word5[2:0]  | word6[2:0]  | word7[2:0]  |
            		      word8[2:0]  | word9[2:0]  | word10[2:0] | word11[2:0] |
            		      word12[2:0] | word13[2:0] | word14[2:0] | word15[2:0] );

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_sync_flops.v"






































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 71 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_sync_flops.v"



module uart_sync_flops
(
  
  rst_i,
  clk_i,
  stage1_rst_i,
  stage1_clk_en_i,
  async_dat_i,
  sync_dat_o
);

parameter Tp            = 1;
parameter width         = 1;
parameter init_value    = 1'b0;

input                           rst_i;                  
input                           clk_i;                  
input                           stage1_rst_i;           
input                           stage1_clk_en_i;        
input   [width-1:0]             async_dat_i;            
output  [width-1:0]             sync_dat_o;             






reg     [width-1:0]             sync_dat_o;
reg     [width-1:0]             flop_0;



always @ (posedge clk_i or posedge rst_i)
begin
    if (rst_i)
        flop_0 <= #Tp {width{init_value}};
    else
        flop_0 <= #Tp async_dat_i;    
end


always @ (posedge clk_i or posedge rst_i)
begin
    if (rst_i)
        sync_dat_o <= #Tp {width{init_value}};
    else if (stage1_rst_i)
        sync_dat_o <= #Tp {width{init_value}};
    else if (stage1_clk_en_i)
        sync_dat_o <= #Tp flop_0;       
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_tfifo.v"













































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 142 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_tfifo.v"



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 145 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_tfifo.v"


module uart_tfifo (clk, 
	wb_rst_i, data_in, data_out,

	push, 
	pop,   

	overrun,
	count,
	fifo_reset,
	reset_status
	);



parameter fifo_width =  8;
parameter fifo_depth =  16;
parameter fifo_pointer_w =  4;
parameter fifo_counter_w =  5;

input				clk;
input				wb_rst_i;
input				push;
input				pop;
input	[fifo_width-1:0]	data_in;
input				fifo_reset;
input       reset_status;

output	[fifo_width-1:0]	data_out;
output				overrun;
output	[fifo_counter_w-1:0]	count;

wire	[fifo_width-1:0]	data_out;


reg	[fifo_pointer_w-1:0]	top;
reg	[fifo_pointer_w-1:0]	bottom;

reg	[fifo_counter_w-1:0]	count;
reg				overrun;
wire [fifo_pointer_w-1:0] top_plus_1 = top + 1'b1;

raminfr #(fifo_pointer_w,fifo_width,fifo_depth) tfifo  
        (.clk(clk), 
			.we(push), 
			.a(top), 
			.dpra(bottom), 
			.di(data_in), 
			.dpo(data_out)
		); 


always @(posedge clk or posedge wb_rst_i) 
begin
	if (wb_rst_i)
	begin
		top		<= #1 0;
		bottom		<= #1 1'b0;
		count		<= #1 0;
	end
	else
	if (fifo_reset) begin
		top		<= #1 0;
		bottom		<= #1 1'b0;
		count		<= #1 0;
	end
  else
	begin
		case ({push, pop})
		2'b10 : if (count<fifo_depth)  
			begin
				top       <= #1 top_plus_1;
				count     <= #1 count + 1'b1;
			end
		2'b01 : if(count>0)
			begin
				bottom   <= #1 bottom + 1'b1;
				count	 <= #1 count - 1'b1;
			end
		2'b11 : begin
				bottom   <= #1 bottom + 1'b1;
				top       <= #1 top_plus_1;
		        end
    default: ;
		endcase
	end
end   

always @(posedge clk or posedge wb_rst_i) 
begin
  if (wb_rst_i)
    overrun   <= #1 1'b0;
  else
  if(fifo_reset | reset_status) 
    overrun   <= #1 1'b0;
  else
  if(push & (count==fifo_depth))
    overrun   <= #1 1'b1;
end   

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_top.v"









































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 138 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_top.v"



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 141 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_top.v"


module uart_top	(
	wb_clk_i, 
	
	
	wb_rst_i, wb_adr_i, wb_dat_i, wb_dat_o, wb_we_i, wb_stb_i, wb_cyc_i, wb_ack_o, wb_sel_i,
	int_o, 

	
	
	stx_pad_o, srx_pad_i,

	
	rts_pad_o, cts_pad_i, dtr_pad_o, dsr_pad_i, ri_pad_i, dcd_pad_i



	);

parameter 							 uart_data_width =  32;
parameter 							 uart_addr_width =  5;

input 								 wb_clk_i;


input 								 wb_rst_i;
input [uart_addr_width-1:0] 	 wb_adr_i;
input [uart_data_width-1:0] 	 wb_dat_i;
output [uart_data_width-1:0] 	 wb_dat_o;
input 								 wb_we_i;
input 								 wb_stb_i;
input 								 wb_cyc_i;
input [3:0]							 wb_sel_i;
output 								 wb_ack_o;
output 								 int_o;


input 								 srx_pad_i;
output 								 stx_pad_o;
output 								 rts_pad_o;
input 								 cts_pad_i;
output 								 dtr_pad_o;
input 								 dsr_pad_i;
input 								 ri_pad_i;
input 								 dcd_pad_i;







wire 									 stx_pad_o;
wire 									 rts_pad_o;
wire 									 dtr_pad_o;

wire [uart_addr_width-1:0] 	 wb_adr_i;
wire [uart_data_width-1:0] 	 wb_dat_i;
wire [uart_data_width-1:0] 	 wb_dat_o;

wire [7:0] 							 wb_dat8_i; 
wire [7:0] 							 wb_dat8_o; 
wire [31:0] 						 wb_dat32_o; 
wire [3:0] 							 wb_sel_i;  
wire [uart_addr_width-1:0] 	 wb_adr_int;
wire 									 we_o;	
wire		          	     re_o;	







wire	[3:0] ier;
wire	[3:0] iir;
wire	[1:0] fcr;
wire	[4:0] mcr;
wire	[7:0] lcr;
wire	[7:0] msr;
wire	[7:0] lsr;
wire	[ 5-1:0] rf_count;
wire	[ 5-1:0] tf_count;
wire	[2:0] tstate;
wire	[3:0] rstate; 























uart_wb		wb_interface(
		.clk(		wb_clk_i		),
		.wb_rst_i(	wb_rst_i	),
	.wb_dat_i(wb_dat_i),
	.wb_dat_o(wb_dat_o),
	.wb_dat8_i(wb_dat8_i),
	.wb_dat8_o(wb_dat8_o),
	 .wb_sel_i(wb_sel_i),
	 .wb_dat32_o(wb_dat32_o),								 
		.wb_we_i(	wb_we_i		),
		.wb_stb_i(	wb_stb_i	),
		.wb_cyc_i(	wb_cyc_i	),
		.wb_ack_o(	wb_ack_o	),
	.wb_adr_i(wb_adr_i),
	.wb_adr_int(wb_adr_int),
		.we_o(		we_o		),
		.re_o(re_o)
		);



uart_regs	regs(
	.clk(		wb_clk_i		),
	.wb_rst_i(	wb_rst_i	),
	.wb_addr_i(	wb_adr_int	),
	.wb_dat_i(	wb_dat8_i	),
	.wb_dat_o(	wb_dat8_o	),
	.wb_we_i(	we_o		),
   .wb_re_i(re_o),
	.modem_inputs(	{cts_pad_i, dsr_pad_i,
	ri_pad_i,  dcd_pad_i}	),
	.stx_pad_o(		stx_pad_o		),
	.srx_pad_i(		srx_pad_i		),



.ier(ier), 
.iir(iir), 
.fcr(fcr), 
.mcr(mcr), 
.lcr(lcr), 
.msr(msr), 
.lsr(lsr), 
.rf_count(rf_count),
.tf_count(tf_count),
.tstate(tstate),
.rstate(rstate),
					  
	.rts_pad_o(		rts_pad_o		),
	.dtr_pad_o(		dtr_pad_o		),
	.int_o(		int_o		)




);



uart_debug_if dbg(
						
						.wb_dat32_o				 (wb_dat32_o[31:0]),
						
						.wb_adr_i				 (wb_adr_int[ 5-1:0]),
						.ier						 (ier[3:0]),
						.iir						 (iir[3:0]),
						.fcr						 (fcr[1:0]),
						.mcr						 (mcr[4:0]),
						.lcr						 (lcr[7:0]),
						.msr						 (msr[7:0]),
						.lsr						 (lsr[7:0]),
						.rf_count				 (rf_count[ 5-1:0]),
						.tf_count				 (tf_count[ 5-1:0]),
						.tstate					 (tstate[2:0]),
						.rstate					 (rstate[3:0]));
 

initial
begin
	


		$display("(%m) UART INFO: Data bus width is 32. Debug Interface present.\n");
	
	


		$display("(%m) UART INFO: Doesn't have baudrate output\n");
	
end

endmodule




`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_transmitter.v"























































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 152 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_transmitter.v"



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_defines.v"















































































































































 
 










































































































`line 155 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart16550\uart_transmitter.v"


module uart_transmitter (clk, wb_rst_i, lcr, tf_push, wb_dat_i, enable,	stx_pad_o, tstate, tf_count, tx_reset, lsr_mask);

input 										clk;
input 										wb_rst_i;
input [7:0] 								lcr;
input 										tf_push;
input [7:0] 								wb_dat_i;
input 										enable;
input 										tx_reset;
input 										lsr_mask; 
output 										stx_pad_o;
output [2:0] 								tstate;
output [ 5-1:0] 	tf_count;

reg [2:0] 									tstate;
reg [4:0] 									counter;
reg [2:0] 									bit_counter;   
reg [6:0] 									shift_out;	
reg 											stx_o_tmp;
reg 											parity_xor;  
reg 											tf_pop;
reg 											bit_out;




wire [ 8-1:0] 			tf_data_in;
wire [ 8-1:0] 			tf_data_out;
wire 											tf_push;
wire 											tf_overrun;
wire [ 5-1:0] 		tf_count;

assign 										tf_data_in = wb_dat_i;

uart_tfifo fifo_tx(	
	.clk(		clk		), 
	.wb_rst_i(	wb_rst_i	),
	.data_in(	tf_data_in	),
	.data_out(	tf_data_out	),
	.push(		tf_push		),
	.pop(		tf_pop		),
	.overrun(	tf_overrun	),
	.count(		tf_count	),
	.fifo_reset(	tx_reset	),
	.reset_status(lsr_mask)
);



parameter s_idle        = 3'd0;
parameter s_send_start  = 3'd1;
parameter s_send_byte   = 3'd2;
parameter s_send_parity = 3'd3;
parameter s_send_stop   = 3'd4;
parameter s_pop_byte    = 3'd5;

always @(posedge clk or posedge wb_rst_i)
begin
  if (wb_rst_i)
  begin
	tstate       <= #1 s_idle;
	stx_o_tmp       <= #1 1'b1;
	counter   <= #1 5'b0;
	shift_out   <= #1 7'b0;
	bit_out     <= #1 1'b0;
	parity_xor  <= #1 1'b0;
	tf_pop      <= #1 1'b0;
	bit_counter <= #1 3'b0;
  end
  else
  if (enable)
  begin
	case (tstate)
	s_idle	 :	if (~|tf_count) 
			begin
				tstate <= #1 s_idle;
				stx_o_tmp <= #1 1'b1;
			end
			else
			begin
				tf_pop <= #1 1'b0;
				stx_o_tmp  <= #1 1'b1;
				tstate  <= #1 s_pop_byte;
			end
	s_pop_byte :	begin
				tf_pop <= #1 1'b1;
				case (lcr[1:0])  
				2'b00 : begin
					bit_counter <= #1 3'b100;
					parity_xor  <= #1 ^tf_data_out[4:0];
				     end
				2'b01 : begin
					bit_counter <= #1 3'b101;
					parity_xor  <= #1 ^tf_data_out[5:0];
				     end
				2'b10 : begin
					bit_counter <= #1 3'b110;
					parity_xor  <= #1 ^tf_data_out[6:0];
				     end
				2'b11 : begin
					bit_counter <= #1 3'b111;
					parity_xor  <= #1 ^tf_data_out[7:0];
				     end
				endcase
				{shift_out[6:0], bit_out} <= #1 tf_data_out;
				tstate <= #1 s_send_start;
			end
	s_send_start :	begin
				tf_pop <= #1 1'b0;
				if (~|counter)
					counter <= #1 5'b01111;
				else
				if (counter == 5'b00001)
				begin
					counter <= #1 0;
					tstate <= #1 s_send_byte;
				end
				else
					counter <= #1 counter - 1'b1;
				stx_o_tmp <= #1 1'b0;
			end
	s_send_byte :	begin
				if (~|counter)
					counter <= #1 5'b01111;
				else
				if (counter == 5'b00001)
				begin
					if (bit_counter > 3'b0)
					begin
						bit_counter <= #1 bit_counter - 1'b1;
						{shift_out[5:0],bit_out  } <= #1 {shift_out[6:1], shift_out[0]};
						tstate <= #1 s_send_byte;
					end
					else   
					if (~lcr[ 3])
					begin
						tstate <= #1 s_send_stop;
					end
					else
					begin
						case ({lcr[ 4],lcr[ 5]})
						2'b00:	bit_out <= #1 ~parity_xor;
						2'b01:	bit_out <= #1 1'b1;
						2'b10:	bit_out <= #1 parity_xor;
						2'b11:	bit_out <= #1 1'b0;
						endcase
						tstate <= #1 s_send_parity;
					end
					counter <= #1 0;
				end
				else
					counter <= #1 counter - 1'b1;
				stx_o_tmp <= #1 bit_out; 
			end
	s_send_parity :	begin
				if (~|counter)
					counter <= #1 5'b01111;
				else
				if (counter == 5'b00001)
				begin
					counter <= #1 4'b0;
					tstate <= #1 s_send_stop;
				end
				else
					counter <= #1 counter - 1'b1;
				stx_o_tmp <= #1 bit_out;
			end
	s_send_stop :  begin
				if (~|counter)
				  begin
						casex ({lcr[ 2],lcr[ 1 : 0]})
  						3'b0xx:	  counter <= #1 5'b01101;     
  						3'b100:	  counter <= #1 5'b10101;     
  						default:	  counter <= #1 5'b11101;     
						endcase
					end
				else
				if (counter == 5'b00001)
				begin
					counter <= #1 0;
					tstate <= #1 s_idle;
				end
				else
					counter <= #1 counter - 1'b1;
				stx_o_tmp <= #1 1'b1;
			end

		default : 
			tstate <= #1 s_idle;
	endcase
  end 
  else
    tf_pop <= #1 1'b0;  
end 

assign stx_pad_o = lcr[ 6] ? 1'b0 : stx_o_tmp;    
	
endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\timescale.v"
`timescale 1ps/1ps


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_alu.v"



















































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 116 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_alu.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 118 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_alu.v"


module or1200_alu(
	a, b, mult_mac_result, macrc_op,
	alu_op, shrot_op, comp_op,
	cust5_op, cust5_limm,
	result, flagforw, flag_we,
	cyforw, cy_we, carry, flag
);

parameter width =  32;




input	[width-1:0]		a;
input	[width-1:0]		b;
input	[width-1:0]		mult_mac_result;
input				macrc_op;
input	[ 4-1:0]	alu_op;
input	[ 2-1:0]	shrot_op;
input	[ 4-1:0]	comp_op;
input	[4:0]			cust5_op;
input	[5:0]			cust5_limm;
output	[width-1:0]		result;
output				flagforw;
output				flag_we;
output				cyforw;
output				cy_we;
input				carry;
input         flag;




reg	[width-1:0]		result;
reg	[width-1:0]		shifted_rotated;
reg	[width-1:0]		result_cust5;
reg				flagforw;
reg				flagcomp;
reg				flag_we;
reg				cy_we;
wire	[width-1:0]		comp_a;
wire	[width-1:0]		comp_b;




wire	[width-1:0]		result_sum;

wire	[width-1:0]		result_csum;
wire				cy_csum;

wire	[width-1:0]		result_and;
wire				cy_sum;
reg				cyforw;




assign comp_a = {a[width-1] ^ comp_op[3] , a[width-2:0]};
assign comp_b = {b[width-1] ^ comp_op[3] , b[width-2:0]};




assign {cy_sum, result_sum} = a + b;

assign {cy_csum, result_csum} = a + b + {32'd0, carry};

assign result_and = a & b;
















always @(alu_op or a or b or result_sum or result_and or macrc_op or shifted_rotated or mult_mac_result) begin

	casex (alu_op)		



     4'd15: begin
        result = a[0] ? 1 : a[1] ? 2 : a[2] ? 3 : a[3] ? 4 : a[4] ? 5 : a[5] ? 6 : a[6] ? 7 : a[7] ? 8 : a[8] ? 9 : a[9] ? 10 : a[10] ? 11 : a[11] ? 12 : a[12] ? 13 : a[13] ? 14 : a[14] ? 15 : a[15] ? 16 : a[16] ? 17 : a[17] ? 18 : a[18] ? 19 : a[19] ? 20 : a[20] ? 21 : a[21] ? 22 : a[22] ? 23 : a[23] ? 24 : a[24] ? 25 : a[25] ? 26 : a[26] ? 27 : a[27] ? 28 : a[28] ? 29 : a[29] ? 30 : a[30] ? 31 : a[31] ? 32 : 0;
    end
		 4'd7 : begin 
				result = result_cust5;
		end
		 4'd8 : begin 
				result = shifted_rotated;
		end
		 4'd0 : begin
				result = result_sum;
		end

		 4'd1 : begin
				result = result_csum;
		end

		 4'd2 : begin
				result = a - b;
		end
		 4'd5 : begin
				result = a ^ b;
		end
		 4'd4  : begin
				result = a | b;
		end
		 4'd11 : begin
				result = b;
		end
		 4'd12 : begin
				if (macrc_op) begin
					result = mult_mac_result;
				end
				else begin
					result = b << 16;
				end
		end





		 4'd6 : begin
				result = mult_mac_result;
		end

     4'd14: begin
        result = flag ? a : b;
    end


    default: begin




      result=result_and;
    end 
	endcase
end






always @(cust5_op or cust5_limm or a or b) begin
	casex (cust5_op)		
		5'h1 : begin 
			casex (cust5_limm[1:0])
				2'h0: result_cust5 = {a[31:8], b[7:0]};
				2'h1: result_cust5 = {a[31:16], b[7:0], a[7:0]};
				2'h2: result_cust5 = {a[31:24], b[7:0], a[15:0]};
				2'h3: result_cust5 = {b[7:0], a[23:0]};
			endcase
		end
		5'h2 :
			result_cust5 = a | (1 << cust5_limm);
		5'h3 :
			result_cust5 = a & (32'hffffffff ^ (1 << cust5_limm));



		default: begin
			result_cust5 = a;
		end
	endcase
end




always @(alu_op or result_sum or result_and or flagcomp) begin
	casex (alu_op)		
















		 4'd13: begin
			flagforw = flagcomp;
			flag_we = 1'b1;
		end
		default: begin
			flagforw = 1'b0;
			flag_we = 1'b0;
		end
	endcase
end




always @(alu_op or cy_sum

	or cy_csum

	) begin
	casex (alu_op)		

		 4'd0 : begin
			cyforw = cy_sum;
			cy_we = 1'b1;
		end

		 4'd1: begin
			cyforw = cy_csum;
			cy_we = 1'b1;
		end


		default: begin
			cyforw = 1'b0;
			cy_we = 1'b0;
		end
	endcase
end




always @(shrot_op or a or b) begin
	case (shrot_op)		
	 2'd0 :
				shifted_rotated = (a << b[4:0]);
		 2'd1 :
				shifted_rotated = (a >> b[4:0]);





		default:
				shifted_rotated = ({32{a[31]}} << (6'd32-{1'b0, b[4:0]})) | a >> b[4:0];
	endcase
end





























always @(comp_op or comp_a or comp_b) begin
	case(comp_op[2:0])	
		 3'b000:
			flagcomp = (comp_a == comp_b);
		 3'b001:
			flagcomp = (comp_a != comp_b);
		 3'b010:
			flagcomp = (comp_a > comp_b);
		 3'b011:
			flagcomp = (comp_a >= comp_b);
		 3'b100:
			flagcomp = (comp_a < comp_b);
		 3'b101:
			flagcomp = (comp_a <= comp_b);
		default:
			flagcomp = 1'b0;
	endcase
end


endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_amultp2_32x32.v"









































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 74 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_amultp2_32x32.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 76 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_amultp2_32x32.v"

































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_cfgr.v"












































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 77 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_cfgr.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 79 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_cfgr.v"


module or1200_cfgr(
	
	spr_addr, spr_dat_o
);




input	[31:0]	spr_addr;	
output	[31:0]	spr_dat_o;	




reg	[31:0]	spr_dat_o;	






always @(spr_addr)

	if (~|spr_addr[31:4])

		case(spr_addr[3:0])		
			 4'h0: begin
				spr_dat_o[ 5 : 0] =  6'h01;
				spr_dat_o[ 15 : 6] =  10'h000;
				spr_dat_o[ 23 : 16] =  8'h00;
				spr_dat_o[ 31 : 24] =  8'h12;
			end
			 4'h1: begin
				spr_dat_o[ 0] =  1'b1;
				spr_dat_o[ 1] =  1'b1;
				spr_dat_o[ 2] =  1'b1;
				spr_dat_o[ 3] =  1'b0;
				spr_dat_o[ 4] =  1'b0;
				spr_dat_o[ 5] =  1'b1;
				spr_dat_o[ 6] =  1'b1;
				spr_dat_o[ 7] =  1'b0;
				spr_dat_o[ 8] =  1'b1;
				spr_dat_o[ 9] =  1'b1;
				spr_dat_o[ 10] =  1'b1;
				spr_dat_o[ 23 : 11] =  13'h0000;
				spr_dat_o[ 31 : 24] =  8'h00;
			end
			 4'h2: begin
				spr_dat_o[ 3 : 0] =  4'h0;
				spr_dat_o[ 4] =  1'b0;
				spr_dat_o[ 5] =  1'b1;
				spr_dat_o[ 6] =  1'b0;
				spr_dat_o[ 7] =  1'b0;
				spr_dat_o[ 8] =  1'b0;
				spr_dat_o[ 9] =  1'b0;
				spr_dat_o[ 31 : 10] =  22'h000000;
			end
			 4'h3: begin
				spr_dat_o[ 1 : 0] =  2'h0;
				spr_dat_o[ 4 : 2] =  3'h0;
				spr_dat_o[ 7 : 5] =  3'h0;
				spr_dat_o[ 8] =  1'b0;
				spr_dat_o[ 9] =  1'b0;
				spr_dat_o[ 10] =  1'b0;
				spr_dat_o[ 11] =  1'b0;
				spr_dat_o[ 31 : 12] =  20'h00000;
			end
			 4'h4: begin
				spr_dat_o[ 1 : 0] =  2'h0;
				spr_dat_o[ 4 : 2] =  3'h0;
				spr_dat_o[ 7 : 5] =  3'h0;
				spr_dat_o[ 8] =  1'b0;
				spr_dat_o[ 9] =  1'b0;
				spr_dat_o[ 10] =  1'b0;
				spr_dat_o[ 11] =  1'b0;
				spr_dat_o[ 31 : 12] =  20'h00000;
			end
			 4'h5: begin
				spr_dat_o[ 2 : 0] =  3'h0;
				spr_dat_o[ 6 : 3] =  (   13 -  4 );
				spr_dat_o[ 7] =  (  4 - 4 );
				spr_dat_o[ 8] =  1'b0;
				spr_dat_o[ 9] =  1'b1;
				spr_dat_o[ 10] =  1'b1;
				spr_dat_o[ 11] =  1'b0;
				spr_dat_o[ 12] =  1'b0;
				spr_dat_o[ 13] =  1'b1;
				spr_dat_o[ 14] =  1'b0;
				spr_dat_o[ 31 : 15] =  17'h00000;
			end
			 4'h6: begin
				spr_dat_o[ 2 : 0] =  3'h0;
				spr_dat_o[ 6 : 3] =  (   13 -  4 );
				spr_dat_o[ 7] =  (  4 - 4 );
				spr_dat_o[ 8] =  1'b0;
				spr_dat_o[ 9] =  1'b1;
				spr_dat_o[ 10] =  1'b1;
				spr_dat_o[ 11] =  1'b0;
				spr_dat_o[ 12] =  1'b0;
				spr_dat_o[ 13] =  1'b1;
				spr_dat_o[ 14] =  1'b0;
				spr_dat_o[ 31 : 15] =  17'h00000;
			end
			 4'h7: begin
				spr_dat_o[ 2 : 0] =  3'h0;
				spr_dat_o[ 3] =  1'b0;
				spr_dat_o[ 31 : 4] =  28'h0000000;
			end
			default: spr_dat_o = 32'h0000_0000;
		endcase

	else
		spr_dat_o = 32'h0000_0000;











































endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_cpu.v"





















































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 150 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_cpu.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 152 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_cpu.v"


module or1200_cpu(
	
	clk, rst,

	
	ic_en,
	icpu_adr_o, icpu_cycstb_o, icpu_sel_o, icpu_tag_o,
	icpu_dat_i, icpu_ack_i, icpu_rty_i, icpu_err_i, icpu_adr_i, icpu_tag_i,
	immu_en,

	
	ex_insn, ex_freeze, id_pc, branch_op,
	spr_dat_npc, rf_dataw,
	du_stall, du_addr, du_dat_du, du_read, du_write, du_dsr, du_hwbkpt,
	du_except, du_dat_cpu,
	
	
	dc_en,
	dcpu_adr_o, dcpu_cycstb_o, dcpu_we_o, dcpu_sel_o, dcpu_tag_o, dcpu_dat_o,
	dcpu_dat_i, dcpu_ack_i, dcpu_rty_i, dcpu_err_i, dcpu_tag_i,
	dmmu_en,

	
	sig_int, sig_tick,

	
	supv, spr_addr, spr_dat_cpu, spr_dat_pic, spr_dat_tt, spr_dat_pm,
	spr_dat_dmmu, spr_dat_immu, spr_dat_du, spr_cs, spr_we
);

parameter dw =  32;
parameter aw =  5;








input 				clk;
input 				rst;




output				ic_en;
output	[31:0]			icpu_adr_o;
output				icpu_cycstb_o;
output	[3:0]			icpu_sel_o;
output	[3:0]			icpu_tag_o;
input	[31:0]			icpu_dat_i;
input				icpu_ack_i;
input				icpu_rty_i;
input				icpu_err_i;
input	[31:0]			icpu_adr_i;
input	[3:0]			icpu_tag_i;




output				immu_en;




output	[31:0]			ex_insn;
output				ex_freeze;
output	[31:0]			id_pc;
output	[ 3-1:0]	branch_op;

input				du_stall;
input	[dw-1:0]		du_addr;
input	[dw-1:0]		du_dat_du;
input				du_read;
input				du_write;
input	[ 14-1:0]	du_dsr;
input				du_hwbkpt;
output	[12:0]			du_except;
output	[dw-1:0]		du_dat_cpu;
output	[dw-1:0]		rf_dataw;




output	[31:0]			dcpu_adr_o;
output				dcpu_cycstb_o;
output				dcpu_we_o;
output	[3:0]			dcpu_sel_o;
output	[3:0]			dcpu_tag_o;
output	[31:0]			dcpu_dat_o;
input	[31:0]			dcpu_dat_i;
input				dcpu_ack_i;
input				dcpu_rty_i;
input				dcpu_err_i;
input	[3:0]			dcpu_tag_i;
output				dc_en;




output				dmmu_en;




output				supv;
input	[dw-1:0]		spr_dat_pic;
input	[dw-1:0]		spr_dat_tt;
input	[dw-1:0]		spr_dat_pm;
input	[dw-1:0]		spr_dat_dmmu;
input	[dw-1:0]		spr_dat_immu;
input	[dw-1:0]		spr_dat_du;
output	[dw-1:0]		spr_addr;
output	[dw-1:0]		spr_dat_cpu;
output	[dw-1:0]		spr_dat_npc;
output	[31:0]			spr_cs;
output				spr_we;




input				sig_int;
input				sig_tick;




wire	[31:0]			if_insn;
wire	[31:0]			if_pc;
wire	[31:2]			lr_sav;
wire	[aw-1:0]		rf_addrw;
wire	[aw-1:0] 		rf_addra;
wire	[aw-1:0] 		rf_addrb;
wire				rf_rda;
wire				rf_rdb;
wire	[dw-1:0]		simm;
wire	[dw-1:2]		branch_addrofs;
wire	[ 4-1:0]	alu_op;
wire	[ 2-1:0]	shrot_op;
wire	[ 4-1:0]	comp_op;
wire	[ 3-1:0]	branch_op;
wire	[ 4-1:0]	lsu_op;
wire				genpc_freeze;
wire				if_freeze;
wire				id_freeze;
wire				ex_freeze;
wire				wb_freeze;
wire	[ 2-1:0]	sel_a;
wire	[ 2-1:0]	sel_b;
wire	[ 3-1:0]	rfwb_op;
wire	[dw-1:0]		rf_dataw;
wire	[dw-1:0]		rf_dataa;
wire	[dw-1:0]		rf_datab;
wire	[dw-1:0]		muxed_b;
wire	[dw-1:0]		wb_forw;
wire				wbforw_valid;
wire	[dw-1:0]		operand_a;
wire	[dw-1:0]		operand_b;
wire	[dw-1:0]		alu_dataout;
wire	[dw-1:0]		lsu_dataout;
wire	[dw-1:0]		sprs_dataout;
wire	[31:0]			lsu_addrofs;
wire	[ 2-1:0]	multicycle;
wire	[ 4-1:0]	except_type;
wire	[4:0]			cust5_op;
wire	[5:0]			cust5_limm;
wire				flushpipe;
wire				extend_flush;
wire				branch_taken;
wire				flag;
wire				flagforw;
wire				flag_we;
wire				carry;
wire				cyforw;
wire				cy_we;
wire				lsu_stall;
wire				epcr_we;
wire				eear_we;
wire				esr_we;
wire				pc_we;
wire	[31:0]			epcr;
wire	[31:0]			eear;
wire	[ 16-1:0]	esr;
wire				sr_we;
wire	[ 16-1:0]	to_sr;
wire	[ 16-1:0]	sr;
wire				except_start;
wire				except_started;
wire	[31:0]			wb_insn;
wire	[15:0]			spr_addrimm;
wire				sig_syscall;
wire				sig_trap;
wire	[31:0]			spr_dat_cfgr;
wire	[31:0]			spr_dat_rf;
wire    [31:0]                  spr_dat_npc;
wire	[31:0]			spr_dat_ppc;
wire	[31:0]			spr_dat_mac;
wire				force_dslot_fetch;
wire				no_more_dslot;
wire				ex_void;
wire				if_stall;
wire				id_macrc_op;
wire				ex_macrc_op;
wire	[ 2-1:0] mac_op;
wire	[31:0]			mult_mac_result;
wire				mac_stall;
wire	[12:0]			except_stop;
wire				genpc_refetch;
wire				rfe;
wire				lsu_unstall;
wire				except_align;
wire				except_dtlbmiss;
wire				except_dmmufault;
wire				except_illegal;
wire				except_itlbmiss;
wire				except_immufault;
wire				except_ibuserr;
wire				except_dbuserr;
wire				abort_ex;




assign du_except = except_stop;




assign dc_en = sr[ 3];




assign ic_en = sr[ 4];




assign dmmu_en = sr[ 5];




assign immu_en = sr[ 6];




assign supv = sr[ 0];




or1200_genpc or1200_genpc(
	.clk(clk),
	.rst(rst),
	.icpu_adr_o(icpu_adr_o),
	.icpu_cycstb_o(icpu_cycstb_o),
	.icpu_sel_o(icpu_sel_o),
	.icpu_tag_o(icpu_tag_o),
	.icpu_rty_i(icpu_rty_i),
	.icpu_adr_i(icpu_adr_i),

	.branch_op(branch_op),
	.except_type(except_type),
	.except_start(except_start),
	.except_prefix(sr[ 14]),
	.branch_addrofs(branch_addrofs),
	.lr_restor(operand_b),
	.flag(flag),
	.taken(branch_taken),
	.binsn_addr(lr_sav),
	.epcr(epcr),
	.spr_dat_i(spr_dat_cpu),
	.spr_pc_we(pc_we),
	.genpc_refetch(genpc_refetch),
	.genpc_freeze(genpc_freeze),
  .genpc_stop_prefetch(1'b0),
	.no_more_dslot(no_more_dslot)
);




or1200_if or1200_if(
	.clk(clk),
	.rst(rst),
	.icpu_dat_i(icpu_dat_i),
	.icpu_ack_i(icpu_ack_i),
	.icpu_err_i(icpu_err_i),
	.icpu_adr_i(icpu_adr_i),
	.icpu_tag_i(icpu_tag_i),

	.if_freeze(if_freeze),
	.if_insn(if_insn),
	.if_pc(if_pc),
	.flushpipe(flushpipe),
	.if_stall(if_stall),
	.no_more_dslot(no_more_dslot),
	.genpc_refetch(genpc_refetch),
	.rfe(rfe),
	.except_itlbmiss(except_itlbmiss),
	.except_immufault(except_immufault),
	.except_ibuserr(except_ibuserr)
);




or1200_ctrl or1200_ctrl(
	.clk(clk),
	.rst(rst),
	.id_freeze(id_freeze),
	.ex_freeze(ex_freeze),
	.wb_freeze(wb_freeze),
	.flushpipe(flushpipe),
	.if_insn(if_insn),
	.ex_insn(ex_insn),
	.branch_op(branch_op),
	.branch_taken(branch_taken),
	.rf_addra(rf_addra),
	.rf_addrb(rf_addrb),
	.rf_rda(rf_rda),
	.rf_rdb(rf_rdb),
	.alu_op(alu_op),
	.mac_op(mac_op),
	.shrot_op(shrot_op),
	.comp_op(comp_op),
	.rf_addrw(rf_addrw),
	.rfwb_op(rfwb_op),
	.wb_insn(wb_insn),
	.simm(simm),
	.branch_addrofs(branch_addrofs),
	.lsu_addrofs(lsu_addrofs),
	.sel_a(sel_a),
	.sel_b(sel_b),
	.lsu_op(lsu_op),
	.cust5_op(cust5_op),
	.cust5_limm(cust5_limm),
	.multicycle(multicycle),
	.spr_addrimm(spr_addrimm),
	.wbforw_valid(wbforw_valid),
	.sig_syscall(sig_syscall),
	.sig_trap(sig_trap),
	.force_dslot_fetch(force_dslot_fetch),
	.no_more_dslot(no_more_dslot),
	.ex_void(ex_void),
	.id_macrc_op(id_macrc_op),
	.ex_macrc_op(ex_macrc_op),
	.rfe(rfe),
	.du_hwbkpt(du_hwbkpt),
	.except_illegal(except_illegal)
);




or1200_rf or1200_rf(
	.clk(clk),
	.rst(rst),
	.supv(sr[ 0]),
	.wb_freeze(wb_freeze),
	.addrw(rf_addrw),
	.dataw(rf_dataw),
	.id_freeze(id_freeze),
	.we(rfwb_op[0]),
	.flushpipe(flushpipe),
	.addra(rf_addra),
	.rda(rf_rda),
	.dataa(rf_dataa),
	.addrb(rf_addrb),
	.rdb(rf_rdb),
	.datab(rf_datab),
	.spr_cs(spr_cs[ 5'd00]),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_rf)
);




or1200_operandmuxes or1200_operandmuxes(
	.clk(clk),
	.rst(rst),
	.id_freeze(id_freeze),
	.ex_freeze(ex_freeze),
	.rf_dataa(rf_dataa),
	.rf_datab(rf_datab),
	.ex_forw(rf_dataw),
	.wb_forw(wb_forw),
	.simm(simm),
	.sel_a(sel_a),
	.sel_b(sel_b),
	.operand_a(operand_a),
	.operand_b(operand_b),
	.muxed_b(muxed_b)
);




or1200_alu or1200_alu(
	.a(operand_a),
	.b(operand_b),
	.mult_mac_result(mult_mac_result),
	.macrc_op(ex_macrc_op),
	.alu_op(alu_op),
	.shrot_op(shrot_op),
	.comp_op(comp_op),
	.cust5_op(cust5_op),
	.cust5_limm(cust5_limm),
	.result(alu_dataout),
	.flagforw(flagforw),
	.flag_we(flag_we),
	.cyforw(cyforw),
	.cy_we(cy_we),
  .flag(flag),
	.carry(carry)
);




or1200_mult_mac or1200_mult_mac(
	.clk(clk),
	.rst(rst),
	.ex_freeze(ex_freeze),
	.id_macrc_op(id_macrc_op),
	.macrc_op(ex_macrc_op),
	.a(operand_a),
	.b(operand_b),
	.mac_op(mac_op),
	.alu_op(alu_op),
	.result(mult_mac_result),
	.mac_stall_r(mac_stall),
	.spr_cs(spr_cs[ 5'd05]),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_mac)
);




or1200_sprs or1200_sprs(
	.clk(clk),
	.rst(rst),
	.addrbase(operand_a),
	.addrofs(spr_addrimm),
	.dat_i(operand_b),
	.alu_op(alu_op),
	.flagforw(flagforw),
	.flag_we(flag_we),
	.flag(flag),
	.cyforw(cyforw),
	.cy_we(cy_we),
	.carry(carry),
	.to_wbmux(sprs_dataout),

	.du_addr(du_addr),
	.du_dat_du(du_dat_du),
	.du_read(du_read),
	.du_write(du_write),
	.du_dat_cpu(du_dat_cpu),

	.spr_addr(spr_addr),
	.spr_dat_pic(spr_dat_pic),
	.spr_dat_tt(spr_dat_tt),
	.spr_dat_pm(spr_dat_pm),
	.spr_dat_cfgr(spr_dat_cfgr),
	.spr_dat_rf(spr_dat_rf),
	.spr_dat_npc(spr_dat_npc),
        .spr_dat_ppc(spr_dat_ppc),
	.spr_dat_mac(spr_dat_mac),
	.spr_dat_dmmu(spr_dat_dmmu),
	.spr_dat_immu(spr_dat_immu),
	.spr_dat_du(spr_dat_du),
	.spr_dat_o(spr_dat_cpu),
	.spr_cs(spr_cs),
	.spr_we(spr_we),

	.epcr_we(epcr_we),
	.eear_we(eear_we),
	.esr_we(esr_we),
	.pc_we(pc_we),
	.epcr(epcr),
	.eear(eear),
	.esr(esr),
	.except_started(except_started),

	.sr_we(sr_we),
	.to_sr(to_sr),
	.sr(sr),
	.branch_op(branch_op)
);




or1200_lsu or1200_lsu(
	.addrbase(operand_a),
	.addrofs(lsu_addrofs),
	.lsu_op(lsu_op),
	.lsu_datain(operand_b),
	.lsu_dataout(lsu_dataout),
	.lsu_stall(lsu_stall),
	.lsu_unstall(lsu_unstall),
        .du_stall(du_stall),
	.except_align(except_align),
	.except_dtlbmiss(except_dtlbmiss),
	.except_dmmufault(except_dmmufault),
	.except_dbuserr(except_dbuserr),

	.dcpu_adr_o(dcpu_adr_o),
	.dcpu_cycstb_o(dcpu_cycstb_o),
	.dcpu_we_o(dcpu_we_o),
	.dcpu_sel_o(dcpu_sel_o),
	.dcpu_tag_o(dcpu_tag_o),
	.dcpu_dat_o(dcpu_dat_o),
	.dcpu_dat_i(dcpu_dat_i),
	.dcpu_ack_i(dcpu_ack_i),
	.dcpu_rty_i(dcpu_rty_i),
	.dcpu_err_i(dcpu_err_i),
	.dcpu_tag_i(dcpu_tag_i)
);




or1200_wbmux or1200_wbmux(
	.clk(clk),
	.rst(rst),
	.wb_freeze(wb_freeze),
	.rfwb_op(rfwb_op),
	.muxin_a(alu_dataout),
	.muxin_b(lsu_dataout),
	.muxin_c(sprs_dataout),
	.muxin_d({lr_sav, 2'b0}),
	.muxout(rf_dataw),
	.muxreg(wb_forw),
	.muxreg_valid(wbforw_valid)
);




or1200_freeze or1200_freeze(
	.clk(clk),
	.rst(rst),
	.multicycle(multicycle),
	.flushpipe(flushpipe),
	.extend_flush(extend_flush),
	.lsu_stall(lsu_stall),
	.if_stall(if_stall),
	.lsu_unstall(lsu_unstall),
	.force_dslot_fetch(force_dslot_fetch),
	.abort_ex(abort_ex),
	.du_stall(du_stall),
	.mac_stall(mac_stall),
	.genpc_freeze(genpc_freeze),
	.if_freeze(if_freeze),
	.id_freeze(id_freeze),
	.ex_freeze(ex_freeze),
	.wb_freeze(wb_freeze),
	.icpu_ack_i(icpu_ack_i),
	.icpu_err_i(icpu_err_i)
);




or1200_except or1200_except(
	.clk(clk),
	.rst(rst),
	.sig_ibuserr(except_ibuserr),
	.sig_dbuserr(except_dbuserr),
	.sig_illegal(except_illegal),
	.sig_align(except_align),
	.sig_range(1'b0),
	.sig_dtlbmiss(except_dtlbmiss),
	.sig_dmmufault(except_dmmufault),
	.sig_int(sig_int),
	.sig_syscall(sig_syscall),
	.sig_trap(sig_trap),
	.sig_itlbmiss(except_itlbmiss),
	.sig_immufault(except_immufault),
	.sig_tick(sig_tick),
	.branch_taken(branch_taken),
	.icpu_ack_i(icpu_ack_i),
	.icpu_err_i(icpu_err_i),
	.dcpu_ack_i(dcpu_ack_i),
	.dcpu_err_i(dcpu_err_i),
	.genpc_freeze(genpc_freeze),
        .id_freeze(id_freeze),
        .ex_freeze(ex_freeze),
        .wb_freeze(wb_freeze),
	.if_stall(if_stall),
	.if_pc(if_pc),
	.id_pc(id_pc),
	.lr_sav(lr_sav),
	.flushpipe(flushpipe),
	.extend_flush(extend_flush),
	.except_type(except_type),
	.except_start(except_start),
	.except_started(except_started),
	.except_stop(except_stop),
	.ex_void(ex_void),
	.spr_dat_ppc(spr_dat_ppc),
	.spr_dat_npc(spr_dat_npc),

	.datain(operand_b),
	.du_dsr(du_dsr),
	.epcr_we(epcr_we),
	.eear_we(eear_we),
	.esr_we(esr_we),
	.pc_we(pc_we),
        .epcr(epcr),
	.eear(eear),
	.esr(esr),

	.lsu_addr(dcpu_adr_o),
	.sr_we(sr_we),
	.to_sr(to_sr),
	.sr(sr),
	.abort_ex(abort_ex)
);




or1200_cfgr or1200_cfgr(
	.spr_addr(spr_addr),
	.spr_dat_o(spr_dat_cfgr)
);

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ctrl.v"




























































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 125 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ctrl.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 127 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ctrl.v"


module or1200_ctrl(
	
	clk, rst,

	
	id_freeze, ex_freeze, wb_freeze, flushpipe, if_insn, ex_insn, branch_op, branch_taken,
	rf_addra, rf_addrb, rf_rda, rf_rdb, alu_op, mac_op, shrot_op, comp_op, rf_addrw, rfwb_op,
	wb_insn, simm, branch_addrofs, lsu_addrofs, sel_a, sel_b, lsu_op,
	cust5_op, cust5_limm,
	multicycle, spr_addrimm, wbforw_valid, du_hwbkpt, sig_syscall, sig_trap,
	force_dslot_fetch, no_more_dslot, ex_void, id_macrc_op, ex_macrc_op, rfe, except_illegal
);




input					clk;
input					rst;
input					id_freeze;
input					ex_freeze;
input					wb_freeze;
input					flushpipe;
input	[31:0]				if_insn;
output	[31:0]				ex_insn;
output	[ 3-1:0]		branch_op;
input						branch_taken;
output	[ 5-1:0]	rf_addrw;
output	[ 5-1:0]	rf_addra;
output	[ 5-1:0]	rf_addrb;
output					rf_rda;
output					rf_rdb;
output	[ 4-1:0]		alu_op;
output	[ 2-1:0]		mac_op;
output	[ 2-1:0]		shrot_op;
output	[ 3-1:0]		rfwb_op;
output	[31:0]				wb_insn;
output	[31:0]				simm;
output	[31:2]				branch_addrofs;
output	[31:0]				lsu_addrofs;
output	[ 2-1:0]		sel_a;
output	[ 2-1:0]		sel_b;
output	[ 4-1:0]		lsu_op;
output	[ 4-1:0]		comp_op;
output	[ 2-1:0]		multicycle;
output	[4:0]				cust5_op;
output	[5:0]				cust5_limm;
output	[15:0]				spr_addrimm;
input					wbforw_valid;
input					du_hwbkpt;
output					sig_syscall;
output					sig_trap;
output					force_dslot_fetch;
output					no_more_dslot;
output					ex_void;
output					id_macrc_op;
output					ex_macrc_op;
output					rfe;
output					except_illegal;




reg	[ 3-1:0]		pre_branch_op;
reg	[ 3-1:0]		branch_op;
reg	[ 4-1:0]		alu_op;

reg	[ 2-1:0]		mac_op;
reg					ex_macrc_op;




reg	[ 2-1:0]		shrot_op;
reg	[31:0]				id_insn;
reg	[31:0]				ex_insn;
reg	[31:0]				wb_insn;
reg	[ 5-1:0]	rf_addrw;
reg	[ 5-1:0]	wb_rfaddrw;
reg	[ 3-1:0]		rfwb_op;
reg	[31:0]				lsu_addrofs;
reg	[ 2-1:0]		sel_a;
reg	[ 2-1:0]		sel_b;
reg					sel_imm;
reg	[ 4-1:0]		lsu_op;
reg	[ 4-1:0]		comp_op;
reg	[ 2-1:0]		multicycle;
reg					imm_signextend;
reg	[15:0]				spr_addrimm;
reg					sig_syscall;
reg					sig_trap;
reg					except_illegal;
wire					id_void;




assign rf_addra = if_insn[20:16];
assign rf_addrb = if_insn[15:11];
assign rf_rda = if_insn[31];
assign rf_rdb = if_insn[30];







assign force_dslot_fetch = 1'b0;
assign no_more_dslot = |branch_op & !id_void & branch_taken | (branch_op ==  3'd6);
assign id_void = (id_insn[31:26] ==  6'b000101) & id_insn[16];
assign ex_void = (ex_insn[31:26] ==  6'b000101) & ex_insn[16];




assign simm = (imm_signextend == 1'b1) ? {{16{id_insn[15]}}, id_insn[15:0]} : {{16'b0}, id_insn[15:0]};




assign branch_addrofs = {{4{ex_insn[25]}}, ex_insn[25:0]};





assign id_macrc_op = (id_insn[31:26] ==  6'b000110) & id_insn[16];







assign cust5_op = ex_insn[4:0];
assign cust5_limm = ex_insn[10:5];




assign rfe = (pre_branch_op ==  3'd6) | (branch_op ==  3'd6);




always @(rf_addrw or id_insn or rfwb_op or wbforw_valid or wb_rfaddrw)
	if ((id_insn[20:16] == rf_addrw) && rfwb_op[0])
		sel_a =  2'd2;
	else if ((id_insn[20:16] == wb_rfaddrw) && wbforw_valid)
		sel_a =  2'd3;
	else
		sel_a =  2'd0;




always @(rf_addrw or sel_imm or id_insn or rfwb_op or wbforw_valid or wb_rfaddrw)
	if (sel_imm)
		sel_b =  2'd1;
	else if ((id_insn[15:11] == rf_addrw) && rfwb_op[0])
		sel_b =  2'd2;
	else if ((id_insn[15:11] == wb_rfaddrw) && wbforw_valid)
		sel_b =  2'd3;
	else
		sel_b =  2'd0;





always @(posedge clk or posedge rst) begin
	if (rst)
		ex_macrc_op <= #1 1'b0;
	else if (!ex_freeze & id_freeze | flushpipe)
		ex_macrc_op <= #1 1'b0;
	else if (!ex_freeze)
		ex_macrc_op <= #1 id_macrc_op;
end







always @(posedge clk or posedge rst) begin
	if (rst)
		spr_addrimm <= #1 16'h0000;
	else if (!ex_freeze & id_freeze | flushpipe)
		spr_addrimm <= #1 16'h0000;
	else if (!ex_freeze) begin
		case (id_insn[31:26])	
			
			 6'b101101: 
				spr_addrimm <= #1 id_insn[15:0];
			
			default:
				spr_addrimm <= #1 {id_insn[25:21], id_insn[10:0]};
		endcase
	end
end




always @(id_insn) begin
  case (id_insn[31:26])		
































    
    
     6'b111000:
      multicycle = id_insn[ 9 : 8];
    
    
    default: begin
      multicycle =  2'd0;
    end
    
  endcase
  
end




always @(id_insn) begin
  case (id_insn[31:26])		

	
	 6'b100111:
		imm_signextend = 1'b1;

	
	 6'b101000:
		imm_signextend = 1'b1;

	
	 6'b101011:
		imm_signextend = 1'b1;

	

	 6'b101100:
		imm_signextend = 1'b1;


	

	 6'b010011:
		imm_signextend = 1'b1;


	
	 6'b101111:
		imm_signextend = 1'b1;

	
	default: begin
		imm_signextend = 1'b0;
	end

endcase

end




always @(lsu_op or ex_insn) begin
	lsu_addrofs[10:0] = ex_insn[10:0];
	case(lsu_op)	
		 4'b1110,  4'b1100,  4'b1010 : 
			lsu_addrofs[31:11] = {{16{ex_insn[25]}}, ex_insn[25:21]};
		default : 
			lsu_addrofs[31:11] = {{16{ex_insn[15]}}, ex_insn[15:11]};
	endcase
end




always @(posedge clk or posedge rst) begin
	if (rst)
		rf_addrw <= #1 5'd0;
	else if (!ex_freeze & id_freeze)
		rf_addrw <= #1 5'd00;
	else if (!ex_freeze)
		case (pre_branch_op)	
			 3'd2,  3'd3:
				rf_addrw <= #1 5'd09;	
			default:
				rf_addrw <= #1 id_insn[25:21];
		endcase
end




always @(posedge clk or posedge rst) begin
	if (rst)
		wb_rfaddrw <= #1 5'd0;
	else if (!wb_freeze)
		wb_rfaddrw <= #1 rf_addrw;
end




always @(posedge clk or posedge rst) begin
	if (rst)
		id_insn <= #1 { 6'b000101, 26'h041_0000};
        else if (flushpipe)
                id_insn <= #1 { 6'b000101, 26'h041_0000};        
	else if (!id_freeze) begin
		id_insn <= #1 if_insn;





	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		ex_insn <= #1 { 6'b000101, 26'h041_0000};
	else if (!ex_freeze & id_freeze | flushpipe)
		ex_insn <= #1 { 6'b000101, 26'h041_0000};	
	else if (!ex_freeze) begin
		ex_insn <= #1 id_insn;





	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		wb_insn <= #1 { 6'b000101, 26'h041_0000};
	else if (flushpipe)
		wb_insn <= #1 { 6'b000101, 26'h041_0000};	
	else if (!wb_freeze) begin
		wb_insn <= #1 ex_insn;
	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		sel_imm <= #1 1'b0;
	else if (!id_freeze) begin
	  case (if_insn[31:26])		

	    
	     6'b010010:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b010001:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b001001:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b101101:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b110000:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b001000:
	      sel_imm <= #1 1'b0;
	    
	    

	     6'b110001:
	      sel_imm <= #1 1'b0;


	    
	     6'b110101:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b110110:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b110111:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b111000:
	      sel_imm <= #1 1'b0;
	    
	    
	     6'b111001:
	      sel_imm <= #1 1'b0;






	    
	    
	     6'b000101:
	      sel_imm <= #1 1'b0;

	    
	    default: begin
	      sel_imm <= #1 1'b1;
	    end
	    
	  endcase
	  
	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		except_illegal <= #1 1'b0;
	else if (!ex_freeze & id_freeze | flushpipe)
		except_illegal <= #1 1'b0;
	else if (!ex_freeze) begin
	  case (id_insn[31:26])		

	     6'b000000,
	     6'b000001,
	     6'b010010,
	     6'b010001,
	     6'b000011,
	     6'b000100,
	     6'b001001,
	     6'b000110,
	     6'b101101,
	     6'b001000,

	     6'b010011,

	     6'b100001,
	     6'b100011,
	     6'b100100,
	     6'b100101,
	     6'b100110,
	     6'b100111,
	     6'b101000,
	     6'b101001,
	     6'b101010,
	     6'b101011,

	     6'b101100,

	     6'b101110,
	     6'b101111,
	     6'b110000,

	     6'b110001,

	     6'b110101,
	     6'b110110,
	     6'b110111,
	     6'b111000,
	     6'b111001,



	     6'b000101:
		except_illegal <= #1 1'b0;

	    
	    default:
	      except_illegal <= #1 1'b1;

	  endcase
	  
	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		alu_op <= #1  4'd4;
	else if (!ex_freeze & id_freeze | flushpipe)
		alu_op <= #1  4'd4;
	else if (!ex_freeze) begin
	  case (id_insn[31:26])		
	    
	    
	     6'b000000:
	      alu_op <= #1  4'd11;
	    
	    
	     6'b000001:
	      alu_op <= #1  4'd11;
	    
	    
	     6'b000011:
	      alu_op <= #1  4'd4;
	    
	    
	     6'b000100:
	      alu_op <= #1  4'd4;
	    
	    
	     6'b000110:
	      alu_op <= #1  4'd12;
	    
	    
	     6'b101101:
	      alu_op <= #1  4'd15;
	    
	    
	     6'b110000:
	      alu_op <= #1  4'd14;
	    
	    
	     6'b100111:
	      alu_op <= #1  4'd0;
	    
	    
	     6'b101000:
	      alu_op <= #1  4'd1;
	    
	    
	     6'b101001:
	      alu_op <= #1  4'd3;
	    
	    
	     6'b101010:
	      alu_op <= #1  4'd4;
	    
	    
	     6'b101011:
	      alu_op <= #1  4'd5;
	    
	    

	     6'b101100:
	      alu_op <= #1  4'd6;

	    
	    
	     6'b101110:
	      alu_op <= #1  4'd8;
	    
	    
	     6'b101111:
	      alu_op <= #1  4'd13;
	    
	    
	     6'b111000:
	      alu_op <= #1 id_insn[3:0];
	    
	    
	     6'b111001:
	      alu_op <= #1  4'd13;






	    
	    
	    default: begin
	      alu_op <= #1  4'd4;
	    end
	      
	  endcase
	  
	end
end





always @(posedge clk or posedge rst) begin
	if (rst)
		mac_op <= #1  2'b00;
	else if (!ex_freeze & id_freeze | flushpipe)
		mac_op <= #1  2'b00;
	else if (!ex_freeze)
	  case (id_insn[31:26])		

	    
	     6'b010011:
	      mac_op <= #1  2'b01;

	    
	     6'b110001:
	      mac_op <= #1 id_insn[1:0];

	    
	    default: begin
	      mac_op <= #1  2'b00;
	    end	      

	  endcase
	else
		mac_op <= #1  2'b00;
end







always @(posedge clk or posedge rst) begin
	if (rst)
		shrot_op <= #1  2'd0;
	else if (!ex_freeze & id_freeze | flushpipe)
		shrot_op <= #1  2'd0;
	else if (!ex_freeze) begin
		shrot_op <= #1 id_insn[ 7 : 6];
	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		rfwb_op <= #1  3'b000;
	else  if (!ex_freeze & id_freeze | flushpipe)
		rfwb_op <= #1  3'b000;
	else  if (!ex_freeze) begin
		case (id_insn[31:26])		

		  
		   6'b000001:
		    rfwb_op <= #1  3'b111;
		  
		  
		   6'b010010:
		    rfwb_op <= #1  3'b111;
		  
		  
		   6'b000110:
		    rfwb_op <= #1  3'b001;
		  
		  
		   6'b101101:
		    rfwb_op <= #1  3'b101;
		  
		  
		   6'b100001:
		    rfwb_op <= #1  3'b011;
		  
		  
		   6'b100011:
		    rfwb_op <= #1  3'b011;
		  
		  
		   6'b100100:
		    rfwb_op <= #1  3'b011;
		  
		  
		   6'b100101:
		    rfwb_op <= #1  3'b011;
		  
		  
		   6'b100110:
		    rfwb_op <= #1  3'b011;
		  
		  
		   6'b100111:
		    rfwb_op <= #1  3'b001;
		  
		  
		   6'b101000:
		    rfwb_op <= #1  3'b001;
		  
		  
		   6'b101001:
		    rfwb_op <= #1  3'b001;
		  
		  
		   6'b101010:
		    rfwb_op <= #1  3'b001;
		  
		  
		   6'b101011:
		    rfwb_op <= #1  3'b001;
		  
		  

		   6'b101100:
		    rfwb_op <= #1  3'b001;

		  
		  
		   6'b101110:
		    rfwb_op <= #1  3'b001;
		  
		  
		   6'b111000:
		    rfwb_op <= #1  3'b001;







		  
		  default: begin
		    rfwb_op <= #1  3'b000;
		  end

		endcase
	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		pre_branch_op <= #1  3'd0;
	else if (flushpipe)
		pre_branch_op <= #1  3'd0;
	else if (!id_freeze) begin
		case (if_insn[31:26])		
		  
		  
		   6'b000000:
		    pre_branch_op <= #1  3'd3;
		  
		  
		   6'b000001:
		    pre_branch_op <= #1  3'd3;
		  
		  
		   6'b010010:
		    pre_branch_op <= #1  3'd2;
		  
		  
		   6'b010001:
		    pre_branch_op <= #1  3'd2;
		  
		  
		   6'b000011:
		    pre_branch_op <= #1  3'd5;
		  
		  
		   6'b000100:
		    pre_branch_op <= #1  3'd4;
		  
		  
		   6'b001001:
		    pre_branch_op <= #1  3'd6;
		  
		  
		  default: begin
		    pre_branch_op <= #1  3'd0;
		  end
		endcase
	end
end




always @(posedge clk or posedge rst)
	if (rst)
		branch_op <= #1  3'd0;
	else if (!ex_freeze & id_freeze | flushpipe)
		branch_op <= #1  3'd0;		
	else if (!ex_freeze)
		branch_op <= #1 pre_branch_op;




always @(posedge clk or posedge rst) begin
	if (rst)
		lsu_op <= #1  4'b0000;
	else if (!ex_freeze & id_freeze | flushpipe)
		lsu_op <= #1  4'b0000;
	else if (!ex_freeze)  begin
	  case (id_insn[31:26])		
	    
	    
	     6'b100001:
	      lsu_op <= #1  4'b0110;
	    
	    
	     6'b100011:
	      lsu_op <= #1  4'b0010;
	    
	    
	     6'b100100:
	      lsu_op <= #1  4'b0011;
	    
	    
	     6'b100101:
	      lsu_op <= #1  4'b0100;
	    
	    
	     6'b100110:
	      lsu_op <= #1  4'b0101;
	    
	    
	     6'b110101:
	      lsu_op <= #1  4'b1110;
	    
	    
	     6'b110110:
	      lsu_op <= #1  4'b1010;
	    
	    
	     6'b110111:
	      lsu_op <= #1  4'b1100;
	    
	    
	    default: begin
	      lsu_op <= #1  4'b0000;
	    end
	  endcase
	end
end




always @(posedge clk or posedge rst) begin
	if (rst) begin
		comp_op <= #1 4'd0;
	end else if (!ex_freeze & id_freeze | flushpipe)
		comp_op <= #1 4'd0;
	else if (!ex_freeze)
		comp_op <= #1 id_insn[24:21];
end




always @(posedge clk or posedge rst) begin
	if (rst)
		sig_syscall <= #1 1'b0;
	else if (!ex_freeze & id_freeze | flushpipe)
		sig_syscall <= #1 1'b0;
	else if (!ex_freeze) begin






		sig_syscall <= #1 (id_insn[31:23] == { 6'b001000, 3'b000});
	end
end




always @(posedge clk or posedge rst) begin
	if (rst)
		sig_trap <= #1 1'b0;
	else if (!ex_freeze & id_freeze | flushpipe)
		sig_trap <= #1 1'b0;
	else if (!ex_freeze) begin






		sig_trap <= #1 (id_insn[31:23] == { 6'b001000, 3'b010})
			| du_hwbkpt;
	end
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_fsm.v"





































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 102 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_fsm.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 104 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_fsm.v"












module or1200_dc_fsm(
	
	clk, rst,

	
	dc_en, dcqmem_cycstb_i, dcqmem_ci_i, dcqmem_we_i, dcqmem_sel_i,
	tagcomp_miss, biudata_valid, biudata_error, start_addr, saved_addr,
	dcram_we, biu_read, biu_write, first_hit_ack, first_miss_ack, first_miss_err,
	burst, tag_we, dc_addr
);




input				clk;
input				rst;
input				dc_en;
input				dcqmem_cycstb_i;
input				dcqmem_ci_i;
input				dcqmem_we_i;
input	[3:0]			dcqmem_sel_i;
input				tagcomp_miss;
input				biudata_valid;
input				biudata_error;
input	[31:0]			start_addr;
output	[31:0]			saved_addr;
output	[3:0]			dcram_we;
output				biu_read;
output				biu_write;
output				first_hit_ack;
output				first_miss_ack;
output				first_miss_err;
output				burst;
output				tag_we;
output	[31:0]			dc_addr;




reg	[31:0]			saved_addr_r;
reg	[2:0]			state;
reg	[2:0]			cnt;
reg				hitmiss_eval;
reg				store;
reg				load;
reg				cache_inhibit;
wire				first_store_hit_ack;




assign dcram_we = {4{load & biudata_valid & !cache_inhibit}} | {4{first_store_hit_ack}} & dcqmem_sel_i;
assign tag_we = biu_read & biudata_valid & !cache_inhibit;




assign biu_read = (hitmiss_eval & tagcomp_miss) | (!hitmiss_eval & load);
assign biu_write = store;

assign dc_addr = (biu_read | biu_write) & !hitmiss_eval ? saved_addr : start_addr;
assign saved_addr = saved_addr_r;







assign first_hit_ack = (state ==  3'd1) & !tagcomp_miss & !cache_inhibit & !dcqmem_ci_i | first_store_hit_ack;
assign first_store_hit_ack = (state ==  3'd3) & !tagcomp_miss & biudata_valid & !cache_inhibit & !dcqmem_ci_i;
assign first_miss_ack = ((state ==  3'd1) | (state ==  3'd3)) & biudata_valid;
assign first_miss_err = ((state ==  3'd1) | (state ==  3'd3)) & biudata_error;




assign burst = (state ==  3'd1) & tagcomp_miss & !cache_inhibit
		| (state ==  3'd2)



		;




always @(posedge clk or posedge rst) begin
	if (rst) begin
		state <= #1  3'd0;
		saved_addr_r <= #1 32'b0;
		hitmiss_eval <= #1 1'b0;
		store <= #1 1'b0;
		load <= #1 1'b0;
		cnt <= #1 3'b000;
		cache_inhibit <= #1 1'b0;
	end
	else
	case (state)	
		 3'd0 :
			if (dc_en & dcqmem_cycstb_i & dcqmem_we_i) begin	
				state <= #1  3'd3;
				saved_addr_r <= #1 start_addr;
				hitmiss_eval <= #1 1'b1;
				store <= #1 1'b1;
				load <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
			else if (dc_en & dcqmem_cycstb_i) begin		
				state <= #1  3'd1;
				saved_addr_r <= #1 start_addr;
				hitmiss_eval <= #1 1'b1;
				store <= #1 1'b0;
				load <= #1 1'b1;
				cache_inhibit <= #1 1'b0;
			end
			else begin							
				hitmiss_eval <= #1 1'b0;
				store <= #1 1'b0;
				load <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
		 3'd1: begin		
			if (dcqmem_cycstb_i & dcqmem_ci_i)
				cache_inhibit <= #1 1'b1;
			if (hitmiss_eval)
				saved_addr_r[31:13] <= #1 start_addr[31:13];
			if ((hitmiss_eval & !dcqmem_cycstb_i) ||					
			    (biudata_error) ||										
			    ((cache_inhibit | dcqmem_ci_i) & biudata_valid)) begin	
				state <= #1  3'd0;
				hitmiss_eval <= #1 1'b0;
				load <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
			else if (tagcomp_miss & biudata_valid) begin	
				state <= #1  3'd2;
				saved_addr_r[3:2] <= #1 saved_addr_r[3:2] + 1'd1;
				hitmiss_eval <= #1 1'b0;
				cnt <= #1  4-2;
				cache_inhibit <= #1 1'b0;
			end
			else if (!tagcomp_miss & !dcqmem_ci_i) begin	
				state <= #1  3'd0;
				hitmiss_eval <= #1 1'b0;
				load <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
			else						
				hitmiss_eval <= #1 1'b0;
		end
		 3'd2 : begin
			if (biudata_valid && (|cnt)) begin		
				cnt <= #1 cnt - 3'd1;
				saved_addr_r[3:2] <= #1 saved_addr_r[3:2] + 1'd1;
			end
			else if (biudata_valid) begin			
				state <= #1  3'd0;
				load <= #1 1'b0;
			end
		end
		 3'd3: begin		
			if (dcqmem_cycstb_i & dcqmem_ci_i)
				cache_inhibit <= #1 1'b1;
			if (hitmiss_eval)
				saved_addr_r[31:13] <= #1 start_addr[31:13];
			if ((hitmiss_eval & !dcqmem_cycstb_i) ||	
			    (biudata_error) ||						
			    ((cache_inhibit | dcqmem_ci_i) & biudata_valid)) begin	
				state <= #1  3'd0;
				hitmiss_eval <= #1 1'b0;
				store <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end










			else if (biudata_valid) begin			
				state <= #1  3'd0;
				hitmiss_eval <= #1 1'b0;
				store <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
			else						
				hitmiss_eval <= #1 1'b0;
			end












		default:
			state <= #1  3'd0;
	endcase
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_ram.v"



















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 84 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_ram.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 86 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_ram.v"


module or1200_dc_ram(
	
	clk, rst,






	
	addr, en, we, datain, dataout
);

parameter dw =  32;
parameter aw =   13 - 2;




input				clk;
input				rst;
input	[aw-1:0]		addr;
input				en;
input	[3:0]			we;
input	[dw-1:0]		datain;
output	[dw-1:0]		dataout;





























or1200_spram_2048x32_bw dc_ram(







	.clk(clk),
	.rst(rst),
	.ce(en),
	.we(we),
	.oe(1'b1),
	.addr(addr),
	.di(datain),
	.doq(dataout)
);

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_tag.v"















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 80 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_tag.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 82 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_tag.v"


module or1200_dc_tag(
	
	clk, rst,






	
	addr, en, we, datain, tag_v, tag
);

parameter dw =  20;
parameter aw =   13 -  4;




input				clk;
input				rst;
input	[aw-1:0]		addr;
input				en;
input				we;
input	[dw-1:0]		datain;
output				tag_v;
output	[dw-2:0]		tag;






























or1200_spram_512x20 dc_tag0(







	.clk(clk),
	.rst(rst),
	.ce(en),
	.we(we),
	.oe(1'b1),
	.addr(addr),
	.di(datain),
	.doq({tag, tag_v})
);



endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_top.v"

































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 98 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_top.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 100 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dc_top.v"





module or1200_dc_top(
	
	clk, rst,

	
	dcsb_dat_o, dcsb_adr_o, dcsb_cyc_o, dcsb_stb_o, dcsb_we_o, dcsb_sel_o, dcsb_cab_o,
	dcsb_dat_i, dcsb_ack_i, dcsb_err_i,

	
	dc_en,
	dcqmem_adr_i, dcqmem_cycstb_i, dcqmem_ci_i,
	dcqmem_we_i, dcqmem_sel_i, dcqmem_tag_i, dcqmem_dat_i,
	dcqmem_dat_o, dcqmem_ack_o, dcqmem_rty_o, dcqmem_err_o, dcqmem_tag_o,






	
	spr_cs, spr_write, spr_dat_i
);

parameter dw =  32;








input				clk;
input				rst;




output	[dw-1:0]		dcsb_dat_o;
output	[31:0]			dcsb_adr_o;
output				dcsb_cyc_o;
output				dcsb_stb_o;
output				dcsb_we_o;
output	[3:0]			dcsb_sel_o;
output				dcsb_cab_o;
input	[dw-1:0]		dcsb_dat_i;
input				dcsb_ack_i;
input				dcsb_err_i;




input				dc_en;
input	[31:0]			dcqmem_adr_i;
input				dcqmem_cycstb_i;
input				dcqmem_ci_i;
input				dcqmem_we_i;
input	[3:0]			dcqmem_sel_i;
input	[3:0]			dcqmem_tag_i;
input	[dw-1:0]		dcqmem_dat_i;
output	[dw-1:0]		dcqmem_dat_o;
output				dcqmem_ack_o;
output				dcqmem_rty_o;
output				dcqmem_err_o;
output	[3:0]			dcqmem_tag_o;













input				spr_cs;
input				spr_write;
input	[31:0]			spr_dat_i;




wire				tag_v;
wire	[ 20-2:0]	tag;
wire	[dw-1:0]		to_dcram;
wire	[dw-1:0]		from_dcram;
wire	[31:0]			saved_addr;
wire	[3:0]			dcram_we;
wire				dctag_we;
wire	[31:0]			dc_addr;
wire				dcfsm_biu_read;
wire				dcfsm_biu_write;
reg				tagcomp_miss;
wire	[  13 - 1: 4]	dctag_addr;
wire				dctag_en;
wire				dctag_v; 
wire				dc_inv;
wire				dcfsm_first_hit_ack;
wire				dcfsm_first_miss_ack;
wire				dcfsm_first_miss_err;
wire				dcfsm_burst;
wire				dcfsm_tag_we;














assign dcsb_adr_o = dc_addr;
assign dc_inv = spr_cs & spr_write;
assign dctag_we = dcfsm_tag_we | dc_inv;
assign dctag_addr = dc_inv ? spr_dat_i[  13 - 1: 4] : dc_addr[  13 - 1: 4];
assign dctag_en = dc_inv | dc_en;
assign dctag_v = ~dc_inv;





assign dcsb_dat_o = dcqmem_dat_i;




assign dcsb_cyc_o = (dc_en) ? dcfsm_biu_read | dcfsm_biu_write : dcqmem_cycstb_i;
assign dcsb_stb_o = (dc_en) ? dcfsm_biu_read | dcfsm_biu_write : dcqmem_cycstb_i;
assign dcsb_we_o = (dc_en) ? dcfsm_biu_write : dcqmem_we_i;
assign dcsb_sel_o = (dc_en & dcfsm_biu_read & !dcfsm_biu_write & !dcqmem_ci_i) ? 4'b1111 : dcqmem_sel_i;
assign dcsb_cab_o = (dc_en) ? dcfsm_burst : 1'b0;
assign dcqmem_rty_o = ~dcqmem_ack_o;
assign dcqmem_tag_o = dcqmem_err_o ?  4'hb : dcqmem_tag_i;




assign dcqmem_ack_o = dc_en ? dcfsm_first_hit_ack | dcfsm_first_miss_ack : dcsb_ack_i;
assign dcqmem_err_o = dc_en ? dcfsm_first_miss_err : dcsb_err_i;









assign to_dcram = (dcfsm_biu_read) ? dcsb_dat_i : dcqmem_dat_i;




assign dcqmem_dat_o = dcfsm_first_miss_ack | !dc_en ? dcsb_dat_i : from_dcram;




always @(tag or saved_addr or tag_v) begin
	if ((tag != saved_addr[31:   13 - 1 + 1]) || !tag_v)
		tagcomp_miss = 1'b1;
	else
		tagcomp_miss = 1'b0;
end




or1200_dc_fsm or1200_dc_fsm(
	.clk(clk),
	.rst(rst),
	.dc_en(dc_en),
	.dcqmem_cycstb_i(dcqmem_cycstb_i),
	.dcqmem_ci_i(dcqmem_ci_i),
	.dcqmem_we_i(dcqmem_we_i),
	.dcqmem_sel_i(dcqmem_sel_i),
	.tagcomp_miss(tagcomp_miss),
	.biudata_valid(dcsb_ack_i),
	.biudata_error(dcsb_err_i),
	.start_addr(dcqmem_adr_i),
	.saved_addr(saved_addr),
	.dcram_we(dcram_we),
	.biu_read(dcfsm_biu_read),
	.biu_write(dcfsm_biu_write),
	.first_hit_ack(dcfsm_first_hit_ack),
	.first_miss_ack(dcfsm_first_miss_ack),
	.first_miss_err(dcfsm_first_miss_err),
	.burst(dcfsm_burst),
	.tag_we(dcfsm_tag_we),
	.dc_addr(dc_addr)
);




or1200_dc_ram or1200_dc_ram(
	.clk(clk),
	.rst(rst),






	.addr(dc_addr[  13 - 1:2]),
	.en(dc_en),
	.we(dcram_we),
	.datain(to_dcram),
	.dataout(from_dcram)
);




or1200_dc_tag or1200_dc_tag(
	.clk(clk),
	.rst(rst),






	.addr(dctag_addr),
	.en(dctag_en),
	.we(dctag_we),
	.datain({dc_addr[31:   13 - 1 + 1], dctag_v}),
	.tag_v(tag_v),
	.tag(tag)
);

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"


















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dmmu_tlb.v"















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 80 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dmmu_tlb.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 82 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dmmu_tlb.v"






module or1200_dmmu_tlb(
	
	clk, rst,

	
	tlb_en, vaddr, hit, ppn, uwe, ure, swe, sre, ci,






	
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o
);

parameter dw =  32;
parameter aw =  32;








input				clk;
input				rst;




input				tlb_en;
input	[aw-1:0]		vaddr;
output				hit;
output	[31: 13]	ppn;
output				uwe;
output				ure;
output				swe;
output				sre;
output				ci;













input				spr_cs;
input				spr_write;
input	[31:0]			spr_addr;
input	[31:0]			spr_dat_i;
output	[31:0]			spr_dat_o;




wire	[ 31 :    13 +  6 - 1 + 1]	vpn;
wire				v;
wire	[ 6-1:0]	tlb_index;
wire				tlb_mr_en;
wire				tlb_mr_we;
wire	[  32 -  6 -  13 + 1-1:0]	tlb_mr_ram_in;
wire	[  32 -  6 -  13 + 1-1:0]	tlb_mr_ram_out;
wire				tlb_tr_en;
wire				tlb_tr_we;
wire	[ 32 -  13 + 5-1:0]	tlb_tr_ram_in;
wire	[ 32 -  13 + 5-1:0]	tlb_tr_ram_out;



























assign tlb_mr_en = tlb_en | (spr_cs & !spr_addr[ 7]);




assign tlb_mr_we = spr_cs & spr_write & !spr_addr[ 7];




assign tlb_tr_en = tlb_en | (spr_cs & spr_addr[ 7]);




assign tlb_tr_we = spr_cs & spr_write & spr_addr[ 7];




assign spr_dat_o = (spr_cs & !spr_write & !spr_addr[ 7]) ?
			{vpn, tlb_index & { 6{v}}, { 32 -  6 -  13-7{1'b0}}, 1'b0, 5'b00000, v} :
		(spr_cs & !spr_write & spr_addr[ 7]) ?
			{ppn, { 13-10{1'b0}}, swe, sre, uwe, ure, {4{1'b0}}, ci, 1'b0} :
			32'h00000000;




assign {vpn, v} = tlb_mr_ram_out;




assign tlb_mr_ram_in = {spr_dat_i[ 31 :    13 +  6 - 1 + 1], spr_dat_i[ 0]};




assign {ppn, swe, sre, uwe, ure, ci} = tlb_tr_ram_out;




assign tlb_tr_ram_in = {spr_dat_i[31: 13],
			spr_dat_i[ 9],
			spr_dat_i[ 8],
			spr_dat_i[ 7],
			spr_dat_i[ 6],
			spr_dat_i[ 1]};




assign hit = (vpn == vaddr[ 31 :    13 +  6 - 1 + 1]) & v;





assign tlb_index = spr_cs ? spr_addr[ 6-1:0] : vaddr[   13 +  6 - 1 :   13];




or1200_spram_64x14 dtlb_mr_ram(
	.clk(clk),
	.rst(rst),






	.ce(tlb_mr_en),
	.we(tlb_mr_we),
	.oe(1'b1),
	.addr(tlb_index),
	.di(tlb_mr_ram_in),
	.doq(tlb_mr_ram_out)
);




or1200_spram_64x24 dtlb_tr_ram(
	.clk(clk),
	.rst(rst),






	.ce(tlb_tr_en),
	.we(tlb_tr_we),
	.oe(1'b1),
	.addr(tlb_index),
	.di(tlb_tr_ram_in),
	.doq(tlb_tr_ram_out)
);

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dmmu_top.v"

































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 98 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dmmu_top.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 100 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dmmu_top.v"






module or1200_dmmu_top(
	
	clk, rst,

	
	dc_en, dmmu_en, supv, dcpu_adr_i, dcpu_cycstb_i, dcpu_we_i,
	dcpu_tag_o, dcpu_err_o,

	
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o,






	
	qmemdmmu_err_i, qmemdmmu_tag_i, qmemdmmu_adr_o, qmemdmmu_cycstb_o, qmemdmmu_ci_o
);

parameter dw =  32;
parameter aw =  32;








input				clk;
input				rst;




input				dc_en;
input				dmmu_en;
input				supv;
input	[aw-1:0]		dcpu_adr_i;
input				dcpu_cycstb_i;
input				dcpu_we_i;
output	[3:0]			dcpu_tag_o;
output				dcpu_err_o;




input				spr_cs;
input				spr_write;
input	[aw-1:0]		spr_addr;
input	[31:0]			spr_dat_i;
output	[31:0]			spr_dat_o;













input				qmemdmmu_err_i;
input	[3:0]			qmemdmmu_tag_i;
output	[aw-1:0]		qmemdmmu_adr_o;
output				qmemdmmu_cycstb_o;
output				qmemdmmu_ci_o;




wire				dtlb_spr_access;
wire	[31: 13]	dtlb_ppn;
wire				dtlb_hit;
wire				dtlb_uwe;
wire				dtlb_ure;
wire				dtlb_swe;
wire				dtlb_sre;
wire	[31:0]			dtlb_dat_o;
wire				dtlb_en;
wire				dtlb_ci;
wire				fault;
wire				miss;
























assign spr_dat_o = 32'h00000000;
assign qmemdmmu_adr_o = dcpu_adr_i;
assign dcpu_tag_o = qmemdmmu_tag_i;
assign qmemdmmu_cycstb_o = dcpu_cycstb_i;
assign dcpu_err_o = qmemdmmu_err_i;
assign qmemdmmu_ci_o =  dcpu_adr_i [ 31 ];

































































































































endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dpram_32x32.v"

























































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 122 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dpram_32x32.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 124 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_dpram_32x32.v"


module or1200_dpram_32x32(
	
	clk_a, rst_a, ce_a, oe_a, addr_a, do_a,
	clk_b, rst_b, ce_b, we_b, addr_b, di_b
);




parameter aw = 5;
parameter dw = 32;




input			clk_a;	
input			rst_a;	
input			ce_a;	
input			oe_a;	
input 	[aw-1:0]	addr_a;	
output	[dw-1:0]	do_a;	
input			clk_b;	
input			rst_b;	
input			ce_b;	
input			we_b;	
input 	[aw-1:0]	addr_b;	
input	[dw-1:0]	di_b;	









































































































































































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_a_reg;		




assign do_a = (oe_a) ? mem[addr_a_reg] : {dw{1'b0}};




always @(posedge clk_a or posedge rst_a)
	if (rst_a)
		addr_a_reg <= #1 {aw{1'b0}};
	else if (ce_a)
		addr_a_reg <= #1 addr_a;




always @(posedge clk_b)
	if (ce_b && we_b)
		mem[addr_b] <= #1 di_b;

	
	
	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_du.v"



















































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 116 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_du.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 118 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_du.v"






module or1200_du(
	
	clk, rst,
	dcpu_cycstb_i, dcpu_we_i, dcpu_adr_i, dcpu_dat_lsu,
	dcpu_dat_dc, icpu_cycstb_i,
	ex_freeze, branch_op, ex_insn, id_pc,
	spr_dat_npc, rf_dataw,
	du_dsr, du_stall, du_addr, du_dat_i, du_dat_o,
	du_read, du_write, du_except, du_hwbkpt,
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o,

	
	dbg_stall_i, dbg_ewt_i,	dbg_lss_o, dbg_is_o, dbg_wp_o, dbg_bp_o,
	dbg_stb_i, dbg_we_i, dbg_adr_i, dbg_dat_i, dbg_dat_o, dbg_ack_o
);

parameter dw =  32;
parameter aw =  32;








input				clk;		
input				rst;		
input				dcpu_cycstb_i;	
input				dcpu_we_i;	
input	[31:0]			dcpu_adr_i;	
input	[31:0]			dcpu_dat_lsu;	
input	[31:0]			dcpu_dat_dc;	
input	[ 1-1:0]	icpu_cycstb_i;	
input				ex_freeze;	
input	[ 3-1:0]	branch_op;	
input	[dw-1:0]		ex_insn;	
input	[31:0]			id_pc;		
input	[31:0]			spr_dat_npc;	
input	[31:0]			rf_dataw;	
output	[ 14-1:0]     du_dsr;		
output				du_stall;	
output	[aw-1:0]		du_addr;	
input	[dw-1:0]		du_dat_i;	
output	[dw-1:0]		du_dat_o;	
output				du_read;	
output				du_write;	
input	[12:0]			du_except;	
output				du_hwbkpt;	
input				spr_cs;		
input				spr_write;	
input	[aw-1:0]		spr_addr;	
input	[dw-1:0]		spr_dat_i;	
output	[dw-1:0]		spr_dat_o;	




input			dbg_stall_i;	
input			dbg_ewt_i;	
output	[3:0]		dbg_lss_o;	
output	[1:0]		dbg_is_o;	
output	[10:0]		dbg_wp_o;	
output			dbg_bp_o;	
input			dbg_stb_i;      
input			dbg_we_i;       
input	[aw-1:0]	dbg_adr_i;	
input	[dw-1:0]	dbg_dat_i;	
output	[dw-1:0]	dbg_dat_o;	
output			dbg_ack_o;	






assign dbg_lss_o = 4'b0000;

reg	[1:0]			dbg_is_o;



always @(posedge clk or posedge rst)
	if (rst)
		dbg_is_o <= #1 2'b00;
	else if (!ex_freeze &
		~((ex_insn[31:26] ==  6'b000101) & ex_insn[16]))
		dbg_is_o <= #1 ~dbg_is_o;







assign dbg_wp_o = 11'b000_0000_0000;
assign dbg_dat_o = du_dat_i;




assign du_stall = dbg_stall_i;
assign du_addr = dbg_adr_i;
assign du_dat_o = dbg_dat_i;
assign du_read = dbg_stb_i && !dbg_we_i;
assign du_write = dbg_stb_i && dbg_we_i;




reg dbg_ack_o;
always @(posedge clk or posedge rst)
	if (rst)
		dbg_ack_o <= #1 1'b0;
	else
		dbg_ack_o <= #1 dbg_stb_i;







reg	[24:0]			dmr1;		










wire	[23:0]			dmr2;		






reg	[ 14-1:0]	dsr;		








reg	[13:0]			drr;		










wire	[31:0]			dvr0;








wire	[31:0]			dvr1;








wire	[31:0]			dvr2;








wire	[31:0]			dvr3;








wire	[31:0]			dvr4;








wire	[31:0]			dvr5;








wire	[31:0]			dvr6;








wire	[31:0]			dvr7;








wire	[7:0]			dcr0;








wire	[7:0]			dcr1;








wire	[7:0]			dcr2;








wire	[7:0]			dcr3;








wire	[7:0]			dcr4;








wire	[7:0]			dcr5;








wire	[7:0]			dcr6;








wire	[7:0]			dcr7;








wire	[31:0]			dwcr0;








wire	[31:0]			dwcr1;





wire				dmr1_sel; 	
wire				dmr2_sel; 	
wire				dsr_sel; 	
wire				drr_sel; 	
wire				dvr0_sel,
				dvr1_sel,
				dvr2_sel,
				dvr3_sel,
				dvr4_sel,
				dvr5_sel,
				dvr6_sel,
				dvr7_sel; 	
wire				dcr0_sel,
				dcr1_sel,
				dcr2_sel,
				dcr3_sel,
				dcr4_sel,
				dcr5_sel,
				dcr6_sel,
				dcr7_sel; 	
wire				dwcr0_sel,
				dwcr1_sel; 	
reg				dbg_bp_r;































wire				du_hwbkpt;

reg	[31:0]			spr_dat_o;

reg	[13:0]			except_stop;	





wire	[31:0]			tbia_dat_o;
wire	[31:0]			tbim_dat_o;
wire	[31:0]			tbar_dat_o;
wire	[31:0]			tbts_dat_o;





assign dmr1_sel = (spr_cs && (spr_addr[ 10 : 0] ==  11'd16));





assign dsr_sel = (spr_cs && (spr_addr[ 10 : 0] ==  11'd20));


assign drr_sel = (spr_cs && (spr_addr[ 10 : 0] ==  11'd21));



























































always @(du_except) begin
	except_stop = 14'b0000_0000_0000;
	casex (du_except)
		13'b1_xxxx_xxxx_xxxx:
			except_stop[ 4] = 1'b1;
		13'b0_1xxx_xxxx_xxxx: begin
			except_stop[ 7] = 1'b1;
		end
		13'b0_01xx_xxxx_xxxx: begin
			except_stop[ 9] = 1'b1;
		end
		13'b0_001x_xxxx_xxxx:
			except_stop[ 3] = 1'b1;
		13'b0_0001_xxxx_xxxx: begin
			except_stop[ 1] = 1'b1;
		end
		13'b0_0000_1xxx_xxxx:
			except_stop[ 6] = 1'b1;
		13'b0_0000_01xx_xxxx: begin
			except_stop[ 5] = 1'b1;
		end
		13'b0_0000_001x_xxxx: begin
			except_stop[ 8] = 1'b1;
		end
		13'b0_0000_0001_xxxx:
			except_stop[ 2] = 1'b1;
		13'b0_0000_0000_1xxx:
			except_stop[ 1] = 1'b1;
		13'b0_0000_0000_01xx: begin
			except_stop[ 10] = 1'b1;
		end
		13'b0_0000_0000_001x: begin
			except_stop[ 13] = 1'b1;
		end
		13'b0_0000_0000_0001:
			except_stop[ 11] = 1'b1;
		default:
			except_stop = 14'b0000_0000_0000;
	endcase
end




assign dbg_bp_o = dbg_bp_r;




always @(posedge clk or posedge rst)
	if (rst)
		dbg_bp_r <= #1 1'b0;
	else if (!ex_freeze)
		dbg_bp_r <= #1 |except_stop

                        | ~((ex_insn[31:26] ==  6'b000101) & ex_insn[16]) & dmr1[ 22]


                        | (branch_op !=  3'd0) & dmr1[ 23]

			;
        else
                dbg_bp_r <= #1 |except_stop;





always @(posedge clk or posedge rst)
	if (rst)
		dmr1 <= 25'h000_0000;
	else if (dmr1_sel && spr_write)



		dmr1 <= #1 {1'b0, spr_dat_i[23:22], 22'h00_0000};















assign dmr2 = 24'h00_0000;






always @(posedge clk or posedge rst)
	if (rst)
		dsr <= { 14{1'b0}};
	else if (dsr_sel && spr_write)
		dsr <= #1 spr_dat_i[ 14-1:0];








always @(posedge clk or posedge rst)
	if (rst)
		drr <= 14'b0;
	else if (drr_sel && spr_write)
		drr <= #1 spr_dat_i[13:0];
	else
		drr <= #1 drr | except_stop;














assign dvr0 = 32'h0000_0000;












assign dvr1 = 32'h0000_0000;












assign dvr2 = 32'h0000_0000;












assign dvr3 = 32'h0000_0000;












assign dvr4 = 32'h0000_0000;












assign dvr5 = 32'h0000_0000;












assign dvr6 = 32'h0000_0000;












assign dvr7 = 32'h0000_0000;












assign dcr0 = 8'h00;












assign dcr1 = 8'h00;












assign dcr2 = 8'h00;












assign dcr3 = 8'h00;












assign dcr4 = 8'h00;












assign dcr5 = 8'h00;












assign dcr6 = 8'h00;












assign dcr7 = 8'h00;














assign dwcr0 = 32'h0000_0000;














assign dwcr1 = 32'h0000_0000;






always @(spr_addr or dsr or drr or dmr1 or dmr2
	or dvr0 or dvr1 or dvr2 or dvr3 or dvr4
	or dvr5 or dvr6 or dvr7
	or dcr0 or dcr1 or dcr2 or dcr3 or dcr4
	or dcr5 or dcr6 or dcr7
	or dwcr0 or dwcr1




	)
	casex (spr_addr[ 10 : 0]) 

































































		 11'd16:
			spr_dat_o = {7'h00, dmr1};














		 11'd20:
			spr_dat_o = {18'b0, dsr};


		 11'd21:
			spr_dat_o = {18'b0, drr};













		default:
			spr_dat_o = 32'h0000_0000;
	endcase





assign du_dsr = dsr;


















































































































































































































































































































































































































































































































































































































assign du_hwbkpt = 1'b0;






















































































































































































assign tbia_dat_o = 32'h0000_0000;
assign tbim_dat_o = 32'h0000_0000;
assign tbar_dat_o = 32'h0000_0000;
assign tbts_dat_o = 32'h0000_0000;

	





















endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_except.v"











































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 140 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_except.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 142 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_except.v"














module or1200_except(
	
	clk, rst, 

	
	sig_ibuserr, sig_dbuserr, sig_illegal, sig_align, sig_range, sig_dtlbmiss, sig_dmmufault,
	sig_int, sig_syscall, sig_trap, sig_itlbmiss, sig_immufault, sig_tick,
	branch_taken, genpc_freeze, id_freeze, ex_freeze, wb_freeze, if_stall,
	if_pc, id_pc, lr_sav, flushpipe, extend_flush, except_type, except_start,
	except_started, except_stop, ex_void,
	spr_dat_ppc, spr_dat_npc, datain, du_dsr, epcr_we, eear_we, esr_we, pc_we, epcr, eear,
	esr, sr_we, to_sr, sr, lsu_addr, abort_ex, icpu_ack_i, icpu_err_i, dcpu_ack_i, dcpu_err_i
);




input				clk;
input				rst;
input				sig_ibuserr;
input				sig_dbuserr;
input				sig_illegal;
input				sig_align;
input				sig_range;
input				sig_dtlbmiss;
input				sig_dmmufault;
input				sig_int;
input				sig_syscall;
input				sig_trap;
input				sig_itlbmiss;
input				sig_immufault;
input				sig_tick;
input				branch_taken;
input				genpc_freeze;
input				id_freeze;
input				ex_freeze;
input				wb_freeze;
input				if_stall;
input	[31:0]			if_pc;
output	[31:0]			id_pc;
output	[31:2]			lr_sav;
input	[31:0]			datain;
input   [ 14-1:0]     du_dsr;
input				epcr_we;
input				eear_we;
input				esr_we;
input				pc_we;
output	[31:0]			epcr;
output	[31:0]			eear;
output	[ 16-1:0]	esr;
input	[ 16-1:0]	to_sr;
input				sr_we;
input	[ 16-1:0]	sr;
input	[31:0]			lsu_addr;
output				flushpipe;
output				extend_flush;
output	[ 4-1:0]	except_type;
output				except_start;
output				except_started;
output	[12:0]			except_stop;
input				ex_void;
output	[31:0]			spr_dat_ppc;
output	[31:0]			spr_dat_npc;
output				abort_ex;
input				icpu_ack_i;
input				icpu_err_i;
input				dcpu_ack_i;
input				dcpu_err_i;




reg	[ 4-1:0]	except_type;
reg	[31:0]			id_pc;
reg	[31:0]			ex_pc;
reg	[31:0]			wb_pc;
reg	[31:0]			epcr;
reg	[31:0]			eear;
reg	[ 16-1:0]		esr;
reg	[2:0]			id_exceptflags;
reg	[2:0]			ex_exceptflags;
reg	[ 3-1:0]	state;
reg				extend_flush;
reg				extend_flush_last;
reg				ex_dslot;
reg				delayed1_ex_dslot;
reg				delayed2_ex_dslot;
wire				except_started;
wire	[12:0]			except_trig;
wire				except_flushpipe;
reg	[2:0]			delayed_iee;
reg	[2:0]			delayed_tee;
wire				int_pending;
wire				tick_pending;




assign except_started = extend_flush & except_start;
assign lr_sav = ex_pc[31:2];
assign spr_dat_ppc = wb_pc;
assign spr_dat_npc = ex_void ? id_pc : ex_pc;
assign except_start = (except_type !=   4 'h0) & extend_flush;
assign int_pending = sig_int & sr[ 2] & delayed_iee[2] & ~ex_freeze & ~branch_taken & ~ex_dslot & ~sr_we;
assign tick_pending = sig_tick & sr[ 1] & ~ex_freeze & ~branch_taken & ~ex_dslot & ~sr_we;
assign abort_ex = sig_dbuserr | sig_dmmufault | sig_dtlbmiss | sig_align | sig_illegal;		




assign except_trig = {
			tick_pending		& ~du_dsr[ 4],
			int_pending 		& ~du_dsr[ 7],
			ex_exceptflags[1]	& ~du_dsr[ 9],
			ex_exceptflags[0]	& ~du_dsr[ 3],
			ex_exceptflags[2]	& ~du_dsr[ 1],
			sig_illegal		& ~du_dsr[ 6],
			sig_align		& ~du_dsr[ 5],
			sig_dtlbmiss		& ~du_dsr[ 8],
			sig_dmmufault		& ~du_dsr[ 2],
			sig_dbuserr		& ~du_dsr[ 1],
			sig_range		& ~du_dsr[ 10],
			sig_trap		& ~du_dsr[ 13] & ~ex_freeze,
			sig_syscall		& ~du_dsr[ 11] & ~ex_freeze
		};
assign except_stop = {
			tick_pending		& du_dsr[ 4],
			int_pending 		& du_dsr[ 7],
			ex_exceptflags[1]	& du_dsr[ 9],
			ex_exceptflags[0]	& du_dsr[ 3],
			ex_exceptflags[2]	& du_dsr[ 1],
			sig_illegal		& du_dsr[ 6],
			sig_align		& du_dsr[ 5],
			sig_dtlbmiss		& du_dsr[ 8],
			sig_dmmufault		& du_dsr[ 2],
			sig_dbuserr		& du_dsr[ 1],
			sig_range		& du_dsr[ 10],
			sig_trap		& du_dsr[ 13] & ~ex_freeze,
			sig_syscall		& du_dsr[ 11] & ~ex_freeze
		};




always @(posedge clk or posedge rst) begin
	if (rst) begin
		id_pc <= #1 32'd0;
		id_exceptflags <= #1 3'b000;
	end
	else if (flushpipe) begin
		id_pc <= #1 32'h0000_0000;
		id_exceptflags <= #1 3'b000;
	end
	else if (!id_freeze) begin
		id_pc <= #1 if_pc;
		id_exceptflags <= #1 { sig_ibuserr, sig_itlbmiss, sig_immufault };
	end
end









always @(posedge rst or posedge clk)
	if (rst)
		delayed_iee <= #1 3'b000;
	else if (!sr[ 2])
		delayed_iee <= #1 3'b000;
	else
		delayed_iee <= #1 {delayed_iee[1:0], 1'b1};









always @(posedge rst or posedge clk)
	if (rst)
		delayed_tee <= #1 3'b000;
	else if (!sr[ 1])
		delayed_tee <= #1 3'b000;
	else
		delayed_tee <= #1 {delayed_tee[1:0], 1'b1};




always @(posedge clk or posedge rst) begin
	if (rst) begin
		ex_dslot <= #1 1'b0;
		ex_pc <= #1 32'd0;
		ex_exceptflags <= #1 3'b000;
		delayed1_ex_dslot <= #1 1'b0;
		delayed2_ex_dslot <= #1 1'b0;
	end
	else if (flushpipe) begin
		ex_dslot <= #1 1'b0;
		ex_pc <= #1 32'h0000_0000;
		ex_exceptflags <= #1 3'b000;
		delayed1_ex_dslot <= #1 1'b0;
		delayed2_ex_dslot <= #1 1'b0;
	end
	else if (!ex_freeze & id_freeze) begin
		ex_dslot <= #1 1'b0;
		ex_pc <= #1 id_pc;
		ex_exceptflags <= #1 3'b000;
		delayed1_ex_dslot <= #1 ex_dslot;
		delayed2_ex_dslot <= #1 delayed1_ex_dslot;
	end
	else if (!ex_freeze) begin
		ex_dslot <= #1 branch_taken;
		ex_pc <= #1 id_pc;
		ex_exceptflags <= #1 id_exceptflags;
		delayed1_ex_dslot <= #1 ex_dslot;
		delayed2_ex_dslot <= #1 delayed1_ex_dslot;
	end
end




always @(posedge clk or posedge rst) begin
	if (rst) begin
		wb_pc <= #1 32'd0;
	end
	else if (!wb_freeze) begin
		wb_pc <= #1 ex_pc;
	end
end




assign flushpipe = except_flushpipe | pc_we | extend_flush;






assign except_flushpipe = |except_trig & ~|state;







always @(posedge clk or posedge rst) begin
	if (rst) begin
		state <= #1   3 'd0;
		except_type <= #1   4 'h0;
		extend_flush <= #1 1'b0;
		epcr <= #1 32'b0;
		eear <= #1 32'b0;
		esr <= #1 {1'b1, { 16-2{1'b0}}, 1'b1};
		extend_flush_last <= #1 1'b0;
	end
	else begin

		case (state)	



			  3 'd0:
				if (except_flushpipe) begin
					state <= #1   3 'd1;
					extend_flush <= #1 1'b1;
					esr <= #1 sr_we ? to_sr : sr;
					casex (except_trig)

						13'b1_xxxx_xxxx_xxxx: begin
							except_type <= #1   4 'h5;
							epcr <= #1 ex_dslot ? wb_pc : delayed1_ex_dslot ? id_pc : delayed2_ex_dslot ? id_pc : id_pc;
						end


						13'b0_1xxx_xxxx_xxxx: begin
							except_type <= #1   4 'h8;
							epcr <= #1 ex_dslot ? wb_pc : delayed1_ex_dslot ? id_pc : delayed2_ex_dslot ? id_pc : id_pc;
						end


						13'b0_01xx_xxxx_xxxx: begin
							except_type <= #1   4 'ha;





							eear <= #1 ex_dslot ? ex_pc : ex_pc;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;


						end


						13'b0_001x_xxxx_xxxx: begin
							except_type <= #1   4 'h4;



							eear <= #1 ex_dslot ? ex_pc : delayed1_ex_dslot ? id_pc : delayed2_ex_dslot ? id_pc : id_pc;
							epcr <= #1 ex_dslot ? wb_pc : delayed1_ex_dslot ? id_pc : delayed2_ex_dslot ? id_pc : id_pc;
						end


						13'b0_0001_xxxx_xxxx: begin
							except_type <= #1   4 'h2;
							eear <= #1 ex_dslot ? wb_pc : ex_pc;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;
						end


						13'b0_0000_1xxx_xxxx: begin
							except_type <= #1   4 'h7;
							eear <= #1 ex_pc;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;
						end


						13'b0_0000_01xx_xxxx: begin
							except_type <= #1   4 'h6;
							eear <= #1 lsu_addr;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;
						end


						13'b0_0000_001x_xxxx: begin
							except_type <= #1   4 'h9;
							eear <= #1 lsu_addr;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;
						end


						13'b0_0000_0001_xxxx: begin
							except_type <= #1   4 'h3;
							eear <= #1 lsu_addr;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;
						end


						13'b0_0000_0000_1xxx: begin	
							except_type <= #1   4 'h2;
							eear <= #1 lsu_addr;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;
						end


						13'b0_0000_0000_01xx: begin
							except_type <= #1   4 'hb;
							epcr <= #1 ex_dslot ? wb_pc : delayed1_ex_dslot ? id_pc : delayed2_ex_dslot ? id_pc : id_pc;
						end

			13'b0_0000_0000_001x: begin
							except_type <= #1   4 'he;
							epcr <= #1 ex_dslot ? wb_pc : ex_pc;
						end


						13'b0_0000_0000_0001: begin
							except_type <= #1   4 'hc;
							epcr <= #1 ex_dslot ? wb_pc : delayed1_ex_dslot ? id_pc : delayed2_ex_dslot ? id_pc : id_pc;
						end

						default:
							except_type <= #1   4 'h0;
					endcase
				end
				else if (pc_we) begin
					state <= #1   3 'd1;
					extend_flush <= #1 1'b1;
				end
				else begin
					if (epcr_we)
						epcr <= #1 datain;
					if (eear_we)
						eear <= #1 datain;
					if (esr_we)
						esr <= #1 {1'b1, datain[ 16-2:0]};
				end
			  3 'd1:
				if (icpu_ack_i | icpu_err_i | genpc_freeze)
					state <= #1   3 'd2;
			  3 'd2:

			        if (except_type ==   4 'he) begin
					state <= #1   3 'd0;
					extend_flush <= #1 1'b0;
					extend_flush_last <= #1 1'b0;
					except_type <= #1   4 'h0;
				end
                        	else

					state <= #1   3 'd3;
			  3 'd3:
					begin
						state <= #1   3 'd4;
					end
			  3 'd4: begin
					state <= #1   3 'd5;
					extend_flush <= #1 1'b0;
					extend_flush_last <= #1 1'b0; 
				end

			default: begin



				if (!if_stall && !id_freeze) begin
					state <= #1   3 'd0;
					except_type <= #1   4 'h0;
					extend_flush_last <= #1 1'b0;
				end
			end
		endcase
	end
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_freeze.v"




































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 101 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_freeze.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 103 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_freeze.v"











module or1200_freeze(
	
	clk, rst,

	
	multicycle, flushpipe, extend_flush, lsu_stall, if_stall,
	lsu_unstall, du_stall, mac_stall, 
	force_dslot_fetch, abort_ex,
	genpc_freeze, if_freeze, id_freeze, ex_freeze, wb_freeze,
	icpu_ack_i, icpu_err_i
);




input				clk;
input				rst;
input	[ 2-1:0]	multicycle;
input				flushpipe;
input				extend_flush;
input				lsu_stall;
input				if_stall;
input				lsu_unstall;
input				force_dslot_fetch;
input				abort_ex;
input				du_stall;
input				mac_stall;
output				genpc_freeze;
output				if_freeze;
output				id_freeze;
output				ex_freeze;
output				wb_freeze;
input				icpu_ack_i;
input				icpu_err_i;




wire				multicycle_freeze;
reg	[ 2-1:0]	multicycle_cnt;
reg				flushpipe_r;















assign genpc_freeze = du_stall | flushpipe_r;
assign if_freeze = id_freeze | extend_flush;

assign id_freeze = (lsu_stall | (~lsu_unstall & if_stall) | multicycle_freeze | force_dslot_fetch) | du_stall | mac_stall;
assign ex_freeze = wb_freeze;

assign wb_freeze = (lsu_stall | (~lsu_unstall & if_stall) | multicycle_freeze) | du_stall | mac_stall | abort_ex;




always @(posedge clk or posedge rst)
	if (rst)
		flushpipe_r <= #1 1'b0;
	else if (icpu_ack_i | icpu_err_i)

		flushpipe_r <= #1 flushpipe;
	else if (!flushpipe)
		flushpipe_r <= #1 1'b0;
		



assign multicycle_freeze = |multicycle_cnt;




always @(posedge clk or posedge rst)
	if (rst)
		multicycle_cnt <= #1 2'b00;
	else if (|multicycle_cnt)
		multicycle_cnt <= #1 multicycle_cnt - 2'd1;
	else if (|multicycle & !ex_freeze)
		multicycle_cnt <= #1 multicycle;

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_genpc.v"










































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 107 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_genpc.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 109 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_genpc.v"


module or1200_genpc(
	
	clk, rst,

	
	icpu_adr_o, icpu_cycstb_o, icpu_sel_o, icpu_tag_o,
	icpu_rty_i, icpu_adr_i,

	
	branch_op, except_type, except_prefix,
	branch_addrofs, lr_restor, flag, taken, except_start,
	binsn_addr, epcr, spr_dat_i, spr_pc_we, genpc_refetch,
	genpc_freeze, genpc_stop_prefetch, no_more_dslot
);








input				clk;
input				rst;




output	[31:0]			icpu_adr_o;
output				icpu_cycstb_o;
output	[3:0]			icpu_sel_o;
output	[3:0]			icpu_tag_o;
input				icpu_rty_i;
input	[31:0]			icpu_adr_i;




input	[ 3-1:0]	branch_op;
input	[ 4-1:0]	except_type;
input					except_prefix;
input	[31:2]			branch_addrofs;
input	[31:0]			lr_restor;
input				flag;
output				taken;
input				except_start;
input	[31:2]			binsn_addr;
input	[31:0]			epcr;
input	[31:0]			spr_dat_i;
input				spr_pc_we;
input				genpc_refetch;
input				genpc_stop_prefetch;
input				genpc_freeze;
input				no_more_dslot;




reg	[31:2]			pcreg;
reg	[31:0]			pc;
reg				taken;	
reg				genpc_refetch_r;




assign icpu_adr_o = !no_more_dslot & !except_start & !spr_pc_we & (icpu_rty_i | genpc_refetch) ? icpu_adr_i : pc;






assign icpu_cycstb_o = !genpc_freeze; 


assign icpu_sel_o = 4'b1111;
assign icpu_tag_o =  4'h1;




always @(posedge clk or posedge rst)
	if (rst)
		genpc_refetch_r <= #1 1'b0;
	else if (genpc_refetch)
		genpc_refetch_r <= #1 1'b1;
	else
		genpc_refetch_r <= #1 1'b0;




always @(pcreg or branch_addrofs or binsn_addr or flag or branch_op or except_type
	or except_start or lr_restor or epcr or spr_pc_we or spr_dat_i or except_prefix) begin
	casex ({spr_pc_we, except_start, branch_op})	
		{2'b00,  3'd0}: begin
			pc = {pcreg + 30'd1, 2'b0};
			taken = 1'b0;
		end
		{2'b00,  3'd1}: begin





			pc = {branch_addrofs, 2'b0};
			taken = 1'b1;
		end
		{2'b00,  3'd2}: begin





			pc = lr_restor;
			taken = 1'b1;
		end
		{2'b00,  3'd3}: begin





			pc = {binsn_addr + branch_addrofs, 2'b0};
			taken = 1'b1;
		end
		{2'b00,  3'd4}:
			if (flag) begin





				pc = {binsn_addr + branch_addrofs, 2'b0};
				taken = 1'b1;
			end
			else begin





				pc = {pcreg + 30'd1, 2'b0};
				taken = 1'b0;
			end
		{2'b00,  3'd5}:
			if (flag) begin
				pc = {pcreg + 30'd1, 2'b0};





				taken = 1'b0;
			end
			else begin





				pc = {binsn_addr + branch_addrofs, 2'b0};
				taken = 1'b1;
			end
		{2'b00,  3'd6}: begin





			pc = epcr;
			taken = 1'b1;
		end
		{2'b01, 3'bxxx}: begin





			pc = {(except_prefix ?  20'hF0000 :  20'h00000), except_type,  8'h00};
			taken = 1'b1;
		end
		default: begin





			pc = spr_dat_i;
			taken = 1'b0;
		end
	endcase
end




always @(posedge clk or posedge rst)
	if (rst)

		pcreg <= #1 ({(except_prefix ?  20'hF0000 :  20'h00000),   4 'h1,  8'h00} - 1) >> 2;
	else if (spr_pc_we)
		pcreg <= #1 spr_dat_i[31:2];
	else if (no_more_dslot | except_start | !genpc_freeze & !icpu_rty_i & !genpc_refetch)

		pcreg <= #1 pc[31:2];

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_gmultp2_32x32.v"









































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 74 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_gmultp2_32x32.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 76 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_gmultp2_32x32.v"











module or1200_gmultp2_32x32 ( X, Y, CLK, RST, P );

input   [ 32-1:0]  X;
input   [ 32-1:0]  Y;
input           CLK;
input           RST;
output  [ 64-1:0]  P;

reg     [ 64-1:0]  p0;
reg     [ 64-1:0]  p1;
integer 		  xi;
integer 		  yi;




always @(X)
	xi <= X;




always @(Y)
	yi <= Y;




always @(posedge CLK or posedge RST)
        if (RST)
                p0 <=  64'b0;
        else
                p0 <= #1 xi * yi;




always @(posedge CLK or posedge RST)
        if (RST)
                p1 <=  64'b0;
        else
                p1 <= #1 p0;

assign P = p1;

endmodule




`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_fsm.v"








































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 105 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_fsm.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 107 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_fsm.v"











module or1200_ic_fsm(
	
	clk, rst,

	
	ic_en, icqmem_cycstb_i, icqmem_ci_i,
	tagcomp_miss, biudata_valid, biudata_error, start_addr, saved_addr,
	icram_we, biu_read, first_hit_ack, first_miss_ack, first_miss_err,
	burst, tag_we
);




input				clk;
input				rst;
input				ic_en;
input				icqmem_cycstb_i;
input				icqmem_ci_i;
input				tagcomp_miss;
input				biudata_valid;
input				biudata_error;
input	[31:0]			start_addr;
output	[31:0]			saved_addr;
output	[3:0]			icram_we;
output				biu_read;
output				first_hit_ack;
output				first_miss_ack;
output				first_miss_err;
output				burst;
output				tag_we;




reg	[31:0]			saved_addr_r;
reg	[1:0]			state;
reg	[2:0]			cnt;
reg				hitmiss_eval;
reg				load;
reg				cache_inhibit;




assign icram_we = {4{biu_read & biudata_valid & !cache_inhibit}};
assign tag_we = biu_read & biudata_valid & !cache_inhibit;




assign biu_read = (hitmiss_eval & tagcomp_miss) | (!hitmiss_eval & load);


assign saved_addr = saved_addr_r;






assign first_hit_ack = (state ==  2'd1) & hitmiss_eval & !tagcomp_miss & !cache_inhibit & !icqmem_ci_i;
assign first_miss_ack = (state ==  2'd1) & biudata_valid;
assign first_miss_err = (state ==  2'd1) & biudata_error;




assign burst = (state ==  2'd1) & tagcomp_miss & !cache_inhibit
		| (state ==  2'd2);




always @(posedge clk or posedge rst) begin
	if (rst) begin
		state <= #1  2'd0;
		saved_addr_r <= #1 32'b0;
		hitmiss_eval <= #1 1'b0;
		load <= #1 1'b0;
		cnt <= #1 3'b000;
		cache_inhibit <= #1 1'b0;
	end
	else
	case (state)	
		 2'd0 :
			if (ic_en & icqmem_cycstb_i) begin		
				state <= #1  2'd1;
				saved_addr_r <= #1 start_addr;
				hitmiss_eval <= #1 1'b1;
				load <= #1 1'b1;
				cache_inhibit <= #1 1'b0;
			end
			else begin							
				hitmiss_eval <= #1 1'b0;
				load <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
		 2'd1: begin	
			if (icqmem_cycstb_i & icqmem_ci_i)
				cache_inhibit <= #1 1'b1;
			if (hitmiss_eval)
				saved_addr_r[31:13] <= #1 start_addr[31:13];
			if ((!ic_en) ||
			    (hitmiss_eval & !icqmem_cycstb_i) ||	
			    (biudata_error) ||						
			    (cache_inhibit & biudata_valid)) begin	
				state <= #1  2'd0;
				hitmiss_eval <= #1 1'b0;
				load <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
			else if (tagcomp_miss & biudata_valid) begin	
				state <= #1  2'd2;
				saved_addr_r[3:2] <= #1 saved_addr_r[3:2] + 1'd1;
				hitmiss_eval <= #1 1'b0;
				cnt <= #1  4-2;
				cache_inhibit <= #1 1'b0;
			end
			else if (!tagcomp_miss & !icqmem_ci_i) begin	
				saved_addr_r <= #1 start_addr;
				cache_inhibit <= #1 1'b0;
			end
			else if (!icqmem_cycstb_i) begin	
				state <= #1  2'd0;
				hitmiss_eval <= #1 1'b0;
				load <= #1 1'b0;
				cache_inhibit <= #1 1'b0;
			end
			else						
				hitmiss_eval <= #1 1'b0;
		end
		 2'd2 : begin
			if (biudata_valid && (|cnt)) begin		
				cnt <= #1 cnt - 3'd1;
				saved_addr_r[3:2] <= #1 saved_addr_r[3:2] + 1'd1;
			end
			else if (biudata_valid) begin			
				state <= #1  2'd0;
				saved_addr_r <= #1 start_addr;
				hitmiss_eval <= #1 1'b0;
				load <= #1 1'b0;
			end
		end
		default:
			state <= #1  2'd0;
	endcase
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_ram.v"





















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 86 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_ram.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 88 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_ram.v"


module or1200_ic_ram(
	
	clk, rst, 






	
	addr, en, we, datain, dataout
);

parameter dw =  32;
parameter aw =   13 - 2;




input 				clk;
input				rst;
input	[aw-1:0]		addr;
input				en;
input	[3:0]			we;
input	[dw-1:0]		datain;
output	[dw-1:0]		dataout;
































or1200_spram_2048x32 ic_ram0(







	.clk(clk),
	.rst(rst),
	.ce(en),
	.we(we[0]),
	.oe(1'b1),
	.addr(addr),
	.di(datain),
	.doq(dataout)
);



endmodule



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_tag.v"





















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 86 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_tag.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 88 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_tag.v"


module or1200_ic_tag(
	
	clk, rst,






	
	addr, en, we, datain, tag_v, tag
);

parameter dw =  20;
parameter aw =   13 -  4;








input				clk;
input				rst;













input	[aw-1:0]		addr;
input				en;
input				we;
input	[dw-1:0]		datain;
output				tag_v;
output	[dw-2:0]		tag;
























or1200_spram_512x20 ic_tag0(







	.clk(clk),
	.rst(rst),
	.ce(en),
	.we(we),
	.oe(1'b1),
	.addr(addr),
	.di(datain),
	.doq({tag, tag_v})
);



endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_top.v"




































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 101 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_top.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 103 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_ic_top.v"





module or1200_ic_top(
	
	clk, rst,

	
	icbiu_dat_o, icbiu_adr_o, icbiu_cyc_o, icbiu_stb_o, icbiu_we_o, icbiu_sel_o, icbiu_cab_o,
	icbiu_dat_i, icbiu_ack_i, icbiu_err_i,

	
	ic_en,
	icqmem_adr_i, icqmem_cycstb_i, icqmem_ci_i,
	icqmem_sel_i, icqmem_tag_i,
	icqmem_dat_o, icqmem_ack_o, icqmem_rty_o, icqmem_err_o, icqmem_tag_o,






	
	spr_cs, spr_write, spr_dat_i
);

parameter dw =  32;








input				clk;
input				rst;




output	[dw-1:0]		icbiu_dat_o;
output	[31:0]			icbiu_adr_o;
output				icbiu_cyc_o;
output				icbiu_stb_o;
output				icbiu_we_o;
output	[3:0]			icbiu_sel_o;
output				icbiu_cab_o;
input	[dw-1:0]		icbiu_dat_i;
input				icbiu_ack_i;
input				icbiu_err_i;




input				ic_en;
input	[31:0]			icqmem_adr_i;
input				icqmem_cycstb_i;
input				icqmem_ci_i;
input	[3:0]			icqmem_sel_i;
input	[3:0]			icqmem_tag_i;
output	[dw-1:0]		icqmem_dat_o;
output				icqmem_ack_o;
output				icqmem_rty_o;
output				icqmem_err_o;
output	[3:0]			icqmem_tag_o;













input				spr_cs;
input				spr_write;
input	[31:0]			spr_dat_i;




wire				tag_v;
wire	[ 20-2:0]	tag;
wire	[dw-1:0]		to_icram;
wire	[dw-1:0]		from_icram;
wire	[31:0]			saved_addr;
wire	[3:0]			icram_we;
wire				ictag_we;
wire	[31:0]			ic_addr;
wire				icfsm_biu_read;
reg				tagcomp_miss;
wire	[  13 - 1: 4]	ictag_addr;
wire				ictag_en;
wire				ictag_v; 
wire				ic_inv;
wire				icfsm_first_hit_ack;
wire				icfsm_first_miss_ack;
wire				icfsm_first_miss_err;
wire				icfsm_burst;
wire				icfsm_tag_we;














assign icbiu_adr_o = ic_addr;
assign ic_inv = spr_cs & spr_write;
assign ictag_we = icfsm_tag_we | ic_inv;
assign ictag_addr = ic_inv ? spr_dat_i[  13 - 1: 4] : ic_addr[  13 - 1: 4];
assign ictag_en = ic_inv | ic_en;
assign ictag_v = ~ic_inv;





assign icbiu_dat_o = 32'h00000000;




assign icbiu_cyc_o = (ic_en) ? icfsm_biu_read : icqmem_cycstb_i;
assign icbiu_stb_o = (ic_en) ? icfsm_biu_read : icqmem_cycstb_i;
assign icbiu_we_o = 1'b0;
assign icbiu_sel_o = (ic_en & icfsm_biu_read) ? 4'b1111 : icqmem_sel_i;
assign icbiu_cab_o = (ic_en) ? icfsm_burst : 1'b0;
assign icqmem_rty_o = ~icqmem_ack_o & ~icqmem_err_o;
assign icqmem_tag_o = icqmem_err_o ?  4'hb : icqmem_tag_i;




assign icqmem_ack_o = ic_en ? (icfsm_first_hit_ack | icfsm_first_miss_ack) : icbiu_ack_i;
assign icqmem_err_o = ic_en ? icfsm_first_miss_err : icbiu_err_i;




assign ic_addr = (icfsm_biu_read) ? saved_addr : icqmem_adr_i;




assign to_icram = icbiu_dat_i;




assign icqmem_dat_o = icfsm_first_miss_ack | !ic_en ? icbiu_dat_i : from_icram;




always @(tag or saved_addr or tag_v) begin
	if ((tag != saved_addr[31:   13 - 1 + 1]) || !tag_v)
		tagcomp_miss = 1'b1;
	else
		tagcomp_miss = 1'b0;
end




or1200_ic_fsm or1200_ic_fsm(
	.clk(clk),
	.rst(rst),
	.ic_en(ic_en),
	.icqmem_cycstb_i(icqmem_cycstb_i),
	.icqmem_ci_i(icqmem_ci_i),
	.tagcomp_miss(tagcomp_miss),
	.biudata_valid(icbiu_ack_i),
	.biudata_error(icbiu_err_i),
	.start_addr(icqmem_adr_i),
	.saved_addr(saved_addr),
	.icram_we(icram_we),
	.biu_read(icfsm_biu_read),
	.first_hit_ack(icfsm_first_hit_ack),
	.first_miss_ack(icfsm_first_miss_ack),
	.first_miss_err(icfsm_first_miss_err),
	.burst(icfsm_burst),
	.tag_we(icfsm_tag_we)
);




or1200_ic_ram or1200_ic_ram(
	.clk(clk),
	.rst(rst),






	.addr(ic_addr[  13 - 1:2]),
	.en(ic_en),
	.we(icram_we),
	.datain(to_icram),
	.dataout(from_icram)
);




or1200_ic_tag or1200_ic_tag(
	.clk(clk),
	.rst(rst),






	.addr(ictag_addr),
	.en(ictag_en),
	.we(ictag_we),
	.datain({ic_addr[31:   13 - 1 + 1], ictag_v}),
	.tag_v(tag_v),
	.tag(tag)
);

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_if.v"


















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 83 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_if.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 85 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_if.v"


module or1200_if(
	
	clk, rst,

	
	icpu_dat_i, icpu_ack_i, icpu_err_i, icpu_adr_i, icpu_tag_i,

	
	if_freeze, if_insn, if_pc, flushpipe,
	if_stall, no_more_dslot, genpc_refetch, rfe,
	except_itlbmiss, except_immufault, except_ibuserr
);








input				clk;
input				rst;




input	[31:0]			icpu_dat_i;
input				icpu_ack_i;
input				icpu_err_i;
input	[31:0]			icpu_adr_i;
input	[3:0]			icpu_tag_i;




input				if_freeze;
output	[31:0]			if_insn;
output	[31:0]			if_pc;
input				flushpipe;
output				if_stall;
input				no_more_dslot;
output				genpc_refetch;
input				rfe;
output				except_itlbmiss;
output				except_immufault;
output				except_ibuserr;




reg	[31:0]			insn_saved;
reg	[31:0]			addr_saved;
reg				saved;




assign if_insn = icpu_err_i | no_more_dslot | rfe ? { 6'b000101, 26'h041_0000} : saved ? insn_saved : icpu_ack_i ? icpu_dat_i : { 6'b000101, 26'h061_0000};
assign if_pc = saved ? addr_saved : icpu_adr_i;

assign if_stall = !icpu_err_i & !icpu_ack_i & !saved;
assign genpc_refetch = saved & icpu_ack_i;
assign except_itlbmiss = icpu_err_i & (icpu_tag_i ==  4'hd) & !no_more_dslot;
assign except_immufault = icpu_err_i & (icpu_tag_i ==  4'hc) & !no_more_dslot;
assign except_ibuserr = icpu_err_i & (icpu_tag_i ==  4'hb) & !no_more_dslot;




always @(posedge clk or posedge rst)
	if (rst)
		saved <= #1 1'b0;
	else if (flushpipe)
		saved <= #1 1'b0;
	else if (icpu_ack_i & if_freeze & !saved)
		saved <= #1 1'b1;
	else if (!if_freeze)
		saved <= #1 1'b0;




always @(posedge clk or posedge rst)
	if (rst)
		insn_saved <= #1 { 6'b000101, 26'h041_0000};
	else if (flushpipe)
		insn_saved <= #1 { 6'b000101, 26'h041_0000};
	else if (icpu_ack_i & if_freeze & !saved)
		insn_saved <= #1 icpu_dat_i;
	else if (!if_freeze)
		insn_saved <= #1 { 6'b000101, 26'h041_0000};




always @(posedge clk or posedge rst)
	if (rst)
		addr_saved <= #1 32'h00000000;
	else if (flushpipe)
		addr_saved <= #1 32'h00000000;
	else if (icpu_ack_i & if_freeze & !saved)
		addr_saved <= #1 icpu_adr_i;
	else if (!if_freeze)
		addr_saved <= #1 icpu_adr_i;

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_immu_tlb.v"





















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 86 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_immu_tlb.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 88 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_immu_tlb.v"






module or1200_immu_tlb(
	
	clk, rst,

	
	tlb_en, vaddr, hit, ppn, uxe, sxe, ci, 






	
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o
);

parameter dw =  32;
parameter aw =  32;








input				clk;
input				rst;




input				tlb_en;
input	[aw-1:0]		vaddr;
output				hit;
output	[31: 13]	ppn;
output				uxe;
output				sxe;
output				ci;













input				spr_cs;
input				spr_write;
input	[31:0]			spr_addr;
input	[31:0]			spr_dat_i;
output	[31:0]			spr_dat_o;




wire	[ 31 :    13 +  6 - 1 + 1]	vpn;
wire				v;
wire	[ 6-1:0]	tlb_index;
wire				tlb_mr_en;
wire				tlb_mr_we;
wire	[  32 -  6 -  13 + 1-1:0]	tlb_mr_ram_in;
wire	[  32 -  6 -  13 + 1-1:0]	tlb_mr_ram_out;
wire				tlb_tr_en;
wire				tlb_tr_we;
wire	[ 32 -  13 + 3-1:0]	tlb_tr_ram_in;
wire	[ 32 -  13 + 3-1:0]	tlb_tr_ram_out;

























assign tlb_mr_en = tlb_en | (spr_cs & !spr_addr[ 7]);




assign tlb_mr_we = spr_cs & spr_write & !spr_addr[ 7];




assign tlb_tr_en = tlb_en | (spr_cs & spr_addr[ 7]);




assign tlb_tr_we = spr_cs & spr_write & spr_addr[ 7];




assign spr_dat_o = (!spr_write & !spr_addr[ 7]) ?
			{vpn, tlb_index & { 6{v}}, { 32 -  6 -  13-7{1'b0}}, 1'b0, 5'b00000, v} :
		(!spr_write & spr_addr[ 7]) ?
			{ppn, { 13-8{1'b0}}, uxe, sxe, {4{1'b0}}, ci, 1'b0} :
			32'h00000000;




assign {vpn, v} = tlb_mr_ram_out;




assign tlb_mr_ram_in = {spr_dat_i[ 31 :    13 +  6 - 1 + 1], spr_dat_i[ 0]};




assign {ppn, uxe, sxe, ci} = tlb_tr_ram_out;




assign tlb_tr_ram_in = {spr_dat_i[31: 13],
			spr_dat_i[ 7],
			spr_dat_i[ 6],
			spr_dat_i[ 1]};




assign hit = (vpn == vaddr[ 31 :    13 +  6 - 1 + 1]) & v;





assign tlb_index = spr_cs ? spr_addr[ 6-1:0] : vaddr[   13 +  6 - 1 :   13];












or1200_spram_64x14 itlb_mr_ram(
	.clk(clk),
	.rst(rst),






	.ce(tlb_mr_en),
	.we(tlb_mr_we),
	.oe(1'b1),
	.addr(tlb_index),
	.di(tlb_mr_ram_in),
	.doq(tlb_mr_ram_out)
);




or1200_spram_64x22 itlb_tr_ram(
	.clk(clk),
	.rst(rst),






	.ce(tlb_tr_en),
	.we(tlb_tr_we),
	.oe(1'b1),
	.addr(tlb_index),
	.di(tlb_tr_ram_in),
	.doq(tlb_tr_ram_out)
);

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_immu_top.v"



















































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 116 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_immu_top.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 118 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_immu_top.v"






module or1200_immu_top(
	
	clk, rst,

	
	ic_en, immu_en, supv, icpu_adr_i, icpu_cycstb_i,
	icpu_adr_o, icpu_tag_o, icpu_rty_o, icpu_err_o,

	
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o,






	
	qmemimmu_rty_i, qmemimmu_err_i, qmemimmu_tag_i, qmemimmu_adr_o, qmemimmu_cycstb_o, qmemimmu_ci_o
);

parameter dw =  32;
parameter aw =  32;








input				clk;
input				rst;




input				ic_en;
input				immu_en;
input				supv;
input	[aw-1:0]		icpu_adr_i;
input				icpu_cycstb_i;
output	[aw-1:0]		icpu_adr_o;
output	[3:0]			icpu_tag_o;
output				icpu_rty_o;
output				icpu_err_o;




input				spr_cs;
input				spr_write;
input	[aw-1:0]		spr_addr;
input	[31:0]			spr_dat_i;
output	[31:0]			spr_dat_o;













input				qmemimmu_rty_i;
input				qmemimmu_err_i;
input	[3:0]			qmemimmu_tag_i;
output	[aw-1:0]		qmemimmu_adr_o;
output				qmemimmu_cycstb_o;
output				qmemimmu_ci_o;




wire				itlb_spr_access;
wire	[31: 13]	itlb_ppn;
wire				itlb_hit;
wire				itlb_uxe;
wire				itlb_sxe;
wire	[31:0]			itlb_dat_o;
wire				itlb_en;
wire				itlb_ci;
wire				itlb_done;
wire				fault;
wire				miss;
wire				page_cross;
reg	[31:0]			icpu_adr_o;
reg	[31: 13]	icpu_vpn_r;























always @(posedge rst or posedge clk)
	if (rst)
		icpu_adr_o <= #1 32'h0000_0100;
	else
		icpu_adr_o <= #1 icpu_adr_i;









assign page_cross = icpu_adr_i[31: 13] != icpu_vpn_r;





always @(posedge clk or posedge rst)
	if (rst)
		icpu_vpn_r <= #1 {32- 13{1'b0}};
	else
		icpu_vpn_r <= #1 icpu_adr_i[31: 13];






assign spr_dat_o = 32'h00000000;
assign qmemimmu_adr_o = icpu_adr_i;
assign icpu_tag_o = qmemimmu_tag_i;
assign qmemimmu_cycstb_o = icpu_cycstb_i & ~page_cross;
assign icpu_rty_o = qmemimmu_rty_i;
assign icpu_err_o = qmemimmu_err_i;
assign qmemimmu_ci_o =  1'b0;





















































































































































endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_iwb_biu.v"












































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 109 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_iwb_biu.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 111 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_iwb_biu.v"


module or1200_iwb_biu(
	
	clk, rst, clmode,

	
	wb_clk_i, wb_rst_i, wb_ack_i, wb_err_i, wb_rty_i, wb_dat_i,
	wb_cyc_o, wb_adr_o, wb_stb_o, wb_we_o, wb_sel_o, wb_dat_o,

	wb_cab_o,





	
	biu_dat_i, biu_adr_i, biu_cyc_i, biu_stb_i, biu_we_i, biu_sel_i, biu_cab_i,
	biu_dat_o, biu_ack_o, biu_err_o
);

parameter dw =  32;
parameter aw =  32;




input			clk;		
input			rst;		
input	[1:0]		clmode;		




input			wb_clk_i;	
input			wb_rst_i;	
input			wb_ack_i;	
input			wb_err_i;	
input			wb_rty_i;	
input	[dw-1:0]	wb_dat_i;	
output			wb_cyc_o;	
output	[aw-1:0]	wb_adr_o;	
output			wb_stb_o;	
output			wb_we_o;	
output	[3:0]		wb_sel_o;	
output	[dw-1:0]	wb_dat_o;	

output			wb_cab_o;	









input	[dw-1:0]	biu_dat_i;	
input	[aw-1:0]	biu_adr_i;	
input			biu_cyc_i;	
input			biu_stb_i;	
input			biu_we_i;	
input			biu_cab_i;	
input	[3:0]		biu_sel_i;	
output	[31:0]		biu_dat_o;	
output			biu_ack_o;	
output			biu_err_o;	




reg	[1:0]		valid_div;	

reg	[aw-1:0]	wb_adr_o;	
reg			wb_cyc_o;	
reg			wb_stb_o;	
reg			wb_we_o;	
reg	[3:0]		wb_sel_o;	

reg			wb_cab_o;	





reg	[dw-1:0]	wb_dat_o;	






wire			long_ack_o;	
wire			long_err_o;	

wire			aborted;	
reg			aborted_r;	
wire			retry;		



reg			previous_complete;
wire			same_addr;
wire			repeated_access;
reg			repeated_access_ack;
reg	[dw-1:0]	wb_dat_r;	









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_adr_o <= #1 {aw{1'b0}};
	else if ((biu_cyc_i & biu_stb_i) & ~wb_ack_i & ~aborted & ~(wb_stb_o & ~wb_ack_i) | biu_cab_i & (previous_complete | biu_ack_o))
		wb_adr_o <= #1 biu_adr_i;







assign same_addr = wb_adr_o == biu_adr_i;
assign repeated_access = same_addr & previous_complete;
always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_dat_r <= #1 32'h0000_0000;
	else if (wb_ack_i)
		wb_dat_r <= #1 wb_dat_i;

always @(posedge clk or posedge rst)
	if (rst)
		repeated_access_ack <= #1 1'b0;
	else if (repeated_access & biu_cyc_i & biu_stb_i)
		repeated_access_ack <= #1 1'b1;
	else
		repeated_access_ack <= #1 1'b0;




always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		previous_complete <= #1 1'b1;
	else if (wb_ack_i & biu_cyc_i & biu_stb_i)
		previous_complete <= #1 1'b1;
	else if ((biu_cyc_i & biu_stb_i) & ~wb_ack_i & ~aborted & ~(wb_stb_o & ~wb_ack_i))
		previous_complete <= #1 1'b0;











assign biu_dat_o = repeated_access_ack ? wb_dat_r : wb_dat_i;






always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_dat_o <= #1 {dw{1'b0}};
	else if ((biu_cyc_i & biu_stb_i) & ~wb_ack_i & ~aborted)
		wb_dat_o <= #1 biu_dat_i;









always @(posedge clk or posedge rst)
	if (rst)
		valid_div <= #1 2'b0;
	else
		valid_div <= #1 valid_div + 1'd1;






assign biu_ack_o = (repeated_access_ack | long_ack_o) & ~aborted_r






		;













assign long_ack_o = wb_ack_i;







assign biu_err_o = long_err_o






		;













assign long_err_o = wb_err_i & ~aborted_r;











assign retry = 1'b0;






















assign aborted = wb_stb_o & ~(biu_cyc_i & biu_stb_i) & ~(wb_ack_i | wb_err_i);
always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		aborted_r <= #1 1'b0;
	else if (wb_ack_i | wb_err_i)
		aborted_r <= #1 1'b0;
	else if (aborted)
		aborted_r <= #1 1'b1;









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_cyc_o <= #1 1'b0;
	else



		wb_cyc_o <= #1 biu_cyc_i & ~wb_ack_i & ~retry & ~repeated_access | biu_cab_i | aborted & ~wb_ack_i;













always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_stb_o <= #1 1'b0;
	else
		wb_stb_o <= #1 (biu_cyc_i & biu_stb_i) & ~wb_ack_i & ~retry & ~repeated_access | aborted & ~wb_ack_i;








always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_we_o <= #1 1'b0;
	else
		wb_we_o <= #1 biu_cyc_i & biu_stb_i & biu_we_i | aborted & wb_we_o;








always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_sel_o <= #1 4'b0000;
	else
		wb_sel_o <= #1 biu_sel_i;









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_cab_o <= #1 1'b0;
	else
		wb_cab_o <= #1 biu_cab_i;










































	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_lsu.v"


















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 83 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_lsu.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 85 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_lsu.v"


module or1200_lsu(

	
	addrbase, addrofs, lsu_op, lsu_datain, lsu_dataout, lsu_stall, lsu_unstall,
        du_stall, except_align, except_dtlbmiss, except_dmmufault, except_dbuserr,

	
	dcpu_adr_o, dcpu_cycstb_o, dcpu_we_o, dcpu_sel_o, dcpu_tag_o, dcpu_dat_o,
	dcpu_dat_i, dcpu_ack_i, dcpu_rty_i, dcpu_err_i, dcpu_tag_i
);

parameter dw =  32;
parameter aw =  5;








input	[31:0]			addrbase;
input	[31:0]			addrofs;
input	[ 4-1:0]	lsu_op;
input	[dw-1:0]		lsu_datain;
output	[dw-1:0]		lsu_dataout;
output				lsu_stall;
output				lsu_unstall;
input                           du_stall;
output				except_align;
output				except_dtlbmiss;
output				except_dmmufault;
output				except_dbuserr;




output	[31:0]			dcpu_adr_o;
output				dcpu_cycstb_o;
output				dcpu_we_o;
output	[3:0]			dcpu_sel_o;
output	[3:0]			dcpu_tag_o;
output	[31:0]			dcpu_dat_o;
input	[31:0]			dcpu_dat_i;
input				dcpu_ack_i;
input				dcpu_rty_i;
input				dcpu_err_i;
input	[3:0]			dcpu_tag_i;




reg	[3:0]			dcpu_sel_o;




assign lsu_stall = dcpu_rty_i & dcpu_cycstb_o;
assign lsu_unstall = dcpu_ack_i;
assign except_align = ((lsu_op ==  4'b1100) | (lsu_op ==  4'b0100) | (lsu_op ==  4'b0101)) & dcpu_adr_o[0]
		|  ((lsu_op ==  4'b1110) | (lsu_op ==  4'b0110) | (lsu_op ==  4'b0111)) & |dcpu_adr_o[1:0];
assign except_dtlbmiss = dcpu_err_i & (dcpu_tag_i ==  4'hd);
assign except_dmmufault = dcpu_err_i & (dcpu_tag_i ==  4'hc);
assign except_dbuserr = dcpu_err_i & (dcpu_tag_i ==  4'hb);




assign dcpu_adr_o = addrbase + addrofs;
assign dcpu_cycstb_o = du_stall | lsu_unstall | except_align ? 1'b0 : |lsu_op;
assign dcpu_we_o = lsu_op[3];
assign dcpu_tag_o = dcpu_cycstb_o ?  4'h1 :  4'h0;
always @(lsu_op or dcpu_adr_o)
	casex({lsu_op, dcpu_adr_o[1:0]})
		{ 4'b1010, 2'b00} : dcpu_sel_o = 4'b1000;
		{ 4'b1010, 2'b01} : dcpu_sel_o = 4'b0100;
		{ 4'b1010, 2'b10} : dcpu_sel_o = 4'b0010;
		{ 4'b1010, 2'b11} : dcpu_sel_o = 4'b0001;
		{ 4'b1100, 2'b00} : dcpu_sel_o = 4'b1100;
		{ 4'b1100, 2'b10} : dcpu_sel_o = 4'b0011;
		{ 4'b1110, 2'b00} : dcpu_sel_o = 4'b1111;
		{ 4'b0010, 2'b00}, { 4'b0011, 2'b00} : dcpu_sel_o = 4'b1000;
		{ 4'b0010, 2'b01}, { 4'b0011, 2'b01} : dcpu_sel_o = 4'b0100;
		{ 4'b0010, 2'b10}, { 4'b0011, 2'b10} : dcpu_sel_o = 4'b0010;
		{ 4'b0010, 2'b11}, { 4'b0011, 2'b11} : dcpu_sel_o = 4'b0001;
		{ 4'b0100, 2'b00}, { 4'b0101, 2'b00} : dcpu_sel_o = 4'b1100;
		{ 4'b0100, 2'b10}, { 4'b0101, 2'b10} : dcpu_sel_o = 4'b0011;
		{ 4'b0110, 2'b00}, { 4'b0111, 2'b00} : dcpu_sel_o = 4'b1111;
		default : dcpu_sel_o = 4'b0000;
	endcase




or1200_mem2reg or1200_mem2reg(
	.addr(dcpu_adr_o[1:0]),
	.lsu_op(lsu_op),
	.memdata(dcpu_dat_i),
	.regdata(lsu_dataout)
);




or1200_reg2mem or1200_reg2mem(
        .addr(dcpu_adr_o[1:0]),
        .lsu_op(lsu_op),
        .regdata(lsu_datain),
        .memdata(dcpu_dat_o)
);

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_mem2reg.v"


















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 83 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_mem2reg.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 85 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_mem2reg.v"


module or1200_mem2reg(addr, lsu_op, memdata, regdata);

parameter width =  32;




input	[1:0]			addr;
input	[ 4-1:0]	lsu_op;
input	[width-1:0]		memdata;
output	[width-1:0]		regdata;



























































































































































































































































































reg	[width-1:0]		regdata;
reg	[width-1:0]		aligned;




always @(addr or memdata) begin



	case(addr) 

		2'b00:
			aligned = memdata;
		2'b01:
			aligned = {memdata[23:0], 8'b0};
		2'b10:
			aligned = {memdata[15:0], 16'b0};
		2'b11:
			aligned = {memdata[7:0], 24'b0};
	endcase
end




always @(lsu_op or aligned) begin



	case(lsu_op) 

		 4'b0010: begin
				regdata[7:0] = aligned[31:24];
				regdata[31:8] = 24'b0;
			end
		 4'b0011: begin
				regdata[7:0] = aligned[31:24];
				regdata[31:8] = {24{aligned[31]}};
			end
		 4'b0100: begin
				regdata[15:0] = aligned[31:16];
				regdata[31:16] = 16'b0;
			end
		 4'b0101: begin
				regdata[15:0] = aligned[31:16];
				regdata[31:16] = {16{aligned[31]}};
			end
		default:
				regdata = aligned;
	endcase
end



endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_mult_mac.v"







































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 72 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_mult_mac.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 74 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_mult_mac.v"


module or1200_mult_mac(
	
	clk, rst,

	
	ex_freeze, id_macrc_op, macrc_op, a, b, mac_op, alu_op, result, mac_stall_r,

	
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o
);

parameter width =  32;








input				clk;
input				rst;




input				ex_freeze;
input				id_macrc_op;
input				macrc_op;
input	[width-1:0]		a;
input	[width-1:0]		b;
input	[ 2-1:0]	mac_op;
input	[ 4-1:0]	alu_op;
output	[width-1:0]		result;
output				mac_stall_r;




input				spr_cs;
input				spr_write;
input	[31:0]			spr_addr;
input	[31:0]			spr_dat_i;
output	[31:0]			spr_dat_o;





reg	[width-1:0]		result;
reg	[2*width-1:0]		mul_prod_r;




wire	[2*width-1:0]		mul_prod;
wire	[ 2-1:0]	mac_op;

reg	[ 2-1:0]	mac_op_r1;
reg	[ 2-1:0]	mac_op_r2;
reg	[ 2-1:0]	mac_op_r3;
reg				mac_stall_r;
reg	[2*width-1:0]		mac_r;







wire	[width-1:0]		x;
wire	[width-1:0]		y;
wire				spr_maclo_we;
wire				spr_machi_we;
wire				alu_op_div_divu;
wire				alu_op_div;
reg				div_free;









assign spr_maclo_we = spr_cs & spr_write & spr_addr[ 0];
assign spr_machi_we = spr_cs & spr_write & !spr_addr[ 0];
assign spr_dat_o = spr_addr[ 0] ? mac_r[31:0] : mac_r[63:32];









assign x = alu_op_div & a[31] ? ~a + 32'b1 : a;
assign y = alu_op_div & b[31] ? ~b + 32'b1 : b;






assign alu_op_div = 1'b0;
assign alu_op_div_divu = 1'b0;








always @(alu_op or mul_prod_r or mac_r or a or b)
	casex(alu_op)	





		 4'd6: begin
			result = mul_prod_r[31:0];
		end
		default:
			result = mac_r[59:28];
	endcase












 
or1200_gmultp2_32x32 or1200_gmultp2_32x32(
	.X(x),
	.Y(y),
	.RST(rst),
	.CLK(clk),
	.P(mul_prod)
);
 





always @(posedge rst or posedge clk)
	if (rst) begin
		mul_prod_r <= #1 64'h0000_0000_0000_0000;
		div_free <= #1 1'b1;



	end













 
	else if (div_free | !ex_freeze) begin
		mul_prod_r <= #1 mul_prod[63:0];
		div_free <= #1 1'b1;
	end





 






always @(posedge clk or posedge rst)
	if (rst)
		mac_op_r1 <= #1  2'b0;
	else
		mac_op_r1 <= #1 mac_op;




always @(posedge clk or posedge rst)
	if (rst)
		mac_op_r2 <= #1  2'b0;
	else
		mac_op_r2 <= #1 mac_op_r1;




always @(posedge clk or posedge rst)
	if (rst)
		mac_op_r3 <= #1  2'b0;
	else
		mac_op_r3 <= #1 mac_op_r2;




always @(posedge rst or posedge clk)
	if (rst)
		mac_r <= #1 64'h0000_0000_0000_0000;

	else if (spr_maclo_we)
		mac_r[31:0] <= #1 spr_dat_i;
	else if (spr_machi_we)
		mac_r[63:32] <= #1 spr_dat_i;

	else if (mac_op_r3 ==  2'b01)
		mac_r <= #1 mac_r + mul_prod_r;
	else if (mac_op_r3 ==  2'b10)
		mac_r <= #1 mac_r - mul_prod_r;
	else if (macrc_op & !ex_freeze)
		mac_r <= #1 64'h0000_0000_0000_0000;






always @(posedge rst or posedge clk)
	if (rst)
		mac_stall_r <= #1 1'b0;
	else
		mac_stall_r <= #1 (|mac_op | (|mac_op_r1) | (|mac_op_r2)) & id_macrc_op



				;






 

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_operandmuxes.v"









































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 74 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_operandmuxes.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 76 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_operandmuxes.v"


module or1200_operandmuxes(
	
	clk, rst,

	
	id_freeze, ex_freeze, rf_dataa, rf_datab, ex_forw, wb_forw,
	simm, sel_a, sel_b, operand_a, operand_b, muxed_b
);

parameter width =  32;




input				clk;
input				rst;
input				id_freeze;
input				ex_freeze;
input	[width-1:0]		rf_dataa;
input	[width-1:0]		rf_datab;
input	[width-1:0]		ex_forw;
input	[width-1:0]		wb_forw;
input	[width-1:0]		simm;
input	[ 2-1:0]	sel_a;
input	[ 2-1:0]	sel_b;
output	[width-1:0]		operand_a;
output	[width-1:0]		operand_b;
output	[width-1:0]		muxed_b;




reg	[width-1:0]		operand_a;
reg	[width-1:0]		operand_b;
reg	[width-1:0]		muxed_a;
reg	[width-1:0]		muxed_b;
reg				saved_a;
reg				saved_b;




always @(posedge clk or posedge rst) begin
	if (rst) begin
		operand_a <= #1 32'd0;
		saved_a <= #1 1'b0;
	end else if (!ex_freeze && id_freeze && !saved_a) begin
		operand_a <= #1 muxed_a;
		saved_a <= #1 1'b1;
	end else if (!ex_freeze && !saved_a) begin
		operand_a <= #1 muxed_a;
	end else if (!ex_freeze && !id_freeze)
		saved_a <= #1 1'b0;
end




always @(posedge clk or posedge rst) begin
	if (rst) begin
		operand_b <= #1 32'd0;
		saved_b <= #1 1'b0;
	end else if (!ex_freeze && id_freeze && !saved_b) begin
		operand_b <= #1 muxed_b;
		saved_b <= #1 1'b1;
	end else if (!ex_freeze && !saved_b) begin
		operand_b <= #1 muxed_b;
	end else if (!ex_freeze && !id_freeze)
		saved_b <= #1 1'b0;
end




always @(ex_forw or wb_forw or rf_dataa or sel_a) begin



	casex (sel_a)	

		 2'd2:
			muxed_a = ex_forw;
		 2'd3:
			muxed_a = wb_forw;
		default:
			muxed_a = rf_dataa;
	endcase
end




always @(simm or ex_forw or wb_forw or rf_datab or sel_b) begin



	casex (sel_b)	

		 2'd1:
			muxed_b = simm;
		 2'd2:
			muxed_b = ex_forw;
		 2'd3:
			muxed_b = wb_forw;
		default:
			muxed_b = rf_datab;
	endcase
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_pic.v"












































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 77 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_pic.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 79 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_pic.v"


module or1200_pic(
	
	clk, rst, spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o,
	pic_wakeup, intr,
	
	
	pic_int
);




input		clk;		
input		rst;		
input		spr_cs;		
input		spr_write;	
input	[31:0]	spr_addr;	
input	[31:0]	spr_dat_i;	
output	[31:0]	spr_dat_o;	
output		pic_wakeup;	
output		intr;		
				




input	[ 20-1:0]	pic_int;







reg	[ 20-1:2]	picmr;	








reg	[ 20-1:0]	picsr;	







wire		picmr_sel;	
wire		picsr_sel;	
wire	[ 20-1:0] um_ints;
reg	[31:0] 	spr_dat_o;	




assign picmr_sel = (spr_cs && (spr_addr[ 1 : 0] ==  2'd0)) ? 1'b1 : 1'b0;
assign picsr_sel = (spr_cs && (spr_addr[ 1 : 0] ==  2'd2)) ? 1'b1 : 1'b0;





always @(posedge clk or posedge rst)
	if (rst)
		picmr <= {1'b1, { 20-3{1'b0}}};
	else if (picmr_sel && spr_write) begin
		picmr <= #1 spr_dat_i[ 20-1:2];
	end








always @(posedge clk or posedge rst)
	if (rst)
		picsr <= { 20{1'b0}};
	else if (picsr_sel && spr_write) begin
		picsr <= #1 spr_dat_i[ 20-1:0] | um_ints;
	end else
		picsr <= #1 picsr | um_ints;







always @(spr_addr or picmr or picsr)
	case (spr_addr[ 1 : 0])	

		 2'd0: begin
					spr_dat_o[ 20-1:0] = {picmr, 2'b0};

					spr_dat_o[31: 20] = {32- 20{1'b0}};

				end

		default: begin
				spr_dat_o[ 20-1:0] = picsr;

				spr_dat_o[31: 20] = {32- 20{1'b0}};

			end
	endcase




assign um_ints = pic_int & {picmr, 2'b11};




assign intr = |um_ints;




assign pic_wakeup = intr;





















endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_pm.v"



































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 68 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_pm.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 70 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_pm.v"


module or1200_pm(
	
	clk, rst, pic_wakeup, spr_write, spr_addr, spr_dat_i, spr_dat_o,
	
	
	pm_clksd, pm_cpustall, pm_dc_gate, pm_ic_gate, pm_dmmu_gate,
	pm_immu_gate, pm_tt_gate, pm_cpu_gate, pm_wakeup, pm_lvolt
);




input		clk;		
input		rst;		
input		pic_wakeup;	
input		spr_write;	
input	[31:0]	spr_addr;	
input	[31:0]	spr_dat_i;	
output	[31:0]	spr_dat_o;	




input		pm_cpustall;	
output	[3:0]	pm_clksd;	
output		pm_dc_gate;	
output		pm_ic_gate;	
output		pm_dmmu_gate;	
output		pm_immu_gate;	
output		pm_tt_gate;	
output		pm_cpu_gate;	
output		pm_wakeup;	
output		pm_lvolt;	






reg	[3:0]	sdf;	
reg		dme;	
reg		sme;	
reg		dcge;	




wire		pmr_sel; 





assign pmr_sel = (spr_addr[ 15 : 11] ==  5'd8) ? 1'b1 : 1'b0;









always @(posedge clk or posedge rst)
	if (rst)
		{dcge, sme, dme, sdf} <= 7'b0;
	else if (pmr_sel && spr_write) begin
		sdf <= #1 spr_dat_i[ 3 : 0];
		dme <= #1 spr_dat_i[ 4];
		sme <= #1 spr_dat_i[ 5];
		dcge <= #1 spr_dat_i[ 6];
	end
	else if (pic_wakeup) begin
		dme <= #1 1'b0;
		sme <= #1 1'b0;
	end





assign spr_dat_o[ 3 : 0] = sdf;
assign spr_dat_o[ 4] = dme;
assign spr_dat_o[ 5] = sme;
assign spr_dat_o[ 6] = dcge;

assign spr_dat_o[ 31 : 7] = 25'b0;






assign pm_clksd = sdf;





assign pm_cpu_gate = (dme | sme) & ~pic_wakeup;
assign pm_dc_gate = pm_cpu_gate;
assign pm_ic_gate = pm_cpu_gate;
assign pm_dmmu_gate = pm_cpu_gate;
assign pm_immu_gate = pm_cpu_gate;
assign pm_tt_gate = sme & ~pic_wakeup;




assign pm_wakeup = pic_wakeup;




assign pm_lvolt = pm_cpu_gate | pm_cpustall;































endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_qmem_top.v"






































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 71 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_qmem_top.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 73 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_qmem_top.v"










module or1200_qmem_top(
	
	clk, rst,






	
	qmemimmu_adr_i,
	qmemimmu_cycstb_i,
	qmemimmu_ci_i,
	qmemicpu_sel_i, 
	qmemicpu_tag_i, 
	qmemicpu_dat_o,
	qmemicpu_ack_o,
	qmemimmu_rty_o,
	qmemimmu_err_o,
	qmemimmu_tag_o,

	
	icqmem_adr_o,
	icqmem_cycstb_o,
	icqmem_ci_o,  
	icqmem_sel_o,
	icqmem_tag_o,
	icqmem_dat_i,
	icqmem_ack_i,
	icqmem_rty_i,
	icqmem_err_i,
	icqmem_tag_i,

	
	qmemdmmu_adr_i,
	qmemdmmu_cycstb_i,
	qmemdmmu_ci_i,
	qmemdcpu_we_i,   
	qmemdcpu_sel_i, 
	qmemdcpu_tag_i, 
	qmemdcpu_dat_i, 
	qmemdcpu_dat_o,
	qmemdcpu_ack_o,
	qmemdcpu_rty_o,
	qmemdmmu_err_o,
	qmemdmmu_tag_o,

	
	dcqmem_adr_o, dcqmem_cycstb_o, dcqmem_ci_o,
	dcqmem_we_o, dcqmem_sel_o, dcqmem_tag_o, dcqmem_dat_o,
	dcqmem_dat_i, dcqmem_ack_i, dcqmem_rty_i, dcqmem_err_i, dcqmem_tag_i

);

parameter dw =  32;








input				clk;
input				rst;













input	[31:0]			qmemimmu_adr_i;
input				qmemimmu_cycstb_i;
input				qmemimmu_ci_i;
input	[3:0]			qmemicpu_sel_i; 
input	[3:0]			qmemicpu_tag_i; 
output	[31:0]			qmemicpu_dat_o;
output				qmemicpu_ack_o;
output				qmemimmu_rty_o;
output				qmemimmu_err_o;
output	[3:0]			qmemimmu_tag_o;




output	[31:0]			icqmem_adr_o;
output				icqmem_cycstb_o;
output				icqmem_ci_o;
output	[3:0]			icqmem_sel_o;
output	[3:0]			icqmem_tag_o;
input	[31:0]			icqmem_dat_i;
input				icqmem_ack_i;
input				icqmem_rty_i;
input				icqmem_err_i;
input	[3:0]			icqmem_tag_i;




input	[31:0]			qmemdmmu_adr_i;
input				qmemdmmu_cycstb_i;
input				qmemdmmu_ci_i;
input				qmemdcpu_we_i;
input	[3:0]			qmemdcpu_sel_i; 
input	[3:0]			qmemdcpu_tag_i; 
input	[31:0]			qmemdcpu_dat_i; 
output	[31:0]			qmemdcpu_dat_o;
output				qmemdcpu_ack_o;
output				qmemdcpu_rty_o;
output				qmemdmmu_err_o;
output	[3:0]			qmemdmmu_tag_o;




output	[31:0]			dcqmem_adr_o;
output				dcqmem_cycstb_o;
output				dcqmem_ci_o;
output				dcqmem_we_o;
output	[3:0]			dcqmem_sel_o;
output	[3:0]			dcqmem_tag_o;
output	[dw-1:0]		dcqmem_dat_o;
input	[dw-1:0]		dcqmem_dat_i;
input				dcqmem_ack_i;
input				dcqmem_rty_i;
input				dcqmem_err_i;
input	[3:0]			dcqmem_tag_i;






wire				iaddr_qmem_hit;
wire				daddr_qmem_hit;
reg	[2:0]			state;
reg				qmem_dack;
reg				qmem_iack;
wire	[31:0]			qmem_di;
wire	[31:0]			qmem_do;
wire				qmem_en;
wire				qmem_we;



wire	[31:0]			qmem_addr;



wire              qmem_ack = 1'b1;





assign qmemicpu_dat_o = qmem_iack ? qmem_do : icqmem_dat_i;
assign qmemicpu_ack_o = qmem_iack ? 1'b1 : icqmem_ack_i;
assign qmemimmu_rty_o = qmem_iack ? 1'b0 : icqmem_rty_i;
assign qmemimmu_err_o = qmem_iack ? 1'b0 : icqmem_err_i;
assign qmemimmu_tag_o = qmem_iack ? 4'h0 : icqmem_tag_i;




assign icqmem_adr_o = iaddr_qmem_hit ? 32'h0000_0000 : qmemimmu_adr_i;
assign icqmem_cycstb_o = iaddr_qmem_hit ? 1'b0 : qmemimmu_cycstb_i;
assign icqmem_ci_o = iaddr_qmem_hit ? 1'b0 : qmemimmu_ci_i;
assign icqmem_sel_o = iaddr_qmem_hit ? 4'h0 : qmemicpu_sel_i;
assign icqmem_tag_o = iaddr_qmem_hit ? 4'h0 : qmemicpu_tag_i;




assign qmemdcpu_dat_o = daddr_qmem_hit ? qmem_do : dcqmem_dat_i;
assign qmemdcpu_ack_o = daddr_qmem_hit ? qmem_dack : dcqmem_ack_i;
assign qmemdcpu_rty_o = daddr_qmem_hit ? ~qmem_dack : dcqmem_rty_i;
assign qmemdmmu_err_o = daddr_qmem_hit ? 1'b0 : dcqmem_err_i;
assign qmemdmmu_tag_o = daddr_qmem_hit ? 4'h0 : dcqmem_tag_i;




assign dcqmem_adr_o = daddr_qmem_hit ? 32'h0000_0000 : qmemdmmu_adr_i;
assign dcqmem_cycstb_o = daddr_qmem_hit ? 1'b0 : qmemdmmu_cycstb_i;
assign dcqmem_ci_o = daddr_qmem_hit ? 1'b0 : qmemdmmu_ci_i;
assign dcqmem_we_o = daddr_qmem_hit ? 1'b0 : qmemdcpu_we_i;
assign dcqmem_sel_o = daddr_qmem_hit ? 4'h0 : qmemdcpu_sel_i;
assign dcqmem_tag_o = daddr_qmem_hit ? 4'h0 : qmemdcpu_tag_i;
assign dcqmem_dat_o = daddr_qmem_hit ? 32'h0000_0000 : qmemdcpu_dat_i;





assign iaddr_qmem_hit = (qmemimmu_adr_i &  32'hfff0_0000) ==  32'h0080_0000;





assign daddr_qmem_hit = (qmemdmmu_adr_i &  32'hfff0_0000) ==  32'h0080_0000;







assign qmem_en = iaddr_qmem_hit & qmemimmu_cycstb_i | daddr_qmem_hit & qmemdmmu_cycstb_i;
assign qmem_we = qmemdmmu_cycstb_i & daddr_qmem_hit & qmemdcpu_we_i;



assign qmem_di = qmemdcpu_dat_i;
assign qmem_addr = (qmemdmmu_cycstb_i & daddr_qmem_hit) ? qmemdmmu_adr_i : qmemimmu_adr_i;




always @(posedge rst or posedge clk)
	if (rst) begin
		state <= #1  3'd0;
		qmem_dack <= #1 1'b0;
		qmem_iack <= #1 1'b0;
	end
	else case (state)	
		 3'd0: begin
			if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmemdcpu_we_i & qmem_ack) begin
				state <= #1  3'd1;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd2;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemimmu_cycstb_i & iaddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd3;
				qmem_iack <= #1 1'b1;
				qmem_dack <= #1 1'b0;
			end
		end
		 3'd1: begin
			if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmemdcpu_we_i & qmem_ack) begin
				state <= #1  3'd1;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd2;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemimmu_cycstb_i & iaddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd3;
				qmem_iack <= #1 1'b1;
				qmem_dack <= #1 1'b0;
			end
			else begin
				state <= #1  3'd0;
				qmem_dack <= #1 1'b0;
				qmem_iack <= #1 1'b0;
			end
		end
		 3'd2: begin
			if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmemdcpu_we_i & qmem_ack) begin
				state <= #1  3'd1;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd2;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemimmu_cycstb_i & iaddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd3;
				qmem_iack <= #1 1'b1;
				qmem_dack <= #1 1'b0;
			end
			else begin
				state <= #1  3'd0;
				qmem_dack <= #1 1'b0;
				qmem_iack <= #1 1'b0;
			end
		end
		 3'd3: begin
			if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmemdcpu_we_i & qmem_ack) begin
				state <= #1  3'd1;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemdmmu_cycstb_i & daddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd2;
				qmem_dack <= #1 1'b1;
				qmem_iack <= #1 1'b0;
			end
			else if (qmemimmu_cycstb_i & iaddr_qmem_hit & qmem_ack) begin
				state <= #1  3'd3;
				qmem_iack <= #1 1'b1;
				qmem_dack <= #1 1'b0;
			end
			else begin
				state <= #1  3'd0;
				qmem_dack <= #1 1'b0;
				qmem_iack <= #1 1'b0;
			end
		end
		default: begin
			state <= #1  3'd0;
			qmem_dack <= #1 1'b0;
			qmem_iack <= #1 1'b0;
		end
	endcase




or1200_spram_2048x32 or1200_qmem_ram(
	.clk(clk),
	.rst(rst),






	.addr(qmem_addr[12:2]),






  .ce(qmem_en),
	.we(qmem_we),
	.oe(1'b1),
	.di(qmem_di),
	.doq(qmem_do)
);















































endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_reg2mem.v"









































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 74 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_reg2mem.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 76 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_reg2mem.v"


module or1200_reg2mem(addr, lsu_op, regdata, memdata);

parameter width =  32;




input	[1:0]			addr;
input	[ 4-1:0]	lsu_op;
input	[width-1:0]		regdata;
output	[width-1:0]		memdata;




reg	[7:0]			memdata_hh;
reg	[7:0]			memdata_hl;
reg	[7:0]			memdata_lh;
reg	[7:0]			memdata_ll;

assign memdata = {memdata_hh, memdata_hl, memdata_lh, memdata_ll};




always @(lsu_op or addr or regdata) begin
	casex({lsu_op, addr[1:0]})	
		{ 4'b1010, 2'b00} : memdata_hh = regdata[7:0];
		{ 4'b1100, 2'b00} : memdata_hh = regdata[15:8];
		default : memdata_hh = regdata[31:24];
	endcase
end




always @(lsu_op or addr or regdata) begin
	casex({lsu_op, addr[1:0]})	
		{ 4'b1110, 2'b00} : memdata_hl = regdata[23:16];
		default : memdata_hl = regdata[7:0];
	endcase
end




always @(lsu_op or addr or regdata) begin
	casex({lsu_op, addr[1:0]})	
		{ 4'b1010, 2'b10} : memdata_lh = regdata[7:0];
		default : memdata_lh = regdata[15:8];
	endcase
end




always @(regdata)
	memdata_ll = regdata[7:0];

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_rf.v"
























































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 89 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_rf.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 91 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_rf.v"


module or1200_rf(
	
	clk, rst,

	
	supv, wb_freeze, addrw, dataw, we, flushpipe,

	
	id_freeze, addra, addrb, dataa, datab, rda, rdb,

	
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o
);

parameter dw =  32;
parameter aw =  5;








input				clk;
input				rst;




input				supv;
input				wb_freeze;
input	[aw-1:0]		addrw;
input	[dw-1:0]		dataw;
input				we;
input				flushpipe;




input				id_freeze;
input	[aw-1:0]		addra;
input	[aw-1:0]		addrb;
output	[dw-1:0]		dataa;
output	[dw-1:0]		datab;
input				rda;
input				rdb;




input				spr_cs;
input				spr_write;
input	[31:0]			spr_addr;
input	[31:0]			spr_dat_i;
output	[31:0]			spr_dat_o;




wire	[dw-1:0]		from_rfa;
wire	[dw-1:0]		from_rfb;
reg	[dw:0]			dataa_saved;
reg	[dw:0]			datab_saved;
wire	[aw-1:0]		rf_addra;
wire	[aw-1:0]		rf_addrw;
wire	[dw-1:0]		rf_dataw;
wire				rf_we;
wire				spr_valid;
wire				rf_ena;
wire				rf_enb;
reg				rf_we_allow;





assign spr_valid = spr_cs & (spr_addr[10:5] ==  6'd32);




assign spr_dat_o = from_rfa;




assign dataa = (dataa_saved[32]) ? dataa_saved[31:0] : from_rfa;




assign datab = (datab_saved[32]) ? datab_saved[31:0] : from_rfb;




assign rf_addra = (spr_valid & !spr_write) ? spr_addr[4:0] : addra;




assign rf_addrw = (spr_valid & spr_write) ? spr_addr[4:0] : addrw;




assign rf_dataw = (spr_valid & spr_write) ? spr_dat_i : dataw;




always @(posedge rst or posedge clk)
	if (rst)
		rf_we_allow <= #1 1'b1;
	else if (~wb_freeze)
		rf_we_allow <= #1 ~flushpipe;

assign rf_we = ((spr_valid & spr_write) | (we & ~wb_freeze)) & rf_we_allow & (supv | (|rf_addrw));





assign rf_ena = rda & ~id_freeze | spr_valid;	







assign rf_enb = rdb & ~id_freeze | spr_valid;






always @(posedge clk or posedge rst)
	if (rst) begin
		dataa_saved <= #1 33'b0;
	end
	else if (id_freeze & !dataa_saved[32]) begin
		dataa_saved <= #1 {1'b1, from_rfa};
	end
	else if (!id_freeze)
		dataa_saved <= #1 33'b0;




always @(posedge clk or posedge rst)
	if (rst) begin
		datab_saved <= #1 33'b0;
	end
	else if (id_freeze & !datab_saved[32]) begin
		datab_saved <= #1 {1'b1, from_rfb};
	end
	else if (!id_freeze)
		datab_saved <= #1 33'b0;










































































































or1200_rfram_generic rf_a(
	
	.clk(clk),
	.rst(rst),

	
	.ce_a(rf_ena),
	.addr_a(rf_addra),
	.do_a(from_rfa),

	
	.ce_b(rf_enb),
	.addr_b(addrb),
	.do_b(from_rfb),

	
	.ce_w(rf_we),
	.we_w(rf_we),
	.addr_w(rf_addrw),
	.di_w(rf_dataw)
);















endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_rfram_generic.v"

























































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 58 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_rfram_generic.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 60 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_rfram_generic.v"


module or1200_rfram_generic(
	
	clk, rst,

	
	ce_a, addr_a, do_a,

	
	ce_b, addr_b, do_b,

	
	ce_w, we_w, addr_w, di_w
);

parameter dw =  32;
parameter aw =  5;








input				clk;
input				rst;




input				ce_a;
input	[aw-1:0]		addr_a;
output	[dw-1:0]		do_a;




input				ce_b;
input	[aw-1:0]		addr_b;
output	[dw-1:0]		do_b;




input				ce_w;
input				we_w;
input	[aw-1:0]		addr_w;
input	[dw-1:0]		di_w;




reg	[aw-1:0]		intaddr_a;
reg	[aw-1:0]		intaddr_b;
reg	[32*dw-1:0]		mem;
reg	[dw-1:0]		do_a;
reg	[dw-1:0]		do_b;




always @(posedge clk or posedge rst)
	if (rst) begin
		mem <= #1 {512'h0, 512'h0};
	end
	else if (ce_w & we_w)
		case (addr_w)	
			5'd00: mem[32*0+31:32*0] <= #1 32'h0000_0000;
			5'd01: mem[32*1+31:32*1] <= #1 di_w;
			5'd02: mem[32*2+31:32*2] <= #1 di_w;
			5'd03: mem[32*3+31:32*3] <= #1 di_w;
			5'd04: mem[32*4+31:32*4] <= #1 di_w;
			5'd05: mem[32*5+31:32*5] <= #1 di_w;
			5'd06: mem[32*6+31:32*6] <= #1 di_w;
			5'd07: mem[32*7+31:32*7] <= #1 di_w;
			5'd08: mem[32*8+31:32*8] <= #1 di_w;
			5'd09: mem[32*9+31:32*9] <= #1 di_w;
			5'd10: mem[32*10+31:32*10] <= #1 di_w;
			5'd11: mem[32*11+31:32*11] <= #1 di_w;
			5'd12: mem[32*12+31:32*12] <= #1 di_w;
			5'd13: mem[32*13+31:32*13] <= #1 di_w;
			5'd14: mem[32*14+31:32*14] <= #1 di_w;
			5'd15: mem[32*15+31:32*15] <= #1 di_w;
			5'd16: mem[32*16+31:32*16] <= #1 di_w;
			5'd17: mem[32*17+31:32*17] <= #1 di_w;
			5'd18: mem[32*18+31:32*18] <= #1 di_w;
			5'd19: mem[32*19+31:32*19] <= #1 di_w;
			5'd20: mem[32*20+31:32*20] <= #1 di_w;
			5'd21: mem[32*21+31:32*21] <= #1 di_w;
			5'd22: mem[32*22+31:32*22] <= #1 di_w;
			5'd23: mem[32*23+31:32*23] <= #1 di_w;
			5'd24: mem[32*24+31:32*24] <= #1 di_w;
			5'd25: mem[32*25+31:32*25] <= #1 di_w;
			5'd26: mem[32*26+31:32*26] <= #1 di_w;
			5'd27: mem[32*27+31:32*27] <= #1 di_w;
			5'd28: mem[32*28+31:32*28] <= #1 di_w;
			5'd29: mem[32*29+31:32*29] <= #1 di_w;
			5'd30: mem[32*30+31:32*30] <= #1 di_w;
			default: mem[32*31+31:32*31] <= #1 di_w;
		endcase




always @(posedge clk or posedge rst)
	if (rst) begin
		intaddr_a <= #1 5'h00;
	end
	else if (ce_a)
		intaddr_a <= #1 addr_a;

always @(mem or intaddr_a)
	case (intaddr_a)	
		5'd00: do_a = 32'h0000_0000;
		5'd01: do_a = mem[32*1+31:32*1];
		5'd02: do_a = mem[32*2+31:32*2];
		5'd03: do_a = mem[32*3+31:32*3];
		5'd04: do_a = mem[32*4+31:32*4];
		5'd05: do_a = mem[32*5+31:32*5];
		5'd06: do_a = mem[32*6+31:32*6];
		5'd07: do_a = mem[32*7+31:32*7];
		5'd08: do_a = mem[32*8+31:32*8];
		5'd09: do_a = mem[32*9+31:32*9];
		5'd10: do_a = mem[32*10+31:32*10];
		5'd11: do_a = mem[32*11+31:32*11];
		5'd12: do_a = mem[32*12+31:32*12];
		5'd13: do_a = mem[32*13+31:32*13];
		5'd14: do_a = mem[32*14+31:32*14];
		5'd15: do_a = mem[32*15+31:32*15];
		5'd16: do_a = mem[32*16+31:32*16];
		5'd17: do_a = mem[32*17+31:32*17];
		5'd18: do_a = mem[32*18+31:32*18];
		5'd19: do_a = mem[32*19+31:32*19];
		5'd20: do_a = mem[32*20+31:32*20];
		5'd21: do_a = mem[32*21+31:32*21];
		5'd22: do_a = mem[32*22+31:32*22];
		5'd23: do_a = mem[32*23+31:32*23];
		5'd24: do_a = mem[32*24+31:32*24];
		5'd25: do_a = mem[32*25+31:32*25];
		5'd26: do_a = mem[32*26+31:32*26];
		5'd27: do_a = mem[32*27+31:32*27];
		5'd28: do_a = mem[32*28+31:32*28];
		5'd29: do_a = mem[32*29+31:32*29];
		5'd30: do_a = mem[32*30+31:32*30];
		default: do_a = mem[32*31+31:32*31];
	endcase




always @(posedge clk or posedge rst)
	if (rst) begin
		intaddr_b <= #1 5'h00;
	end
	else if (ce_b)
		intaddr_b <= #1 addr_b;

always @(mem or intaddr_b)
	case (intaddr_b)	
		5'd00: do_b = 32'h0000_0000;
		5'd01: do_b = mem[32*1+31:32*1];
		5'd02: do_b = mem[32*2+31:32*2];
		5'd03: do_b = mem[32*3+31:32*3];
		5'd04: do_b = mem[32*4+31:32*4];
		5'd05: do_b = mem[32*5+31:32*5];
		5'd06: do_b = mem[32*6+31:32*6];
		5'd07: do_b = mem[32*7+31:32*7];
		5'd08: do_b = mem[32*8+31:32*8];
		5'd09: do_b = mem[32*9+31:32*9];
		5'd10: do_b = mem[32*10+31:32*10];
		5'd11: do_b = mem[32*11+31:32*11];
		5'd12: do_b = mem[32*12+31:32*12];
		5'd13: do_b = mem[32*13+31:32*13];
		5'd14: do_b = mem[32*14+31:32*14];
		5'd15: do_b = mem[32*15+31:32*15];
		5'd16: do_b = mem[32*16+31:32*16];
		5'd17: do_b = mem[32*17+31:32*17];
		5'd18: do_b = mem[32*18+31:32*18];
		5'd19: do_b = mem[32*19+31:32*19];
		5'd20: do_b = mem[32*20+31:32*20];
		5'd21: do_b = mem[32*21+31:32*21];
		5'd22: do_b = mem[32*22+31:32*22];
		5'd23: do_b = mem[32*23+31:32*23];
		5'd24: do_b = mem[32*24+31:32*24];
		5'd25: do_b = mem[32*25+31:32*25];
		5'd26: do_b = mem[32*26+31:32*26];
		5'd27: do_b = mem[32*27+31:32*27];
		5'd28: do_b = mem[32*28+31:32*28];
		5'd29: do_b = mem[32*29+31:32*29];
		5'd30: do_b = mem[32*30+31:32*30];
		default: do_b = mem[32*31+31:32*31];
	endcase

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sb.v"























































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 56 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sb.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 58 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sb.v"


module or1200_sb(
	
	clk, rst,

	
	dcsb_dat_i, dcsb_adr_i, dcsb_cyc_i, dcsb_stb_i, dcsb_we_i, dcsb_sel_i, dcsb_cab_i,
	dcsb_dat_o, dcsb_ack_o, dcsb_err_o,

	
	sbbiu_dat_o, sbbiu_adr_o, sbbiu_cyc_o, sbbiu_stb_o, sbbiu_we_o, sbbiu_sel_o, sbbiu_cab_o,
	sbbiu_dat_i, sbbiu_ack_i, sbbiu_err_i
);

parameter dw =  32;
parameter aw =  32;




input			clk;		
input			rst;		




input	[dw-1:0]	dcsb_dat_i;	
input	[aw-1:0]	dcsb_adr_i;	
input			dcsb_cyc_i;	
input			dcsb_stb_i;	
input			dcsb_we_i;	
input			dcsb_cab_i;	
input	[3:0]		dcsb_sel_i;	
output	[dw-1:0]	dcsb_dat_o;	
output			dcsb_ack_o;	
output			dcsb_err_o;	




output	[dw-1:0]	sbbiu_dat_o;	
output	[aw-1:0]	sbbiu_adr_o;	
output			sbbiu_cyc_o;	
output			sbbiu_stb_o;	
output			sbbiu_we_o;	
output			sbbiu_cab_o;	
output	[3:0]		sbbiu_sel_o;	
input	[dw-1:0]	sbbiu_dat_i;	
input			sbbiu_ack_i;	
input			sbbiu_err_i;	








































































	

assign sbbiu_dat_o = dcsb_dat_i;
assign sbbiu_adr_o = dcsb_adr_i;
assign sbbiu_cyc_o = dcsb_cyc_i;
assign sbbiu_stb_o = dcsb_stb_i;
assign sbbiu_we_o = dcsb_we_i;
assign sbbiu_cab_o = dcsb_cab_i;
assign sbbiu_sel_o = dcsb_sel_i;
assign dcsb_dat_o = sbbiu_dat_i;
assign dcsb_ack_o = sbbiu_ack_i;
assign dcsb_err_o = sbbiu_err_i;



endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sb_fifo.v"


























































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 59 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sb_fifo.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 61 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sb_fifo.v"


module or1200_sb_fifo(
	clk_i, rst_i, dat_i, wr_i, rd_i, dat_o, full_o, empty_o
);

parameter dw = 68;
parameter fw =  2;
parameter fl =  4;




input			clk_i;	
input			rst_i;	
input	[dw-1:0]	dat_i;	
input			wr_i;	
input			rd_i;	
output [dw-1:0]	dat_o;	
output			full_o;	
output			empty_o;




reg	[dw-1:0]	mem [fl-1:0];
reg	[dw-1:0]	dat_o;
reg	[fw+1:0]	cntr;
reg	[fw-1:0]	wr_pntr;
reg	[fw-1:0]	rd_pntr;
reg			empty_o;
reg			full_o;

always @(posedge clk_i or posedge rst_i)
	if (rst_i) begin
		full_o <= #1 1'b0;
		empty_o <= #1 1'b1;
		wr_pntr <= #1 {fw{1'b0}};
		rd_pntr <= #1 {fw{1'b0}};
		cntr <= #1 {fw+2{1'b0}};
		dat_o <= #1 {dw{1'b0}};
	end
	else if (wr_i && rd_i) begin		
		mem[wr_pntr] <= #1 dat_i;
		if (wr_pntr >= fl-1)
			wr_pntr <= #1 {fw{1'b0}};
		else
			wr_pntr <= #1 wr_pntr + 1'b1;
		if (empty_o) begin
			dat_o <= #1 dat_i;
		end
		else begin
			dat_o <= #1 mem[rd_pntr];
		end
		if (rd_pntr >= fl-1)
			rd_pntr <= #1 {fw{1'b0}};
		else
			rd_pntr <= #1 rd_pntr + 1'b1;
	end
	else if (wr_i && !full_o) begin		
		mem[wr_pntr] <= #1 dat_i;
		cntr <= #1 cntr + 1'b1;
		empty_o <= #1 1'b0;
		if (cntr >= (fl-1)) begin
			full_o <= #1 1'b1;
			cntr <= #1 fl;
		end
		if (wr_pntr >= fl-1)
			wr_pntr <= #1 {fw{1'b0}};
		else
			wr_pntr <= #1 wr_pntr + 1'b1;
	end
	else if (rd_i && !empty_o) begin	
		dat_o <= #1 mem[rd_pntr];
		cntr <= #1 cntr - 1'b1;
		full_o <= #1 1'b0;
		if (cntr <= 1) begin
			empty_o <= #1 1'b1;
			cntr <= #1 {fw+2{1'b0}};
		end
		if (rd_pntr >= fl-1)
			rd_pntr <= #1 {fw{1'b0}};
		else
			rd_pntr <= #1 rd_pntr + 1'b1;
	end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_32x24.v"











































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 76 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_32x24.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 78 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_32x24.v"


module or1200_spram_32x24(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 5;
parameter dw = 24;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	




wire [31:24] unconnected;




























































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x14.v"








































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 105 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x14.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 107 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x14.v"


module or1200_spram_64x14(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 6;
parameter dw = 14;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	




wire	[1:0]		unconnected;






















































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
        if (rst)
                addr_reg <= #1 {aw{1'b0}};
        else if (ce)
                addr_reg <= #1 addr;
                                                                                                                                                                                                     



always @(posedge clk)
        if (ce && we)
                mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x22.v"








































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 105 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x22.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 107 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x22.v"


module or1200_spram_64x22(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 6;
parameter dw = 22;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	




wire	[9:0]		unconnected;



































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
        if (rst)
                addr_reg <= #1 {aw{1'b0}};
        else if (ce)
                addr_reg <= #1 addr;
                                                                                                                                                                                                     



always @(posedge clk)
        if (ce && we)
                mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x24.v"











































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 108 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x24.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 110 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_64x24.v"


module or1200_spram_64x24(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 6;
parameter dw = 24;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	




wire	[7:0]		unconnected;



































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
        if (rst)
                addr_reg <= #1 {aw{1'b0}};
        else if (ce)
                addr_reg <= #1 addr;
                                                                                                                                                                                                     



always @(posedge clk)
        if (ce && we)
                mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_128x32.v"







































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 72 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_128x32.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 74 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_128x32.v"


module or1200_spram_128x32(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 7;
parameter dw = 32;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	






























































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_256x21.v"

















































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 114 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_256x21.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 116 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_256x21.v"


module or1200_spram_256x21(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 8;
parameter dw = 21;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	




wire	[10:0]		unconnected;



































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_512x20.v"














































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 111 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_512x20.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 113 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_512x20.v"


module or1200_spram_512x20(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 9;
parameter dw = 20;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	




wire	[3:0]		unconnected;
















































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x8.v"








































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 105 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x8.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 107 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x8.v"


module or1200_spram_1024x8(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 10;
parameter dw = 8;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	







































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x32.v"











































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 108 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x32.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 110 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x32.v"


module or1200_spram_1024x32(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 10;
parameter dw = 32;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	





















































































































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x32_bw.v"













































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 78 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x32_bw.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 80 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_1024x32_bw.v"


module or1200_spram_1024x32_bw(




        
        clk, rst, ce, we, oe, addr, di, doq
);













input                   clk;    
input                   rst;    
input                   ce;     
input   [3:0]           we;     
input                   oe;     
input   [9:0]           addr;   
input   [31:0]          di;     
output  [31:0]          doq;     











































































































































































































































































































































reg     [7:0]        mem_0 [1023:0];              
reg     [7:0]        mem_1 [1023:0];              
reg     [7:0]        mem_2 [1023:0];              
reg     [7:0]        mem_3 [1023:0];              
reg     [9:0]        addr_reg;                 




assign doq = (oe) ? {mem_3[addr_reg], mem_2[addr_reg], mem_1[addr_reg], mem_0[addr_reg]} : {32{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 10'h000;
        else if (ce)
                addr_reg <= #1 addr;




always @(posedge clk)
        if (ce && we[0])
                mem_0[addr] <= #1 di[7:0];




always @(posedge clk)
        if (ce && we[1])
                mem_1[addr] <= #1 di[15:8];




always @(posedge clk)
        if (ce && we[2])
                mem_2[addr] <= #1 di[23:16];




always @(posedge clk)
        if (ce && we[3])
                mem_3[addr] <= #1 di[31:24];


  
  
  
  
  

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x8.v"








































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 105 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x8.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 107 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x8.v"


module or1200_spram_2048x8(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 11;
parameter dw = 8;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	

































































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x32.v"











































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 108 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x32.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 110 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x32.v"


module or1200_spram_2048x32(




	
	clk, rst, ce, we, oe, addr, di, doq
);




parameter aw = 11;
parameter dw = 32;













input			clk;	
input			rst;	
input			ce;	
input			we;	
input			oe;	
input 	[aw-1:0]	addr;	
input	[dw-1:0]	di;	
output	[dw-1:0]	doq;	





























































































































































































































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_reg;		




assign doq = (oe) ? mem[addr_reg] : {dw{1'b0}};




always @(posedge clk or posedge rst)
	if (rst)
		addr_reg <= #1 {aw{1'b0}};
	else if (ce)
		addr_reg <= #1 addr;




always @(posedge clk)
	if (ce && we)
		mem[addr] <= #1 di;

	
	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x32_bw.v"
















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 81 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x32_bw.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 83 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_spram_2048x32_bw.v"


module or1200_spram_2048x32_bw(




        
        clk, rst, ce, we, oe, addr, di, doq
);













input                   clk;    
input                   rst;    
input                   ce;     
input   [3:0]           we;     
input                   oe;     
input   [10:0]          addr;   
input   [31:0]          di;     
output  [31:0]          doq;     
















































































































































































































































































































































































































































reg     [7:0]        mem_0 [2047:0];              
reg     [7:0]        mem_1 [2047:0];              
reg     [7:0]        mem_2 [2047:0];              
reg     [7:0]        mem_3 [2047:0];              
reg     [10:0]       addr_reg;                    
                                                                                                                                                                                                     



assign doq = (oe) ? {mem_3[addr_reg], mem_2[addr_reg], mem_1[addr_reg], mem_0[addr_reg]} : {32{1'b0}};
                                                                                                                                                                                                     



always @(posedge clk or posedge rst)
        if (rst)
                addr_reg <= #1 11'h000;
        else if (ce)
                addr_reg <= #1 addr;
                                                                                                                                                                                                     



always @(posedge clk)
        if (ce && we[0])
                mem_0[addr] <= #1 di[7:0];
                                                                                                                                                                                                     



always @(posedge clk)
        if (ce && we[1])
                mem_1[addr] <= #1 di[15:8];
                                                                                                                                                                                                     



always @(posedge clk)
        if (ce && we[2])
                mem_2[addr] <= #1 di[23:16];
                                                                                                                                                                                                     



always @(posedge clk)
        if (ce && we[3])
                mem_3[addr] <= #1 di[31:24];

  
  
  
  
  

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sprs.v"













































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 110 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sprs.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 112 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_sprs.v"


module or1200_sprs(
		
		clk, rst,

		
		flagforw, flag_we, flag, cyforw, cy_we, carry,
		addrbase, addrofs, dat_i, alu_op, branch_op,
		epcr, eear, esr, except_started,
		to_wbmux, epcr_we, eear_we, esr_we, pc_we, sr_we, to_sr, sr,
		spr_dat_cfgr, spr_dat_rf, spr_dat_npc, spr_dat_ppc, spr_dat_mac,

		
		spr_dat_pic, spr_dat_tt, spr_dat_pm,
		spr_dat_dmmu, spr_dat_immu, spr_dat_du,
		spr_addr, spr_dat_o, spr_cs, spr_we,

		du_addr, du_dat_du, du_read,
		du_write, du_dat_cpu

);

parameter width =  32;








input				clk; 		
input 				rst;		
input 				flagforw;	
input 				flag_we;	
output 				flag;		
input 				cyforw;		
input 				cy_we;		
output 				carry;		
input	[width-1:0] 		addrbase;	
input	[15:0] 			addrofs;	
input	[width-1:0]		dat_i;		
input	[ 4-1:0]	alu_op;		
input	[ 3-1:0]	branch_op;	
input	[width-1:0] 		epcr;		
input	[width-1:0] 		eear;		
input	[ 16-1:0] 	esr;		
input 				except_started; 
output	[width-1:0]		to_wbmux;	
output				epcr_we;	
output				eear_we;	
output				esr_we;		
output				pc_we;		
output 				sr_we;		
output	[ 16-1:0]	to_sr;		
output	[ 16-1:0]	sr;		
input	[31:0]			spr_dat_cfgr;	
input	[31:0]			spr_dat_rf;	
input	[31:0]			spr_dat_npc;	
input	[31:0]			spr_dat_ppc;	
input	[31:0]			spr_dat_mac;	




input	[31:0]			spr_dat_pic;	
input	[31:0]			spr_dat_tt;	
input	[31:0]			spr_dat_pm;	
input	[31:0]			spr_dat_dmmu;	
input	[31:0]			spr_dat_immu;	
input	[31:0]			spr_dat_du;	
output	[31:0]			spr_addr;	
output	[31:0]			spr_dat_o;	
output	[31:0]			spr_cs;		
output				spr_we;		




input	[width-1:0]		du_addr;	
input	[width-1:0]		du_dat_du;	
input				du_read;	
input				du_write;	
output	[width-1:0]		du_dat_cpu;	




reg	[ 16-1:0]		sr;		
reg				write_spr;	
reg				read_spr;	
reg	[width-1:0]		to_wbmux;	
wire				cfgr_sel;	
wire				rf_sel;		
wire				npc_sel;	
wire				ppc_sel;	
wire 				sr_sel;		
wire 				epcr_sel;	
wire 				eear_sel;	
wire 				esr_sel;	
wire	[31:0]			sys_data;	
wire				du_access;	
wire	[ 4-1:0]	sprs_op;	
reg	[31:0]			unqualified_cs;	




assign du_access = du_read | du_write;




assign sprs_op = du_write ?  4'd14 : du_read ?  4'd15 : alu_op;





assign spr_addr = du_access ? du_addr : addrbase | {16'h0000, addrofs};




assign spr_dat_o = du_write ? du_dat_du : dat_i;







assign du_dat_cpu = du_write ? du_dat_du : du_read ? to_wbmux : dat_i;




assign spr_we = du_write | write_spr;




assign spr_cs = unqualified_cs & {32{read_spr | write_spr}};




always @(spr_addr)
	case (spr_addr[ 15 : 11])	
		 5'd00: unqualified_cs = 32'b00000000_00000000_00000000_00000001;
		 5'd01: unqualified_cs = 32'b00000000_00000000_00000000_00000010;
		 5'd02: unqualified_cs = 32'b00000000_00000000_00000000_00000100;
		 5'd03: unqualified_cs = 32'b00000000_00000000_00000000_00001000;
		 5'd04: unqualified_cs = 32'b00000000_00000000_00000000_00010000;
		 5'd05: unqualified_cs = 32'b00000000_00000000_00000000_00100000;
		 5'd06: unqualified_cs = 32'b00000000_00000000_00000000_01000000;
		 5'd07: unqualified_cs = 32'b00000000_00000000_00000000_10000000;
		 5'd08: unqualified_cs = 32'b00000000_00000000_00000001_00000000;
		 5'd09: unqualified_cs = 32'b00000000_00000000_00000010_00000000;
		 5'd10: unqualified_cs = 32'b00000000_00000000_00000100_00000000;
		 5'd11: unqualified_cs = 32'b00000000_00000000_00001000_00000000;
		 5'd12: unqualified_cs = 32'b00000000_00000000_00010000_00000000;
		 5'd13: unqualified_cs = 32'b00000000_00000000_00100000_00000000;
		 5'd14: unqualified_cs = 32'b00000000_00000000_01000000_00000000;
		 5'd15: unqualified_cs = 32'b00000000_00000000_10000000_00000000;
		 5'd16: unqualified_cs = 32'b00000000_00000001_00000000_00000000;
		 5'd17: unqualified_cs = 32'b00000000_00000010_00000000_00000000;
		 5'd18: unqualified_cs = 32'b00000000_00000100_00000000_00000000;
		 5'd19: unqualified_cs = 32'b00000000_00001000_00000000_00000000;
		 5'd20: unqualified_cs = 32'b00000000_00010000_00000000_00000000;
		 5'd21: unqualified_cs = 32'b00000000_00100000_00000000_00000000;
		 5'd22: unqualified_cs = 32'b00000000_01000000_00000000_00000000;
		 5'd23: unqualified_cs = 32'b00000000_10000000_00000000_00000000;
		 5'd24: unqualified_cs = 32'b00000001_00000000_00000000_00000000;
		 5'd25: unqualified_cs = 32'b00000010_00000000_00000000_00000000;
		 5'd26: unqualified_cs = 32'b00000100_00000000_00000000_00000000;
		 5'd27: unqualified_cs = 32'b00001000_00000000_00000000_00000000;
		 5'd28: unqualified_cs = 32'b00010000_00000000_00000000_00000000;
		 5'd29: unqualified_cs = 32'b00100000_00000000_00000000_00000000;
		 5'd30: unqualified_cs = 32'b01000000_00000000_00000000_00000000;
		 5'd31: unqualified_cs = 32'b10000000_00000000_00000000_00000000;
	endcase








assign to_sr[ 15: 11] =
		(branch_op ==  3'd6) ? esr[ 15: 11] :
		(write_spr && sr_sel) ? {1'b1, spr_dat_o[ 15-1: 11]}:
		sr[ 15: 11];
assign to_sr[ 10] =
		(branch_op ==  3'd6) ? esr[ 10] :
		cy_we ? cyforw :
		(write_spr && sr_sel) ? spr_dat_o[ 10] :
		sr[ 10];
assign to_sr[ 9] =
		(branch_op ==  3'd6) ? esr[ 9] :
		flag_we ? flagforw :
		(write_spr && sr_sel) ? spr_dat_o[ 9] :
		sr[ 9];
assign to_sr[ 8: 0] =
		(branch_op ==  3'd6) ? esr[ 8: 0] :
		(write_spr && sr_sel) ? spr_dat_o[ 8: 0]:
		sr[ 8: 0];




assign cfgr_sel = (spr_cs[ 5'd00] && (spr_addr[10:4] ==  7'd0));
assign rf_sel = (spr_cs[ 5'd00] && (spr_addr[10:5] ==  6'd32));
assign npc_sel = (spr_cs[ 5'd00] && (spr_addr[10:0] ==  11'd16));
assign ppc_sel = (spr_cs[ 5'd00] && (spr_addr[10:0] ==  11'd18));
assign sr_sel = (spr_cs[ 5'd00] && (spr_addr[10:0] ==  11'd17));
assign epcr_sel = (spr_cs[ 5'd00] && (spr_addr[10:0] ==  11'd32));
assign eear_sel = (spr_cs[ 5'd00] && (spr_addr[10:0] ==  11'd48));
assign esr_sel = (spr_cs[ 5'd00] && (spr_addr[10:0] ==  11'd64));




assign sr_we = (write_spr && sr_sel) | (branch_op ==  3'd6) | flag_we | cy_we;
assign pc_we = (write_spr && (npc_sel | ppc_sel));
assign epcr_we = (write_spr && epcr_sel);
assign eear_we = (write_spr && eear_sel);
assign esr_we = (write_spr && esr_sel);




assign sys_data = (spr_dat_cfgr & {32{read_spr & cfgr_sel}}) |
		  (spr_dat_rf & {32{read_spr & rf_sel}}) |
		  (spr_dat_npc & {32{read_spr & npc_sel}}) |
		  (spr_dat_ppc & {32{read_spr & ppc_sel}}) |
		  ({{32- 16{1'b0}},sr} & {32{read_spr & sr_sel}}) |
		  (epcr & {32{read_spr & epcr_sel}}) |
		  (eear & {32{read_spr & eear_sel}}) |
		  ({{32- 16{1'b0}},esr} & {32{read_spr & esr_sel}});




assign flag = sr[ 9];




assign carry = sr[ 10];




always @(posedge clk or posedge rst)
	if (rst)
		sr <= #1 {1'b1,  1'b0, { 16-3{1'b0}}, 1'b1};
	else if (except_started) begin
		sr[ 0]  <= #1 1'b1;
		sr[ 1] <= #1 1'b0;
		sr[ 2] <= #1 1'b0;
		sr[ 5] <= #1 1'b0;
		sr[ 6] <= #1 1'b0;
	end
	else if (sr_we)
		sr <= #1 to_sr[ 16-1:0];




always @(sprs_op or spr_addr or sys_data or spr_dat_mac or spr_dat_pic or spr_dat_pm or
	spr_dat_dmmu or spr_dat_immu or spr_dat_du or spr_dat_tt) begin
	case (sprs_op)	
		 4'd14 : begin
			write_spr = 1'b1;
			read_spr = 1'b0;
			to_wbmux = 32'b0;
		end
		 4'd15 : begin
			casex (spr_addr[ 15 : 11]) 
				 5'd10:
					to_wbmux = spr_dat_tt;
				 5'd09:
					to_wbmux = spr_dat_pic;
				 5'd08:
					to_wbmux = spr_dat_pm;
				 5'd01:
					to_wbmux = spr_dat_dmmu;
				 5'd02:
					to_wbmux = spr_dat_immu;
				 5'd05:
					to_wbmux = spr_dat_mac;
				 5'd06:
					to_wbmux = spr_dat_du;
				 5'd00:
					to_wbmux = sys_data;
				default:
					to_wbmux = 32'b0;
			endcase
			write_spr = 1'b0;
			read_spr = 1'b1;
		end
		default : begin
			write_spr = 1'b0;
			read_spr = 1'b0;
			to_wbmux = 32'b0;
		end
	endcase
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_top.v"














































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 143 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_top.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 145 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_top.v"


module or1200_top(
	
	clk_i, rst_i, pic_ints_i, clmode_i,

	
	iwb_clk_i, iwb_rst_i, iwb_ack_i, iwb_err_i, iwb_rty_i, iwb_dat_i,
	iwb_cyc_o, iwb_adr_o, iwb_stb_o, iwb_we_o, iwb_sel_o, iwb_dat_o,

	iwb_cab_o,




	
	dwb_clk_i, dwb_rst_i, dwb_ack_i, dwb_err_i, dwb_rty_i, dwb_dat_i,
	dwb_cyc_o, dwb_adr_o, dwb_stb_o, dwb_we_o, dwb_sel_o, dwb_dat_o,

	dwb_cab_o,





	
	dbg_stall_i, dbg_ewt_i,	dbg_lss_o, dbg_is_o, dbg_wp_o, dbg_bp_o,
	dbg_stb_i, dbg_we_i, dbg_adr_i, dbg_dat_i, dbg_dat_o, dbg_ack_o,
	




	
	pm_cpustall_i,
	pm_clksd_o, pm_dc_gate_o, pm_ic_gate_o, pm_dmmu_gate_o, 
	pm_immu_gate_o, pm_tt_gate_o, pm_cpu_gate_o, pm_wakeup_o, pm_lvolt_o

);

parameter dw =  32;
parameter aw =  32;
parameter ppic_ints =  20;








input			clk_i;
input			rst_i;
input	[1:0]		clmode_i;	
input	[ppic_ints-1:0]	pic_ints_i;




input			iwb_clk_i;	
input			iwb_rst_i;	
input			iwb_ack_i;	
input			iwb_err_i;	
input			iwb_rty_i;	
input	[dw-1:0]	iwb_dat_i;	
output			iwb_cyc_o;	
output	[aw-1:0]	iwb_adr_o;	
output			iwb_stb_o;	
output			iwb_we_o;	
output	[3:0]		iwb_sel_o;	
output	[dw-1:0]	iwb_dat_o;	

output			iwb_cab_o;	









input			dwb_clk_i;	
input			dwb_rst_i;	
input			dwb_ack_i;	
input			dwb_err_i;	
input			dwb_rty_i;	
input	[dw-1:0]	dwb_dat_i;	
output			dwb_cyc_o;	
output	[aw-1:0]	dwb_adr_o;	
output			dwb_stb_o;	
output			dwb_we_o;	
output	[3:0]		dwb_sel_o;	
output	[dw-1:0]	dwb_dat_o;	

output			dwb_cab_o;	









input			dbg_stall_i;	
input			dbg_ewt_i;	
output	[3:0]		dbg_lss_o;	
output	[1:0]		dbg_is_o;	
output	[10:0]		dbg_wp_o;	
output			dbg_bp_o;	
input			dbg_stb_i;      
input			dbg_we_i;       
input	[aw-1:0]	dbg_adr_i;	
input	[dw-1:0]	dbg_dat_i;	
output	[dw-1:0]	dbg_dat_o;	
output			dbg_ack_o;	













input			pm_cpustall_i;
output	[3:0]		pm_clksd_o;
output			pm_dc_gate_o;
output			pm_ic_gate_o;
output			pm_dmmu_gate_o;
output			pm_immu_gate_o;
output			pm_tt_gate_o;
output			pm_cpu_gate_o;
output			pm_wakeup_o;
output			pm_lvolt_o;









wire	[dw-1:0]	dcsb_dat_dc;
wire	[aw-1:0]	dcsb_adr_dc;
wire			dcsb_cyc_dc;
wire			dcsb_stb_dc;
wire			dcsb_we_dc;
wire	[3:0]		dcsb_sel_dc;
wire			dcsb_cab_dc;
wire	[dw-1:0]	dcsb_dat_sb;
wire			dcsb_ack_sb;
wire			dcsb_err_sb;




wire	[dw-1:0]	sbbiu_dat_sb;
wire	[aw-1:0]	sbbiu_adr_sb;
wire			sbbiu_cyc_sb;
wire			sbbiu_stb_sb;
wire			sbbiu_we_sb;
wire	[3:0]		sbbiu_sel_sb;
wire			sbbiu_cab_sb;
wire	[dw-1:0]	sbbiu_dat_biu;
wire			sbbiu_ack_biu;
wire			sbbiu_err_biu;




wire	[dw-1:0]	icbiu_dat_ic;
wire	[aw-1:0]	icbiu_adr_ic;
wire			icbiu_cyc_ic;
wire			icbiu_stb_ic;
wire			icbiu_we_ic;
wire	[3:0]		icbiu_sel_ic;
wire	[3:0]		icbiu_tag_ic;
wire			icbiu_cab_ic;
wire	[dw-1:0]	icbiu_dat_biu;
wire			icbiu_ack_biu;
wire			icbiu_err_biu;
wire	[3:0]		icbiu_tag_biu;




wire			supv;
wire	[aw-1:0]	spr_addr;
wire	[dw-1:0]	spr_dat_cpu;
wire	[31:0]		spr_cs;
wire			spr_we;




wire			dmmu_en;
wire	[31:0]		spr_dat_dmmu;




wire			qmemdmmu_err_qmem;
wire	[3:0]		qmemdmmu_tag_qmem;
wire	[aw-1:0]	qmemdmmu_adr_dmmu;
wire			qmemdmmu_cycstb_dmmu;
wire			qmemdmmu_ci_dmmu;




wire			dc_en;
wire	[31:0]		dcpu_adr_cpu;
wire			dcpu_cycstb_cpu;
wire			dcpu_we_cpu;
wire	[3:0]		dcpu_sel_cpu;
wire	[3:0]		dcpu_tag_cpu;
wire	[31:0]		dcpu_dat_cpu;
wire	[31:0]		dcpu_dat_qmem;
wire			dcpu_ack_qmem;
wire			dcpu_rty_qmem;
wire			dcpu_err_dmmu;
wire	[3:0]		dcpu_tag_dmmu;




wire			immu_en;
wire	[31:0]		spr_dat_immu;




wire			ic_en;
wire	[31:0]		icpu_adr_cpu;
wire			icpu_cycstb_cpu;
wire	[3:0]		icpu_sel_cpu;
wire	[3:0]		icpu_tag_cpu;
wire	[31:0]		icpu_dat_qmem;
wire			icpu_ack_qmem;
wire	[31:0]		icpu_adr_immu;
wire			icpu_err_immu;
wire	[3:0]		icpu_tag_immu;
wire			icpu_rty_immu;




wire	[aw-1:0]	qmemimmu_adr_immu;
wire			qmemimmu_rty_qmem;
wire			qmemimmu_err_qmem;
wire	[3:0]		qmemimmu_tag_qmem;
wire			qmemimmu_cycstb_immu;
wire			qmemimmu_ci_immu;




wire	[aw-1:0]	icqmem_adr_qmem;
wire			icqmem_rty_ic;
wire			icqmem_err_ic;
wire	[3:0]		icqmem_tag_ic;
wire			icqmem_cycstb_qmem;
wire			icqmem_ci_qmem;
wire	[31:0]		icqmem_dat_ic;
wire			icqmem_ack_ic;




wire	[aw-1:0]	dcqmem_adr_qmem;
wire			dcqmem_rty_dc;
wire			dcqmem_err_dc;
wire	[3:0]		dcqmem_tag_dc;
wire			dcqmem_cycstb_qmem;
wire			dcqmem_ci_qmem;
wire	[31:0]		dcqmem_dat_dc;
wire	[31:0]		dcqmem_dat_qmem;
wire			dcqmem_we_qmem;
wire	[3:0]		dcqmem_sel_qmem;
wire			dcqmem_ack_dc;




wire	[dw-1:0]	spr_dat_pic;
wire			pic_wakeup;
wire			sig_int;




wire	[dw-1:0]	spr_dat_pm;




wire	[dw-1:0]	spr_dat_tt;
wire			sig_tick;




wire	[dw-1:0]	spr_dat_du;
wire			du_stall;
wire	[dw-1:0]	du_addr;
wire	[dw-1:0]	du_dat_du;
wire			du_read;
wire			du_write;
wire	[12:0]		du_except;
wire	[ 14-1:0]     du_dsr;
wire	[dw-1:0]	du_dat_cpu;
wire			du_hwbkpt;

wire			ex_freeze;
wire	[31:0]		ex_insn;
wire	[31:0]		id_pc;
wire	[ 3-1:0]	branch_op;
wire	[31:0]		spr_dat_npc;
wire	[31:0]		rf_dataw;


















wire  [3:0] icqmem_sel_qmem;
wire  [3:0] icqmem_tag_qmem;
wire  [3:0] dcqmem_tag_qmem;




or1200_iwb_biu iwb_biu(
	
	.clk(clk_i),
	.rst(rst_i),
	.clmode(clmode_i),

	
	.wb_clk_i(iwb_clk_i),
	.wb_rst_i(iwb_rst_i),
	.wb_ack_i(iwb_ack_i),
	.wb_err_i(iwb_err_i),
	.wb_rty_i(iwb_rty_i),
	.wb_dat_i(iwb_dat_i),
	.wb_cyc_o(iwb_cyc_o),
	.wb_adr_o(iwb_adr_o),
	.wb_stb_o(iwb_stb_o),
	.wb_we_o(iwb_we_o),
	.wb_sel_o(iwb_sel_o),
	.wb_dat_o(iwb_dat_o),

	.wb_cab_o(iwb_cab_o),






	
	.biu_dat_i(icbiu_dat_ic),
	.biu_adr_i(icbiu_adr_ic),
	.biu_cyc_i(icbiu_cyc_ic),
	.biu_stb_i(icbiu_stb_ic),
	.biu_we_i(icbiu_we_ic),
	.biu_sel_i(icbiu_sel_ic),
	.biu_cab_i(icbiu_cab_ic),
	.biu_dat_o(icbiu_dat_biu),
	.biu_ack_o(icbiu_ack_biu),
	.biu_err_o(icbiu_err_biu)
);




or1200_wb_biu dwb_biu(
	
	.clk(clk_i),
	.rst(rst_i),
	.clmode(clmode_i),

	
	.wb_clk_i(dwb_clk_i),
	.wb_rst_i(dwb_rst_i),
	.wb_ack_i(dwb_ack_i),
	.wb_err_i(dwb_err_i),
	.wb_rty_i(dwb_rty_i),
	.wb_dat_i(dwb_dat_i),
	.wb_cyc_o(dwb_cyc_o),
	.wb_adr_o(dwb_adr_o),
	.wb_stb_o(dwb_stb_o),
	.wb_we_o(dwb_we_o),
	.wb_sel_o(dwb_sel_o),
	.wb_dat_o(dwb_dat_o),

	.wb_cab_o(dwb_cab_o),






	
	.biu_dat_i(sbbiu_dat_sb),
	.biu_adr_i(sbbiu_adr_sb),
	.biu_cyc_i(sbbiu_cyc_sb),
	.biu_stb_i(sbbiu_stb_sb),
	.biu_we_i(sbbiu_we_sb),
	.biu_sel_i(sbbiu_sel_sb),
	.biu_cab_i(sbbiu_cab_sb),
	.biu_dat_o(sbbiu_dat_biu),
	.biu_ack_o(sbbiu_ack_biu),
	.biu_err_o(sbbiu_err_biu)
);




or1200_immu_top or1200_immu_top(
	
	.clk(clk_i),
	.rst(rst_i),








	
	.ic_en(ic_en),
	.immu_en(immu_en),
	.supv(supv),
	.icpu_adr_i(icpu_adr_cpu),
	.icpu_cycstb_i(icpu_cycstb_cpu),
	.icpu_adr_o(icpu_adr_immu),
	.icpu_tag_o(icpu_tag_immu),
	.icpu_rty_o(icpu_rty_immu),
	.icpu_err_o(icpu_err_immu),

	
	.spr_cs(spr_cs[ 5'd02]),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_immu),

	
	.qmemimmu_rty_i(qmemimmu_rty_qmem),
	.qmemimmu_err_i(qmemimmu_err_qmem),
	.qmemimmu_tag_i(qmemimmu_tag_qmem),
	.qmemimmu_adr_o(qmemimmu_adr_immu),
	.qmemimmu_cycstb_o(qmemimmu_cycstb_immu),
	.qmemimmu_ci_o(qmemimmu_ci_immu)
);




or1200_ic_top or1200_ic_top(
	.clk(clk_i),
	.rst(rst_i),








	
	.ic_en(ic_en),
	.icqmem_adr_i(icqmem_adr_qmem),
	.icqmem_cycstb_i(icqmem_cycstb_qmem),
	.icqmem_ci_i(icqmem_ci_qmem),
	.icqmem_sel_i(icqmem_sel_qmem),
	.icqmem_tag_i(icqmem_tag_qmem),
	.icqmem_dat_o(icqmem_dat_ic),
	.icqmem_ack_o(icqmem_ack_ic),
	.icqmem_rty_o(icqmem_rty_ic),
	.icqmem_err_o(icqmem_err_ic),
	.icqmem_tag_o(icqmem_tag_ic),

	
	.spr_cs(spr_cs[ 5'd04]),
	.spr_write(spr_we),
	.spr_dat_i(spr_dat_cpu),

	
	.icbiu_dat_o(icbiu_dat_ic),
	.icbiu_adr_o(icbiu_adr_ic),
	.icbiu_cyc_o(icbiu_cyc_ic),
	.icbiu_stb_o(icbiu_stb_ic),
	.icbiu_we_o(icbiu_we_ic),
	.icbiu_sel_o(icbiu_sel_ic),
	.icbiu_cab_o(icbiu_cab_ic),
	.icbiu_dat_i(icbiu_dat_biu),
	.icbiu_ack_i(icbiu_ack_biu),
	.icbiu_err_i(icbiu_err_biu)
);




or1200_cpu or1200_cpu(
	.clk(clk_i),
	.rst(rst_i),

	
	.ic_en(ic_en),
	.icpu_adr_o(icpu_adr_cpu),
	.icpu_cycstb_o(icpu_cycstb_cpu),
	.icpu_sel_o(icpu_sel_cpu),
	.icpu_tag_o(icpu_tag_cpu),
	.icpu_dat_i(icpu_dat_qmem),
	.icpu_ack_i(icpu_ack_qmem),
	.icpu_rty_i(icpu_rty_immu),
	.icpu_adr_i(icpu_adr_immu),
	.icpu_err_i(icpu_err_immu),
	.icpu_tag_i(icpu_tag_immu),

	
	.ex_freeze(ex_freeze),
	.ex_insn(ex_insn),
	.id_pc(id_pc),
	.branch_op(branch_op),
	.du_stall(du_stall),
	.du_addr(du_addr),
	.du_dat_du(du_dat_du),
	.du_read(du_read),
	.du_write(du_write),
	.du_dsr(du_dsr),
	.du_except(du_except),
	.du_dat_cpu(du_dat_cpu),
	.du_hwbkpt(du_hwbkpt),
	.rf_dataw(rf_dataw),


	
	.immu_en(immu_en),

	
	.dc_en(dc_en),
	.dcpu_adr_o(dcpu_adr_cpu),
	.dcpu_cycstb_o(dcpu_cycstb_cpu),
	.dcpu_we_o(dcpu_we_cpu),
	.dcpu_sel_o(dcpu_sel_cpu),
	.dcpu_tag_o(dcpu_tag_cpu),
	.dcpu_dat_o(dcpu_dat_cpu),
        .dcpu_dat_i(dcpu_dat_qmem),
	.dcpu_ack_i(dcpu_ack_qmem),
	.dcpu_rty_i(dcpu_rty_qmem),
	.dcpu_err_i(dcpu_err_dmmu),
	.dcpu_tag_i(dcpu_tag_dmmu),

	
	.dmmu_en(dmmu_en),

	
	.sig_int(sig_int),
	.sig_tick(sig_tick),

	
	.supv(supv),
	.spr_addr(spr_addr),
	.spr_dat_cpu(spr_dat_cpu),
	.spr_dat_pic(spr_dat_pic),
	.spr_dat_tt(spr_dat_tt),
	.spr_dat_pm(spr_dat_pm),
	.spr_dat_dmmu(spr_dat_dmmu),
	.spr_dat_immu(spr_dat_immu),
	.spr_dat_du(spr_dat_du),
	.spr_dat_npc(spr_dat_npc),
	.spr_cs(spr_cs),
	.spr_we(spr_we)
);




or1200_dmmu_top or1200_dmmu_top(
	
	.clk(clk_i),
	.rst(rst_i),








	
	.dc_en(dc_en),
	.dmmu_en(dmmu_en),
	.supv(supv),
	.dcpu_adr_i(dcpu_adr_cpu),
	.dcpu_cycstb_i(dcpu_cycstb_cpu),
	.dcpu_we_i(dcpu_we_cpu),
	.dcpu_tag_o(dcpu_tag_dmmu),
	.dcpu_err_o(dcpu_err_dmmu),

	
	.spr_cs(spr_cs[ 5'd01]),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_dmmu),

	
	.qmemdmmu_err_i(qmemdmmu_err_qmem),
	.qmemdmmu_tag_i(qmemdmmu_tag_qmem),
	.qmemdmmu_adr_o(qmemdmmu_adr_dmmu),
	.qmemdmmu_cycstb_o(qmemdmmu_cycstb_dmmu),
	.qmemdmmu_ci_o(qmemdmmu_ci_dmmu)
);




or1200_dc_top or1200_dc_top(
	.clk(clk_i),
	.rst(rst_i),








	
	.dc_en(dc_en),
	.dcqmem_adr_i(dcqmem_adr_qmem),
	.dcqmem_cycstb_i(dcqmem_cycstb_qmem),
	.dcqmem_ci_i(dcqmem_ci_qmem),
	.dcqmem_we_i(dcqmem_we_qmem),
	.dcqmem_sel_i(dcqmem_sel_qmem),
	.dcqmem_tag_i(dcqmem_tag_qmem),
	.dcqmem_dat_i(dcqmem_dat_qmem),
	.dcqmem_dat_o(dcqmem_dat_dc),
	.dcqmem_ack_o(dcqmem_ack_dc),
	.dcqmem_rty_o(dcqmem_rty_dc),
	.dcqmem_err_o(dcqmem_err_dc),
	.dcqmem_tag_o(dcqmem_tag_dc),

	
	.spr_cs(spr_cs[ 5'd03]),
	.spr_write(spr_we),
	.spr_dat_i(spr_dat_cpu),

	
	.dcsb_dat_o(dcsb_dat_dc),
	.dcsb_adr_o(dcsb_adr_dc),
	.dcsb_cyc_o(dcsb_cyc_dc),
	.dcsb_stb_o(dcsb_stb_dc),
	.dcsb_we_o(dcsb_we_dc),
	.dcsb_sel_o(dcsb_sel_dc),
	.dcsb_cab_o(dcsb_cab_dc),
	.dcsb_dat_i(dcsb_dat_sb),
	.dcsb_ack_i(dcsb_ack_sb),
	.dcsb_err_i(dcsb_err_sb)
);




or1200_qmem_top or1200_qmem_top(
	.clk(clk_i),
	.rst(rst_i),








	
	.qmemimmu_adr_i(qmemimmu_adr_immu),
	.qmemimmu_cycstb_i(qmemimmu_cycstb_immu),
	.qmemimmu_ci_i(qmemimmu_ci_immu),
	.qmemicpu_sel_i(icpu_sel_cpu),
	.qmemicpu_tag_i(icpu_tag_cpu),
	.qmemicpu_dat_o(icpu_dat_qmem),
	.qmemicpu_ack_o(icpu_ack_qmem),
	.qmemimmu_rty_o(qmemimmu_rty_qmem),
	.qmemimmu_err_o(qmemimmu_err_qmem),
	.qmemimmu_tag_o(qmemimmu_tag_qmem),

	
	.icqmem_adr_o(icqmem_adr_qmem),
	.icqmem_cycstb_o(icqmem_cycstb_qmem),
	.icqmem_ci_o(icqmem_ci_qmem),
	.icqmem_sel_o(icqmem_sel_qmem),
	.icqmem_tag_o(icqmem_tag_qmem),
	.icqmem_dat_i(icqmem_dat_ic),
	.icqmem_ack_i(icqmem_ack_ic),
	.icqmem_rty_i(icqmem_rty_ic),
	.icqmem_err_i(icqmem_err_ic),
	.icqmem_tag_i(icqmem_tag_ic),

	
	.qmemdmmu_adr_i(qmemdmmu_adr_dmmu),
	.qmemdmmu_cycstb_i(qmemdmmu_cycstb_dmmu),
	.qmemdmmu_ci_i(qmemdmmu_ci_dmmu),
	.qmemdcpu_we_i(dcpu_we_cpu),
	.qmemdcpu_sel_i(dcpu_sel_cpu),
	.qmemdcpu_tag_i(dcpu_tag_cpu),
	.qmemdcpu_dat_i(dcpu_dat_cpu),
	.qmemdcpu_dat_o(dcpu_dat_qmem),
	.qmemdcpu_ack_o(dcpu_ack_qmem),
	.qmemdcpu_rty_o(dcpu_rty_qmem),
	.qmemdmmu_err_o(qmemdmmu_err_qmem),
	.qmemdmmu_tag_o(qmemdmmu_tag_qmem),

	
	.dcqmem_adr_o(dcqmem_adr_qmem),
	.dcqmem_cycstb_o(dcqmem_cycstb_qmem),
	.dcqmem_ci_o(dcqmem_ci_qmem),
	.dcqmem_we_o(dcqmem_we_qmem),
	.dcqmem_sel_o(dcqmem_sel_qmem),
	.dcqmem_tag_o(dcqmem_tag_qmem),
	.dcqmem_dat_o(dcqmem_dat_qmem),
	.dcqmem_dat_i(dcqmem_dat_dc),
	.dcqmem_ack_i(dcqmem_ack_dc),
	.dcqmem_rty_i(dcqmem_rty_dc),
	.dcqmem_err_i(dcqmem_err_dc),
	.dcqmem_tag_i(dcqmem_tag_dc)
);




or1200_sb or1200_sb(
	
	.clk(clk_i),
	.rst(rst_i),

	
	.dcsb_dat_i(dcsb_dat_dc),
	.dcsb_adr_i(dcsb_adr_dc),
	.dcsb_cyc_i(dcsb_cyc_dc),
	.dcsb_stb_i(dcsb_stb_dc),
	.dcsb_we_i(dcsb_we_dc),
	.dcsb_sel_i(dcsb_sel_dc),
	.dcsb_cab_i(dcsb_cab_dc),
	.dcsb_dat_o(dcsb_dat_sb),
	.dcsb_ack_o(dcsb_ack_sb),
	.dcsb_err_o(dcsb_err_sb),

	
	.sbbiu_dat_o(sbbiu_dat_sb),
	.sbbiu_adr_o(sbbiu_adr_sb),
	.sbbiu_cyc_o(sbbiu_cyc_sb),
	.sbbiu_stb_o(sbbiu_stb_sb),
	.sbbiu_we_o(sbbiu_we_sb),
	.sbbiu_sel_o(sbbiu_sel_sb),
	.sbbiu_cab_o(sbbiu_cab_sb),
	.sbbiu_dat_i(sbbiu_dat_biu),
	.sbbiu_ack_i(sbbiu_ack_biu),
	.sbbiu_err_i(sbbiu_err_biu)
);




or1200_du or1200_du(
	
	.clk(clk_i),
	.rst(rst_i),
	.dcpu_cycstb_i(dcpu_cycstb_cpu),
	.dcpu_we_i(dcpu_we_cpu),
	.dcpu_adr_i(dcpu_adr_cpu),
	.dcpu_dat_lsu(dcpu_dat_cpu),
	.dcpu_dat_dc(dcpu_dat_qmem),
	.icpu_cycstb_i(icpu_cycstb_cpu),
	.ex_freeze(ex_freeze),
	.branch_op(branch_op),
	.ex_insn(ex_insn),
	.id_pc(id_pc),
	.du_dsr(du_dsr),

	
	.spr_dat_npc(spr_dat_npc),
	.rf_dataw(rf_dataw),

	
	.du_stall(du_stall),
	.du_addr(du_addr),
	.du_dat_i(du_dat_cpu),
	.du_dat_o(du_dat_du),
	.du_read(du_read),
	.du_write(du_write),
	.du_except(du_except),
	.du_hwbkpt(du_hwbkpt),

	
	.spr_cs(spr_cs[ 5'd06]),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_du),

	
	.dbg_stall_i(dbg_stall_i),
	.dbg_ewt_i(dbg_ewt_i),
	.dbg_lss_o(dbg_lss_o),
	.dbg_is_o(dbg_is_o),
	.dbg_wp_o(dbg_wp_o),
	.dbg_bp_o(dbg_bp_o),
	.dbg_stb_i(dbg_stb_i),
	.dbg_we_i(dbg_we_i),
	.dbg_adr_i(dbg_adr_i),
	.dbg_dat_i(dbg_dat_i),
	.dbg_dat_o(dbg_dat_o),
	.dbg_ack_o(dbg_ack_o)
);




or1200_pic or1200_pic(
	
	.clk(clk_i),
	.rst(rst_i),
	.spr_cs(spr_cs[ 5'd09]),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_pic),
	.pic_wakeup(pic_wakeup),
	.intr(sig_int), 

	
	.pic_int(pic_ints_i)
);




or1200_tt or1200_tt(
	
	.clk(clk_i),
	.rst(rst_i),
	.du_stall(du_stall),
	.spr_cs(spr_cs[ 5'd10]),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_tt),
	.intr(sig_tick)
);




or1200_pm or1200_pm(
	
	.clk(clk_i),
	.rst(rst_i),
	.pic_wakeup(pic_wakeup),
	.spr_write(spr_we),
	.spr_addr(spr_addr),
	.spr_dat_i(spr_dat_cpu),
	.spr_dat_o(spr_dat_pm),

	
	.pm_cpustall(pm_cpustall_i),
	.pm_clksd(pm_clksd_o),
	.pm_dc_gate(pm_dc_gate_o),
	.pm_ic_gate(pm_ic_gate_o),
	.pm_dmmu_gate(pm_dmmu_gate_o),
	.pm_immu_gate(pm_immu_gate_o),
	.pm_tt_gate(pm_tt_gate_o),
	.pm_cpu_gate(pm_cpu_gate_o),
	.pm_wakeup(pm_wakeup_o),
	.pm_lvolt(pm_lvolt_o)
);


endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_tpram_32x32.v"

































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 98 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_tpram_32x32.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 100 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_tpram_32x32.v"


module or1200_tpram_32x32(
	
	clk_a, rst_a, ce_a, we_a, oe_a, addr_a, di_a, do_a,
	clk_b, rst_b, ce_b, we_b, oe_b, addr_b, di_b, do_b
);




parameter aw = 5;
parameter dw = 32;




input			clk_a;	
input			rst_a;	
input			ce_a;	
input			we_a;	
input			oe_a;	
input 	[aw-1:0]	addr_a;	
input	[dw-1:0]	di_a;	
output	[dw-1:0]	do_a;	
input			clk_b;	
input			rst_b;	
input			ce_b;	
input			we_b;	
input			oe_b;	
input 	[aw-1:0]	addr_b;	
input	[dw-1:0]	di_b;	
output	[dw-1:0]	do_b;	










































































































































































































reg	[dw-1:0]	mem [(1<<aw)-1:0];	
reg	[aw-1:0]	addr_a_reg;		
reg	[aw-1:0]	addr_b_reg;		




assign do_a = (oe_a) ? mem[addr_a_reg] : {dw{1'b0}};
assign do_b = (oe_b) ? mem[addr_b_reg] : {dw{1'b0}};




always @(posedge clk_a)
	if (ce_a && we_a)
		mem[addr_a] <= #1 di_a;




always @(posedge clk_b)
	if (ce_b && we_b)
		mem[addr_b] <= #1 di_b;




always @(posedge clk_a or posedge rst_a)
	if (rst_a)
		addr_a_reg <= #1 {aw{1'b0}};
	else if (ce_a)
		addr_a_reg <= #1 addr_a;




always @(posedge clk_b or posedge rst_b)
	if (rst_b)
		addr_b_reg <= #1 {aw{1'b0}};
	else if (ce_b)
		addr_b_reg <= #1 addr_b;

	
	
	
  
	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_tt.v"





















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 86 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_tt.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 88 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_tt.v"


module or1200_tt(
	
	clk, rst, du_stall,
	spr_cs, spr_write, spr_addr, spr_dat_i, spr_dat_o,
	intr
);




input		clk;		
input		rst;		
input		du_stall;	
input		spr_cs;		
input		spr_write;	
input	[31:0]	spr_addr;	
input	[31:0]	spr_dat_i;	
output	[31:0]	spr_dat_o;	
output		intr;		







reg	[31:0]	ttmr;	








reg	[31:0]	ttcr;	







wire		ttmr_sel;	
wire		ttcr_sel;	
wire		match;		
				
wire		restart;	
wire		stop;		
reg	[31:0] 	spr_dat_o;	




assign ttmr_sel = (spr_cs && (spr_addr[ 0] ==  1'd0)) ? 1'b1 : 1'b0;
assign ttcr_sel = (spr_cs && (spr_addr[ 0] ==  1'd1)) ? 1'b1 : 1'b0;





always @(posedge clk or posedge rst)
	if (rst)
		ttmr <= 32'b0;
	else if (ttmr_sel && spr_write)
		ttmr <= #1 spr_dat_i;
	else if (ttmr[ 29])
		ttmr[ 28] <= #1 ttmr[ 28] | (match & ttmr[ 29]);








always @(posedge clk or posedge rst)
	if (rst)
		ttcr <= 32'b0;
	else if (restart)
		ttcr <= #1 32'b0;
	else if (ttcr_sel && spr_write)
		ttcr <= #1 spr_dat_i;
	else if (!stop)
		ttcr <= #1 ttcr + 32'd1;







always @(spr_addr or ttmr or ttcr)
	case (spr_addr[ 0])	

		 1'd0: spr_dat_o = ttmr;

		default: spr_dat_o = ttcr;
	endcase




assign match = (ttmr[ 27 : 0] == ttcr[27:0]) ? 1'b1 : 1'b0;




assign restart = match && (ttmr[ 31 : 30] == 2'b01);




assign stop = match & (ttmr[ 31 : 30] == 2'b10) | (ttmr[ 31 : 30] == 2'b00) | du_stall;




assign intr = ttmr[ 28];

















endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_wb_biu.v"









































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 106 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_wb_biu.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 108 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_wb_biu.v"


module or1200_wb_biu(
	
	clk, rst, clmode,

	
	wb_clk_i, wb_rst_i, wb_ack_i, wb_err_i, wb_rty_i, wb_dat_i,
	wb_cyc_o, wb_adr_o, wb_stb_o, wb_we_o, wb_sel_o, wb_dat_o,

	wb_cab_o,





	
	biu_dat_i, biu_adr_i, biu_cyc_i, biu_stb_i, biu_we_i, biu_sel_i, biu_cab_i,
	biu_dat_o, biu_ack_o, biu_err_o
);

parameter dw =  32;
parameter aw =  32;




input			clk;		
input			rst;		
input	[1:0]		clmode;		




input			wb_clk_i;	
input			wb_rst_i;	
input			wb_ack_i;	
input			wb_err_i;	
input			wb_rty_i;	
input	[dw-1:0]	wb_dat_i;	
output			wb_cyc_o;	
output	[aw-1:0]	wb_adr_o;	
output			wb_stb_o;	
output			wb_we_o;	
output	[3:0]		wb_sel_o;	
output	[dw-1:0]	wb_dat_o;	

output			wb_cab_o;	









input	[dw-1:0]	biu_dat_i;	
input	[aw-1:0]	biu_adr_i;	
input			biu_cyc_i;	
input			biu_stb_i;	
input			biu_we_i;	
input			biu_cab_i;	
input	[3:0]		biu_sel_i;	
output	[31:0]		biu_dat_o;	
output			biu_ack_o;	
output			biu_err_o;	




reg	[1:0]		valid_div;	

reg	[aw-1:0]	wb_adr_o;	
reg			wb_cyc_o;	
reg			wb_stb_o;	
reg			wb_we_o;	
reg	[3:0]		wb_sel_o;	

reg			wb_cab_o;	





reg	[dw-1:0]	wb_dat_o;	






wire			long_ack_o;	
wire			long_err_o;	

wire			aborted;	
reg			aborted_r;	
wire			retry;		












always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_adr_o <= #1 {aw{1'b0}};
	else if ((biu_cyc_i & biu_stb_i) & ~wb_ack_i & ~aborted & ~(wb_stb_o & ~wb_ack_i))
		wb_adr_o <= #1 biu_adr_i;














assign biu_dat_o = wb_dat_i;






always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_dat_o <= #1 {dw{1'b0}};
	else if ((biu_cyc_i & biu_stb_i) & ~wb_ack_i & ~aborted)
		wb_dat_o <= #1 biu_dat_i;









always @(posedge clk or posedge rst)
	if (rst)
		valid_div <= #1 2'b0;
	else
		valid_div <= #1 valid_div + 1'd1;






assign biu_ack_o = long_ack_o






		;













assign long_ack_o = wb_ack_i & ~aborted_r;







assign biu_err_o = long_err_o






		;













assign long_err_o = wb_err_i & ~aborted_r;











assign retry = 1'b0;






















assign aborted = wb_stb_o & ~(biu_cyc_i & biu_stb_i) & ~(wb_ack_i | wb_err_i);
always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		aborted_r <= #1 1'b0;
	else if (wb_ack_i | wb_err_i)
		aborted_r <= #1 1'b0;
	else if (aborted)
		aborted_r <= #1 1'b1;









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_cyc_o <= #1 1'b0;
	else



		wb_cyc_o <= #1 biu_cyc_i & ~wb_ack_i & ~retry | biu_cab_i | aborted & ~wb_ack_i;













always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_stb_o <= #1 1'b0;
	else
		wb_stb_o <= #1 (biu_cyc_i & biu_stb_i) & ~wb_ack_i & ~retry | aborted & ~wb_ack_i;








always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_we_o <= #1 1'b0;
	else
		wb_we_o <= #1 biu_cyc_i & biu_stb_i & biu_we_i | aborted & wb_we_o;








always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_sel_o <= #1 4'b0000;
	else
		wb_sel_o <= #1 biu_sel_i;









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_cab_o <= #1 1'b0;
	else
		wb_cab_o <= #1 biu_cab_i;










































	

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_wbmux.v"









































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 74 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_wbmux.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 76 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_wbmux.v"


module or1200_wbmux(
	
	clk, rst,

	
	wb_freeze, rfwb_op,
	muxin_a, muxin_b, muxin_c, muxin_d,
	muxout, muxreg, muxreg_valid
);

parameter width =  32;








input				clk;
input				rst;




input				wb_freeze;
input	[ 3-1:0]	rfwb_op;
input	[width-1:0]		muxin_a;
input	[width-1:0]		muxin_b;
input	[width-1:0]		muxin_c;
input	[width-1:0]		muxin_d;
output	[width-1:0]		muxout;
output	[width-1:0]		muxreg;
output				muxreg_valid;




reg	[width-1:0]		muxout;
reg	[width-1:0]		muxreg;
reg				muxreg_valid;




always @(posedge clk or posedge rst) begin
	if (rst) begin
		muxreg <= #1 32'd0;
		muxreg_valid <= #1 1'b0;
	end
	else if (!wb_freeze) begin
		muxreg <= #1 muxout;
		muxreg_valid <= #1 rfwb_op[0];
	end
end




always @(muxin_a or muxin_b or muxin_c or muxin_d or rfwb_op) begin



	case(rfwb_op[ 3-1:1]) 

		2'b00: muxout = muxin_a;
		2'b01: begin
			muxout = muxin_b;





		end
		2'b10: begin
			muxout = muxin_c;





		end
		2'b11: begin
			muxout = muxin_d + 32'h8;





		end
	endcase
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_xcv_ram32x8d.v"



































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 68 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_xcv_ram32x8d.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_defines.v"

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































`line 70 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\or1200\or1200_xcv_ram32x8d.v"












































































































































































































































































































































































































































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\mem_if\onchip_ram.v"








module onchip_ram_top (wb_clk_i,
		       wb_rst_i,
		       wb_dat_i,
		       wb_dat_o,
		       wb_adr_i,
		       wb_sel_i,
		       wb_we_i,
		       wb_cyc_i,
		       wb_stb_i,
		       wb_ack_o,
		       wb_err_o);
   
   
   
   parameter aw = 13;

   
   
   
   input     wb_clk_i;
   input     wb_rst_i;

   
   
   
   input [31:0] wb_dat_i;
   output [31:0] wb_dat_o;
   input [31:0]  wb_adr_i;
   input [3:0] 	 wb_sel_i;
   input 	 wb_we_i;
   input 	 wb_cyc_i;
   input 	 wb_stb_i;
   output 	 wb_ack_o;
   output 	 wb_err_o;

   
   
   
   wire 	 we;
   wire [3:0] 	 be_i;
   
   wire [31:0] 	 wb_dat_o;
   reg 		 ack_we;
   reg 		 ack_re;

   
   
   
   assign 	 wb_ack_o = ack_re | ack_we;
   assign 	 wb_err_o = wb_cyc_i & wb_stb_i & (|wb_adr_i[23:aw+2]);

   
   assign 	 we = wb_cyc_i & wb_stb_i & wb_we_i & (|wb_sel_i[3:0]);
   assign 	 be_i = (wb_cyc_i & wb_stb_i) * wb_sel_i;

   
   
   
   always @ (negedge wb_clk_i or posedge wb_rst_i) begin
      if (wb_rst_i)
	ack_we <= 1'b0;
      else if (wb_cyc_i & wb_stb_i & wb_we_i & ~ack_we)
	ack_we <= #1 1'b1;
      else
	ack_we <= #1 1'b0;
   end

   
   
   
   always @ (posedge wb_clk_i or posedge wb_rst_i) begin
      if (wb_rst_i)
	ack_re <= 1'b0;
      else if (wb_cyc_i & wb_stb_i & ~wb_err_o & ~wb_we_i & ~ack_re)
	ack_re <= #1 1'b1;
      else
	ack_re <= #1 1'b0;
   end

  reg [7:0] mem [0:2048*16-1];
  reg  [8*256:1] ram_initf;
  integer i,j;
  parameter lpm_file="hello.ihex";
	initial begin
	     $convert_hex2ver(lpm_file,8, ram_initf);
       $readmemh(ram_initf, mem);
			 j=0;
			 for (i=0;i< 2048*16;i=i+4) begin
				lpm_ram_dq_component_bank0.mem[j]=mem[0+i];
			  lpm_ram_dq_component_bank1.mem[j]=mem[1+i];
			  lpm_ram_dq_component_bank2.mem[j]=mem[2+i];
		 	  lpm_ram_dq_component_bank3.mem[j]=mem[3+i];
			  j=j+1;
		end	
	end



   lpm_ram_dq_bank0 lpm_ram_dq_component_bank0(
					       .reset(wb_rst_i),
					       .address (wb_adr_i[aw+1:2]),
  					       .inclock (wb_clk_i),
					       .data (wb_dat_i[31:24]),
					       .we (we & be_i[3]),
					       .q (wb_dat_o[31:24]));

   lpm_ram_dq_bank1 lpm_ram_dq_component_bank1(
					       .reset(wb_rst_i),
					       .address (wb_adr_i[aw+1:2]),
					       .inclock (wb_clk_i),
					       .data (wb_dat_i[23:16]),
					       .we (we & be_i[2]),
					       .q (wb_dat_o[23:16]));
   
   lpm_ram_dq_bank2 lpm_ram_dq_component_bank2(
					       .reset(wb_rst_i),
					       .address (wb_adr_i[aw+1:2]),
					       .inclock (wb_clk_i),
					       .data (wb_dat_i[15:8]),
					       .we (we & be_i[1]),
					       .q (wb_dat_o[15:8]));

   lpm_ram_dq_bank3 lpm_ram_dq_component_bank3(
					       .reset(wb_rst_i),
					       .address (wb_adr_i[aw+1:2]),
					       .inclock (wb_clk_i),
					       .data (wb_dat_i[7:0]),
					       .we (we & be_i[0]),
					       .q (wb_dat_o[7:0]));




























 



	
      
      
      
	

   reg [0:640*2-1] char_buffer;
   integer  counter=0;    
   wire mem_write=wb_we_i;
   wire clock=wb_clk_i;
   wire [31:0] mem_address=wb_adr_i;
   wire [31:0] mem_data_w=wb_dat_i;
   
   task Cprint;
		integer i;
		begin :Block
			i=0;
			while (1) begin
				if (char_buffer[i*8 +:8] ===8'h00 || char_buffer[i*8 +:8]===8'hxx) begin
						disable Block;
				end	
				$write("%c",char_buffer[i*8 +:8]);
				i=i+1;  
			end
		end
	endtask	
   always @ (negedge clock ) begin
            if ((mem_write === 1'b1)) begin 
           	   if (mem_address== 16'h7ff0) begin
				if (mem_data_w[7:0]===8'h00) begin
					char_buffer[counter*8 +:8]=mem_data_w[7:0];
					if (char_buffer[0  +:8*7]==="$finish") begin
							$finish;				
							
					end else if (char_buffer[0  +:8*5]==="$time") begin
							$display("Current Time on Simulation=%d",$time);				
							
					end else  Cprint;

					for (counter=0; counter< 80*2; counter=counter+1) begin
						char_buffer[counter*8 +:8]=8'h00;
					end
					counter=0;
				
				end else begin
					char_buffer[counter*8 +:8]=mem_data_w[7:0];
					counter=counter+1;
				end
		   end
       	   else if (mem_address== 16'h7ff1) begin
				$write("%h ",mem_data_w[7:0]);
		   end else if (mem_address== 16'h7ff2) begin
				$write("%h ",mem_data_w[15:0]);
		   end else if (mem_address== 16'h7ff4) begin
				$write("%h ",mem_data_w[31:0]);
		   end 
	end 
   end 



endmodule 


module lpm_ram_dq_bank0(
			reset,
			address,
			we,
			inclock,
			data,
			q);
   input                reset;
   input [12:0] 	address;
   input 		we;
   input 		inclock;
   input [7:0] 		data;
   output [7:0] 	q;

   reg [7:0] 		mem[0:4096*2-1];
   
   
   assign 		q = we ? 8'hZZ : mem[address];
   always @(posedge inclock or posedge reset) begin
      if (reset) begin
 
      end else if (we == 1'b1) begin
	 mem[address] <= data;
      end
   end
endmodule

module lpm_ram_dq_bank1(
			reset,
			address,
			we,
			inclock,
			data,
			q);
   input                reset;
   input [12:0] 	address;
   input 		we;
   input 		inclock;
   input [7:0] 		data;
   output [7:0] 	q;

   reg [7:0] 		mem[0:4096*2-1];
   
   assign 		q = we ? 8'hZZ : mem[address];
   always @(posedge inclock or posedge reset) begin
      if (reset) begin
 
      end else if (we == 1'b1) begin
	 mem[address] <= data;
      end
   end
endmodule

module lpm_ram_dq_bank2(
			reset,
			address,
			we,
			inclock,
			data,
			q);
   input                reset;
   input [12:0] 	address;
   input 		we;
   input 		inclock;
   input [7:0] 		data;
   output [7:0] 	q;

   reg [7:0] 		mem[0:4096*2-1];
   
   assign 		q = we ? 8'hZZ : mem[address];
   always @(posedge inclock or posedge reset) begin
      if (reset) begin

      end else if (we == 1'b1) begin
	 mem[address] <= data;
      end
   end
endmodule

module lpm_ram_dq_bank3(
			reset,
			address,
			we,
			inclock,
			data,
			q);
   input                reset;
   input [12:0] 	address;
   input 		we;
   input 		inclock;
   input [7:0] 		data;
   output [7:0] 	q;

   reg [7:0] 		mem[0:4096*2-1];
   
   assign 		q = we ? 8'hZZ : mem[address];
   always @(posedge inclock or posedge reset) begin
      if (reset) begin

      end else if (we == 1'b1) begin
	 mem[address] <= data;
      end
   end

endmodule





`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_crc8_d1.v"




































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 101 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_crc8_d1.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_defines.v"










































































































































































`line 103 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_crc8_d1.v"



module dbg_crc8_d1 (Data, EnableCrc, Reset, SyncResetCrc, CrcOut, Clk);

parameter Tp = 1;


input Data;
input EnableCrc;
input Reset;
input SyncResetCrc;
input Clk;


output [7:0] CrcOut;
reg    [7:0] CrcOut;



function [7:0] nextCRC8_D1;

  input Data;
  input [7:0] Crc;
  
  reg [0:0] D;
  reg [7:0] C;
  reg [7:0] NewCRC;
  
  begin
    D[0] = Data;
    C = Crc;
  
    NewCRC[0] = D[0] ^ C[7];
    NewCRC[1] = D[0] ^ C[0] ^ C[7];
    NewCRC[2] = D[0] ^ C[1] ^ C[7];
    NewCRC[3] = C[2];
    NewCRC[4] = C[3];
    NewCRC[5] = C[4];
    NewCRC[6] = C[5];
    NewCRC[7] = C[6];
  
    nextCRC8_D1 = NewCRC;
  end
endfunction


always @ (posedge Clk or posedge Reset)
begin
  if(Reset)
    CrcOut[7:0] <= #Tp 0;
  else
  if(SyncResetCrc)
    CrcOut[7:0] <= #Tp 0;
  else
  if(EnableCrc)
    CrcOut[7:0] <= #Tp nextCRC8_D1(Data, CrcOut);
end



endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_defines.v"











































































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_register.v"



































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 68 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_register.v"



module dbg_register(DataIn, DataOut, Write, Clk, Reset, Default);

parameter WIDTH = 8; 

input [WIDTH-1:0] DataIn;

input Write;
input Clk;
input Reset;
input [WIDTH-1:0] Default;

output [WIDTH-1:0] DataOut;
reg    [WIDTH-1:0] DataOut;


always @ (posedge Clk)
begin
  if(Reset)
    DataOut[WIDTH-1:0]<=#1 Default;
  else
    begin
      if(Write)                         
        DataOut[WIDTH-1:0]<=#1 DataIn[WIDTH-1:0];
    end
end


endmodule   



`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_registers.v"
















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 81 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_registers.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_defines.v"










































































































































































`line 83 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_registers.v"


module dbg_registers(DataIn, DataOut, Address, RW, Access, Clk, Bp, Reset, 
                     










                     RiscStall, RiscReset
                    );

parameter Tp = 1;

input [31:0] DataIn;
input [4:0] Address;

input RW;
input Access;
input Clk;
input Bp;
input Reset;

output [31:0] DataOut;
reg    [31:0] DataOut;















































  output RiscStall;
  output RiscReset;

  wire MODER_Acc =   (Address ==  5'h00)   & Access;
  wire RISCOP_Acc =  (Address ==  5'h04)  & Access;







  
  wire MODER_Wr =   MODER_Acc   &  RW;
  wire RISCOP_Wr =  RISCOP_Acc  &  RW;








  
  wire MODER_Rd =   MODER_Acc   &  ~RW;
  wire RISCOP_Rd =  RISCOP_Acc  &  ~RW;








  wire [31:0] MODEROut;
  wire [1:1]  RISCOPOut;













  assign MODEROut[31:0] = 32'h0000;



  reg RiscStallBp;
  always @(posedge Clk or posedge Reset)
  begin
    if(Reset)
      RiscStallBp <= 1'b0;
    else
    if(Bp)                      
      RiscStallBp <= 1'b1;
    else
    if(RISCOP_Wr)               
      RiscStallBp <= DataIn[0];
  end

  dbg_register #(1)  RISCOP (.DataIn(DataIn[1]), .DataOut(RISCOPOut[1]), .Write(RISCOP_Wr),   .Clk(Clk), .Reset(Reset), .Default(1'b0));












always @ (posedge Clk)
begin
  if(MODER_Rd)    DataOut<= #Tp MODEROut;
  else
  if(RISCOP_Rd)   DataOut<= #Tp {30'h0, RISCOPOut[1], RiscStall};










  else            DataOut<= #Tp 'h0;
end













































  assign RiscStall          = Bp | RiscStallBp;   
  assign RiscReset          = RISCOPOut[1];

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_sync_clk1_clk2.v"































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 64 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_sync_clk1_clk2.v"




module dbg_sync_clk1_clk2 (clk1, clk2, reset1, reset2, set2, sync_out);

parameter   Tp = 1;

input   clk1;
input   clk2;
input   reset1;
input   reset2;
input   set2;

output  sync_out;

reg     set2_q;
reg     set2_q2;
reg     set1_q;
reg     set1_q2;
reg     clear2_q;
reg     clear2_q2;
reg     sync_out;

wire    z;

assign z = set2 | set2_q & ~clear2_q2;



always @ (posedge clk2 or posedge reset2)
begin
  if(reset2)
    set2_q <=#Tp 1'b0;
  else
    set2_q <=#Tp z;
end


always @ (posedge clk2 or posedge reset2)
begin
  if(reset2)
    set2_q2 <=#Tp 1'b0;
  else
    set2_q2 <=#Tp set2_q;
end



always @ (posedge clk1 or posedge reset1)
begin
  if(reset1)
    set1_q <=#Tp 1'b0;
  else
    set1_q <=#Tp set2_q2;
end


always @ (posedge clk1 or posedge reset1)
begin
  if(reset1)
    set1_q2 <=#Tp 1'b0;
  else
    set1_q2 <=#Tp set1_q;
end



always @ (posedge clk2 or posedge reset2)
begin
  if(reset2)
    clear2_q <=#Tp 1'b0;
  else
    clear2_q <=#Tp set1_q2;
end


always @ (posedge clk2 or posedge reset2)
begin
  if(reset2)
    clear2_q2 <=#Tp 1'b0;
  else
    clear2_q2 <=#Tp clear2_q;
end


always @ (posedge clk1 or posedge reset1)
begin
  if(reset1)
    sync_out <=#Tp 1'b0;
  else
    sync_out <=#Tp set1_q2;
end

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_top.v"































































































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 128 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_top.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_defines.v"










































































































































































`line 130 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_top.v"



module dbg_top(
                
                tms_pad_i, tck_pad_i, trst_pad_i, tdi_pad_i, tdo_pad_o, tdo_padoen_o,

                
                capture_dr_o, shift_dr_o, update_dr_o, extest_selected_o, bs_chain_i, bs_chain_o, 
                
                
                risc_clk_i, risc_addr_o, risc_data_i, risc_data_o, wp_i, 
                bp_i, opselect_o, lsstatus_i, istatus_i, risc_stall_o, reset_o, 
                
                
                wb_rst_i, wb_clk_i, 

                
                wb_adr_o, wb_dat_o, wb_dat_i, wb_cyc_o, wb_stb_o, wb_sel_o,
                wb_we_o, wb_ack_i, wb_cab_o, wb_err_i


              );

parameter Tp = 1;


input         tms_pad_i;                  
input         tck_pad_i;                  
input         trst_pad_i;                 
input         tdi_pad_i;                  
output        tdo_pad_o;                  
output        tdo_padoen_o;               



output capture_dr_o;
output shift_dr_o;
output update_dr_o;
output extest_selected_o;
input  bs_chain_i;
output bs_chain_o;


input         risc_clk_i;                 
input  [31:0] risc_data_i;                
input  [10:0] wp_i;                       
input         bp_i;                       
input  [3:0]  lsstatus_i;                 
input  [1:0]  istatus_i;                  
output [31:0] risc_addr_o;                
output [31:0] risc_data_o;                
output [ 3-1:0] opselect_o;   
output                      risc_stall_o; 
output                      reset_o;      



input         wb_rst_i;                   
input         wb_clk_i;                   


output [31:0] wb_adr_o;
output [31:0] wb_dat_o;
input  [31:0] wb_dat_i;
output        wb_cyc_o;
output        wb_stb_o;
output  [3:0] wb_sel_o;
output        wb_we_o;
input         wb_ack_i;
output        wb_cab_o;
input         wb_err_i;

reg           wb_cyc_o;


reg TestLogicReset;
reg RunTestIdle;
reg SelectDRScan;
reg CaptureDR;
reg ShiftDR;
reg Exit1DR;
reg PauseDR;
reg Exit2DR;
reg UpdateDR;

reg SelectIRScan;
reg CaptureIR;
reg ShiftIR;
reg Exit1IR;
reg PauseIR;
reg Exit2IR;
reg UpdateIR;



reg EXTESTSelected;
reg SAMPLE_PRELOADSelected;
reg IDCODESelected;
reg CHAIN_SELECTSelected;
reg INTESTSelected;
reg CLAMPSelected;
reg CLAMPZSelected;
reg HIGHZSelected;
reg DEBUGSelected;
reg BYPASSSelected;

reg [31:0]  ADDR;
reg [31:0]  DataOut;

reg [ 3-1:0] opselect_o;      

reg [ 4-1:0] Chain;         
reg [31:0]  DataReadLatch;                
reg         RegAccessTck;                 
reg         RISCAccessTck;                
reg [7:0]   BitCounter;                   
reg         RW;                           
reg         CrcMatch;                     

reg         RegAccess_q;                  
reg         RegAccess_q2;                 
reg         RISCAccess_q;                 
reg         RISCAccess_q2;                

reg         wb_AccessTck;                 
reg [31:0]  WBReadLatch;                  
reg         WBErrorLatch;                 
wire        trst;                         

reg         BypassRegister;               


wire TCK = tck_pad_i;
wire TMS = tms_pad_i;
wire TDI = tdi_pad_i;

wire [31:0]             RegDataIn;        
wire [ 8-1:0]  CalculatedCrcOut; 

wire RiscStall_reg;                       
wire RiscReset_reg;                       
wire RiscStall_trace;                     
       
       
wire RegisterScanChain;                   
wire RiscDebugScanChain;                  
wire WishboneScanChain;                   

wire RiscStall_read_access;               
wire RiscStall_write_access;              
wire RiscStall_access;                    

wire BitCounter_Lt4;
wire BitCounter_Eq5;
wire BitCounter_Eq32;
wire BitCounter_Lt38;
wire BitCounter_Lt65;

assign capture_dr_o       = CaptureDR;
assign shift_dr_o         = ShiftDR;
assign update_dr_o        = UpdateDR;
assign extest_selected_o  = EXTESTSelected;
wire   BS_CHAIN_I         = bs_chain_i;
assign bs_chain_o         = tdi_pad_i;








































































assign trst = ~trst_pad_i;                









always @ (posedge TCK or posedge trst)
begin
  if(trst)
    TestLogicReset<=#Tp 1;
  else
    begin
      if(TMS & (TestLogicReset | SelectIRScan))
        TestLogicReset<=#Tp 1;
      else
        TestLogicReset<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    RunTestIdle<=#Tp 0;
  else
    begin
      if(~TMS & (TestLogicReset | RunTestIdle | UpdateDR | UpdateIR))
        RunTestIdle<=#Tp 1;
      else
        RunTestIdle<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    SelectDRScan<=#Tp 0;
  else
    begin
      if(TMS & (RunTestIdle | UpdateDR | UpdateIR))
        SelectDRScan<=#Tp 1;
      else
        SelectDRScan<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    CaptureDR<=#Tp 0;
  else
    begin
      if(~TMS & SelectDRScan)
        CaptureDR<=#Tp 1;
      else
        CaptureDR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    ShiftDR<=#Tp 0;
  else
    begin
      if(~TMS & (CaptureDR | ShiftDR | Exit2DR))
        ShiftDR<=#Tp 1;
      else
        ShiftDR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    Exit1DR<=#Tp 0;
  else
    begin
      if(TMS & (CaptureDR | ShiftDR))
        Exit1DR<=#Tp 1;
      else
        Exit1DR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    PauseDR<=#Tp 0;
  else
    begin
      if(~TMS & (Exit1DR | PauseDR))
        PauseDR<=#Tp 1;
      else
        PauseDR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    Exit2DR<=#Tp 0;
  else
    begin
      if(TMS & PauseDR)
        Exit2DR<=#Tp 1;
      else
        Exit2DR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    UpdateDR<=#Tp 0;
  else
    begin
      if(TMS & (Exit1DR | Exit2DR))
        UpdateDR<=#Tp 1;
      else
        UpdateDR<=#Tp 0;
    end
end


reg UpdateDR_q;
always @ (posedge TCK)
begin
  UpdateDR_q<=#Tp UpdateDR;
end



always @ (posedge TCK or posedge trst)
begin
  if(trst)
    SelectIRScan<=#Tp 0;
  else
    begin
      if(TMS & SelectDRScan)
        SelectIRScan<=#Tp 1;
      else
        SelectIRScan<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    CaptureIR<=#Tp 0;
  else
    begin
      if(~TMS & SelectIRScan)
        CaptureIR<=#Tp 1;
      else
        CaptureIR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    ShiftIR<=#Tp 0;
  else
    begin
      if(~TMS & (CaptureIR | ShiftIR | Exit2IR))
        ShiftIR<=#Tp 1;
      else
        ShiftIR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    Exit1IR<=#Tp 0;
  else
    begin
      if(TMS & (CaptureIR | ShiftIR))
        Exit1IR<=#Tp 1;
      else
        Exit1IR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    PauseIR<=#Tp 0;
  else
    begin
      if(~TMS & (Exit1IR | PauseIR))
        PauseIR<=#Tp 1;
      else
        PauseIR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    Exit2IR<=#Tp 0;
  else
    begin
      if(TMS & PauseIR)
        Exit2IR<=#Tp 1;
      else
        Exit2IR<=#Tp 0;
    end
end


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    UpdateIR<=#Tp 0;
  else
    begin
      if(TMS & (Exit1IR | Exit2IR))
        UpdateIR<=#Tp 1;
      else
        UpdateIR<=#Tp 0;
    end
end














wire [1:0]Status = 2'b10;     

reg [ 4-1:0]JTAG_IR;  
reg [ 4-1:0]LatchedJTAG_IR;

reg TDOInstruction;

always @ (posedge TCK or posedge trst)
begin
  if(trst)
    JTAG_IR[ 4-1:0] <= #Tp 0;
  else
    begin
      if(CaptureIR)
        begin
          JTAG_IR[1:0] <= #Tp 2'b01;       
          JTAG_IR[3:2] <= #Tp Status[1:0]; 
        end
      else
        begin
          if(ShiftIR)
            begin
              JTAG_IR[ 4-1:0] <= #Tp {TDI, JTAG_IR[ 4-1:1]};
            end
        end
    end
end



always @ (negedge TCK)
begin
  if(ShiftIR)
    TDOInstruction <= #Tp JTAG_IR[0];
end













reg [ 74-1:0]JTAG_DR_IN;    
reg TDOData;


always @ (posedge TCK or posedge trst)
begin
  if(trst)
    JTAG_DR_IN[ 74-1:0]<=#Tp 0;
  else
  if(IDCODESelected)                          
    begin
      if(ShiftDR)
        JTAG_DR_IN[31:0] <= #Tp {TDI, JTAG_DR_IN[31:1]};
      else
        JTAG_DR_IN[31:0] <= #Tp  32'hdeadbeef;
    end
  else
  if(CHAIN_SELECTSelected & ShiftDR)
    JTAG_DR_IN[12:0] <= #Tp {TDI, JTAG_DR_IN[12:1]};
  else
  if(DEBUGSelected & ShiftDR)
    begin
      if(RiscDebugScanChain | WishboneScanChain)
        JTAG_DR_IN[73:0] <= #Tp {TDI, JTAG_DR_IN[73:1]};
      else
      if(RegisterScanChain)
        JTAG_DR_IN[46:0] <= #Tp {TDI, JTAG_DR_IN[46:1]};
    end
end
 
wire [73:0] RISC_Data;
wire [46:0] Register_Data;
wire [73:0] WISHBONE_Data;
wire [12:0] chain_sel_data;
wire wb_Access_wbClk;


reg select_crc_out;
always @ (posedge TCK or posedge trst)
begin
  if(trst)
    select_crc_out <= 0;
  else
  if( RegisterScanChain  & BitCounter_Eq5  |
      RiscDebugScanChain & BitCounter_Eq32 |
      WishboneScanChain  & BitCounter_Eq32 )
    select_crc_out <=#Tp TDI;
  else
  if(CHAIN_SELECTSelected)
    select_crc_out <=#Tp 1;
  else
  if(UpdateDR)
    select_crc_out <=#Tp 0;
end

wire [8:0] send_crc;

assign send_crc = select_crc_out? {9{BypassRegister}}    :    
                                  {CalculatedCrcOut, 1'b0} ;  

assign RISC_Data      = {send_crc, DataReadLatch, 33'h0};
assign Register_Data  = {send_crc, DataReadLatch, 6'h0};
assign WISHBONE_Data  = {send_crc, WBReadLatch, 32'h0, WBErrorLatch};
assign chain_sel_data = {send_crc, 4'h0};
                                                  
                                                  





always @ (negedge TCK or posedge trst)
begin
  if(trst)
    begin
      TDOData <= #Tp 0;
      


    end
  else
  if(UpdateDR)
    begin
      TDOData <= #Tp CrcMatch;
      



    end
  else
    begin
      if(ShiftDR)
        begin
          if(IDCODESelected)
            TDOData <= #Tp JTAG_DR_IN[0]; 
          else
          if(CHAIN_SELECTSelected)
            TDOData <= #Tp chain_sel_data[BitCounter];        
          else
          if(DEBUGSelected)
            begin
              if(RiscDebugScanChain)
                TDOData <= #Tp RISC_Data[BitCounter];         
              else
              if(RegisterScanChain)
                TDOData <= #Tp Register_Data[BitCounter];     
              else
              if(WishboneScanChain)
                TDOData <= #Tp WISHBONE_Data[BitCounter];     
              




            end
        end
      else
        begin
          TDOData <= #Tp 0;
          


        end
    end
end














always @ (posedge TCK or posedge trst)
begin
  if(trst)
    Chain[ 4-1:0]<=#Tp  4'b0000;  
  else
  if(UpdateDR & CHAIN_SELECTSelected & CrcMatch)
    Chain[ 4-1:0]<=#Tp JTAG_DR_IN[3:0];   
end









always @ (posedge TCK or posedge trst)
begin
  if(trst)
    begin
      ADDR[31:0]        <=#Tp 32'h0;
      DataOut[31:0]     <=#Tp 32'h0;
      RW                <=#Tp 1'b0;
      RegAccessTck      <=#Tp 1'b0;
      RISCAccessTck     <=#Tp 1'b0;
      wb_AccessTck      <=#Tp 1'h0;
    end
  else
  if(UpdateDR & DEBUGSelected & CrcMatch)
    begin
      if(RegisterScanChain)
        begin
          ADDR[4:0]         <=#Tp JTAG_DR_IN[4:0];    
          RW                <=#Tp JTAG_DR_IN[5];      
          DataOut[31:0]     <=#Tp JTAG_DR_IN[37:6];   
          RegAccessTck      <=#Tp 1'b1;
        end
      else
      if(RiscDebugScanChain)
        begin
          ADDR[31:0]        <=#Tp JTAG_DR_IN[31:0];   
          RW                <=#Tp JTAG_DR_IN[32];     
          DataOut[31:0]     <=#Tp JTAG_DR_IN[64:33];  
          RISCAccessTck     <=#Tp 1'b1;
        end
      else
      if(WishboneScanChain)
        begin
          ADDR              <=#Tp JTAG_DR_IN[31:0];   
          RW                <=#Tp JTAG_DR_IN[32];     
          DataOut           <=#Tp JTAG_DR_IN[64:33];  
          wb_AccessTck      <=#Tp 1'b1;               
        end
    end
  else
    begin
      RegAccessTck      <=#Tp 1'b0;       
      RISCAccessTck     <=#Tp 1'b0;
      wb_AccessTck      <=#Tp 1'b0;
    end
end


assign wb_adr_o = ADDR;
assign wb_we_o  = RW;
assign wb_dat_o = DataOut;
assign wb_sel_o[3:0] = 4'hf;
assign wb_cab_o = 1'b0;
   
   

dbg_sync_clk1_clk2 syn1 (.clk1(risc_clk_i),   .clk2(TCK),           .reset1(wb_rst_i),  .reset2(trst), 
                         .set2(RegAccessTck), .sync_out(RegAccess)
                        );


dbg_sync_clk1_clk2 syn2 (.clk1(risc_clk_i),    .clk2(TCK),          .reset1(wb_rst_i),  .reset2(trst), 
                         .set2(RISCAccessTck), .sync_out(RISCAccess)
                        );



dbg_sync_clk1_clk2 syn3 (.clk1(wb_clk_i),     .clk2(TCK),           .reset1(wb_rst_i),  .reset2(trst), 
                         .set2(wb_AccessTck), .sync_out(wb_Access_wbClk)
                        );






always @ (posedge risc_clk_i or posedge wb_rst_i)
begin
  if(wb_rst_i)
    begin
      RegAccess_q   <=#Tp 1'b0;
      RegAccess_q2  <=#Tp 1'b0;
      RISCAccess_q  <=#Tp 1'b0;
      RISCAccess_q2 <=#Tp 1'b0;
    end
  else
    begin
      RegAccess_q   <=#Tp RegAccess;
      RegAccess_q2  <=#Tp RegAccess_q;
      RISCAccess_q  <=#Tp RISCAccess;
      RISCAccess_q2 <=#Tp RISCAccess_q;
    end
end


assign RiscStall_write_access = RISCAccess & ~RISCAccess_q  &  RW;
assign RiscStall_read_access  = RISCAccess & ~RISCAccess_q2 & ~RW;
assign RiscStall_access = RiscStall_write_access | RiscStall_read_access;


reg wb_Access_wbClk_q;

always @ (posedge wb_clk_i or posedge wb_rst_i)
begin
  if(wb_rst_i)
    wb_Access_wbClk_q <=#Tp 1'b0;
  else
    wb_Access_wbClk_q <=#Tp wb_Access_wbClk;
end

always @ (posedge wb_clk_i or posedge wb_rst_i)
begin
  if(wb_rst_i)
    wb_cyc_o <=#Tp 1'b0;
  else
  if(wb_Access_wbClk & ~wb_Access_wbClk_q & ~(wb_ack_i | wb_err_i))
    wb_cyc_o <=#Tp 1'b1;
  else
  if(wb_ack_i | wb_err_i)
    wb_cyc_o <=#Tp 1'b0;
end

assign wb_stb_o = wb_cyc_o;



always @ (posedge wb_clk_i or posedge wb_rst_i)
begin
  if(wb_rst_i)
    WBReadLatch[31:0]<=#Tp 32'h0;
  else
  if(wb_ack_i)
    WBReadLatch[31:0]<=#Tp wb_dat_i[31:0];
end


always @ (posedge wb_clk_i or posedge wb_rst_i)
begin
  if(wb_rst_i)
    WBErrorLatch<=#Tp 1'b0;
  else
  if(wb_err_i)
    WBErrorLatch<=#Tp 1'b1;     
  else
  if(wb_ack_i)
    WBErrorLatch<=#Tp 1'b0;     
end






  assign  risc_stall_o = RiscStall_access | RiscStall_reg;


assign  reset_o = RiscReset_reg;





always @ (RiscStall_write_access or RiscStall_read_access)

begin
  if(RiscStall_write_access)
    opselect_o =  5;  
  else
  if(RiscStall_read_access)
    opselect_o =  4;   
  else



    opselect_o = 3'h0;

end



always @ (posedge risc_clk_i or posedge wb_rst_i)
begin
  if(wb_rst_i)
    DataReadLatch[31:0]<=#Tp 0;
  else
  if(RISCAccess_q & ~RISCAccess_q2)
    DataReadLatch[31:0]<=#Tp risc_data_i[31:0];
  else
  if(RegAccess_q & ~RegAccess_q2)
    DataReadLatch[31:0]<=#Tp RegDataIn[31:0];
end

assign risc_addr_o = ADDR;
assign risc_data_o = DataOut;










































reg TDOBypassed;

always @ (posedge TCK)
begin
  if(ShiftDR)
    BypassRegister<=#Tp TDI;
end

always @ (negedge TCK)
begin
    TDOBypassed<=#Tp BypassRegister;
end

















always @ (posedge TCK or posedge trst)
begin
  if(trst)
    LatchedJTAG_IR <=#Tp  4'b0010;   
  else
  if(UpdateIR)
    LatchedJTAG_IR <=#Tp JTAG_IR;
end




always @ (LatchedJTAG_IR)
begin
  EXTESTSelected          = 0;
  SAMPLE_PRELOADSelected  = 0;
  IDCODESelected          = 0;
  CHAIN_SELECTSelected    = 0;
  INTESTSelected          = 0;
  CLAMPSelected           = 0;
  CLAMPZSelected          = 0;
  HIGHZSelected           = 0;
  DEBUGSelected           = 0;
  BYPASSSelected          = 0;

  case(LatchedJTAG_IR)
     4'b0000:            EXTESTSelected          = 1;    
     4'b0001:    SAMPLE_PRELOADSelected  = 1;    
     4'b0010:            IDCODESelected          = 1;    
     4'b0011:      CHAIN_SELECTSelected    = 1;    
     4'b0100:            INTESTSelected          = 1;    
     4'b0101:             CLAMPSelected           = 1;    
     4'b0110:            CLAMPZSelected          = 1;    
     4'b0111:             HIGHZSelected           = 1;    
     4'b1000:             DEBUGSelected           = 1;    
     4'b1111:            BYPASSSelected          = 1;    
    default:            BYPASSSelected          = 1;    
  endcase
end







wire TDOShifted;
assign TDOShifted = (ShiftIR | Exit1IR)? TDOInstruction : TDOData;









reg TDOMuxed;

always @ (LatchedJTAG_IR or TDOShifted or TDOBypassed or BS_CHAIN_I)
begin
  case(JTAG_IR)
     4'b0010: 
      begin
        TDOMuxed<=#Tp TDOShifted;
      end
     4'b0011: 
      begin
        TDOMuxed<=#Tp TDOShifted;
      end
     4'b1000: 
      begin
        TDOMuxed<=#Tp TDOShifted;
      end
     4'b0001:  
      begin
        TDOMuxed<=#Tp BS_CHAIN_I;
      end
     4'b0000:  
      begin
        TDOMuxed<=#Tp BS_CHAIN_I;
      end
    default:  
      begin
        TDOMuxed<=#Tp TDOBypassed;
      end
  endcase
end



assign tdo_pad_o = TDOMuxed;
assign tdo_padoen_o = ShiftIR | ShiftDR | Exit1IR | Exit1DR | UpdateDR;














always @ (posedge TCK or posedge trst)
begin
  if(trst)
    BitCounter[7:0]<=#Tp 0;
  else
  if(ShiftDR)
    BitCounter[7:0]<=#Tp BitCounter[7:0]+1;
  else
  if(UpdateDR)
    BitCounter[7:0]<=#Tp 0;
end
















dbg_registers dbgregs(.DataIn(DataOut[31:0]), .DataOut(RegDataIn[31:0]), 
                      .Address(ADDR[4:0]), .RW(RW), .Access(RegAccess & ~RegAccess_q), .Clk(risc_clk_i), 
                      .Bp(bp_i), .Reset(wb_rst_i), 
                      

















                      .RiscStall(RiscStall_reg), .RiscReset(RiscReset_reg)

                     );













wire AsyncResetCrc = trst;
wire SyncResetCrc = UpdateDR_q;
wire [7:0] CalculatedCrcIn;     

assign BitCounter_Lt4   = BitCounter<4;
assign BitCounter_Eq5   = BitCounter==5;
assign BitCounter_Eq32  = BitCounter==32;
assign BitCounter_Lt38  = BitCounter<38;
assign BitCounter_Lt65  = BitCounter<65;






wire EnableCrcIn = ShiftDR & 
                  ( (CHAIN_SELECTSelected                 & BitCounter_Lt4) |
                    ((DEBUGSelected & RegisterScanChain)  & BitCounter_Lt38)| 
                    ((DEBUGSelected & RiscDebugScanChain) & BitCounter_Lt65)|
                    ((DEBUGSelected & WishboneScanChain)  & BitCounter_Lt65)  
                  );

wire EnableCrcOut= ShiftDR & 
                   (
                    ((DEBUGSelected & RegisterScanChain)  & BitCounter_Lt38)| 
                    ((DEBUGSelected & RiscDebugScanChain) & BitCounter_Lt65)|
                    ((DEBUGSelected & WishboneScanChain)  & BitCounter_Lt65)  
                    



                   );


dbg_crc8_d1 crc1 (.Data(TDI), .EnableCrc(EnableCrcIn), .Reset(AsyncResetCrc), .SyncResetCrc(SyncResetCrc), 
                  .CrcOut(CalculatedCrcIn), .Clk(TCK));


dbg_crc8_d1 crc2 (.Data(TDOData), .EnableCrc(EnableCrcOut), .Reset(AsyncResetCrc), .SyncResetCrc(SyncResetCrc), 
                  .CrcOut(CalculatedCrcOut), .Clk(TCK));



always @ (posedge TCK or posedge trst)
begin
  if(trst)
    CrcMatch <=#Tp 1'b0;
  else
  if(Exit1DR)
    begin
      if(CHAIN_SELECTSelected)
        CrcMatch <=#Tp CalculatedCrcIn == JTAG_DR_IN[11:4];
      else
        begin
          if(RegisterScanChain)
            CrcMatch <=#Tp CalculatedCrcIn == JTAG_DR_IN[45:38];
          else
          if(RiscDebugScanChain)
            CrcMatch <=#Tp CalculatedCrcIn == JTAG_DR_IN[72:65];
          else
          if(WishboneScanChain)
            CrcMatch <=#Tp CalculatedCrcIn == JTAG_DR_IN[72:65];
        end
    end
end



assign RegisterScanChain   = Chain ==  4'b0100;
assign RiscDebugScanChain  = Chain ==  4'b0001;
assign WishboneScanChain   = Chain ==  4'b0101;















































endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_trace.v"



















































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 84 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_trace.v"


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_defines.v"










































































































































































`line 86 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\dbg_trace.v"



module dbg_trace (Wp, Bp, DataIn, OpSelect, LsStatus, IStatus, RiscStall_O, 
                  Mclk, Reset, TraceChain, ContinMode, TraceEnable_reg, 
                  WpTrigger, BpTrigger, LSSTrigger, ITrigger, TriggerOper, WpQualif, 
                  BpQualif, LSSQualif, IQualif, QualifOper, RecordPC, RecordLSEA, 
                  RecordLDATA, RecordSDATA, RecordReadSPR, RecordWriteSPR, 
                  RecordINSTR, 
                  WpTriggerValid, BpTriggerValid, LSSTriggerValid, ITriggerValid, 
                  WpQualifValid, BpQualifValid, LSSQualifValid, IQualifValid, ReadBuffer,
                  WpStop, BpStop, LSSStop, IStop, StopOper, WpStopValid, BpStopValid, 
                  LSSStopValid, IStopValid 
                 );

parameter Tp = 1;


input [10:0] Wp;              
input        Bp;              
input [31:0] DataIn;          
input [3:0]  LsStatus;        
input [1:0]  IStatus;         

input        Mclk;            
input        Reset;           
input        ReadBuffer;      


input ContinMode;             
input TraceEnable_reg;        

input [10:0] WpTrigger;       
input        BpTrigger;       
input [3:0]  LSSTrigger;      
input [1:0]  ITrigger;        
input [1:0]  TriggerOper;     

input [10:0] WpQualif;        
input        BpQualif;        
input [3:0]  LSSQualif;       
input [1:0]  IQualif;         
input [1:0]  QualifOper;      

input [10:0] WpStop;          
input        BpStop;          
input [3:0]  LSSStop;         
input [1:0]  IStop;           
input [1:0]  StopOper;        

input RecordPC;               
input RecordLSEA;             
input RecordLDATA;            
input RecordSDATA;            
input RecordReadSPR;          
input RecordWriteSPR;         
input RecordINSTR;            

input WpTriggerValid;         
input BpTriggerValid;         
input LSSTriggerValid;        
input ITriggerValid;          

input WpQualifValid;          
input BpQualifValid;          
input LSSQualifValid;         
input IQualifValid;           

input WpStopValid;            
input BpStopValid;            
input LSSStopValid;           
input IStopValid;             



output [ 3-1:0]  OpSelect;  
output        RiscStall_O;              
output [39:0] TraceChain;               

reg TraceEnable_d;
reg TraceEnable;



reg [ 5:0] Counter;
reg [ 5-1:0] WritePointer;
reg [ 5-1:0] ReadPointer;
reg RiscStall;
reg RiscStall_q;
reg [ 3-1:0] StallCounter;

reg [ 36-1:0] Buffer[0: 32-1];

reg TriggerLatch;







wire TempWpTrigger = |(Wp[10:0] & WpTrigger[10:0]);
wire TempBpTrigger = Bp & BpTrigger;
wire TempLSSTrigger = LsStatus[3:0] == LSSTrigger[3:0];
wire TempITrigger = IStatus[1:0] == ITrigger[1:0];

wire TempTriggerAND =  (  (TempWpTrigger  | ~WpTriggerValid)
                        & (TempBpTrigger  | ~BpTriggerValid) 
                        & (TempLSSTrigger | ~LSSTriggerValid) 
                        & (TempITrigger   | ~ITriggerValid)
                       ) 
                       & (WpTriggerValid | BpTriggerValid | LSSTriggerValid | ITriggerValid);

wire TempTriggerOR =   (  (TempWpTrigger  &  WpTriggerValid)
                        | (TempBpTrigger  &  BpTriggerValid) 
                        | (TempLSSTrigger &  LSSTriggerValid) 
                        | (TempITrigger   &  ITriggerValid)
                       );

wire Trigger = TraceEnable & (~TriggerOper[1]?  1 :                               
                               TriggerOper[0]?  TempTriggerAND : TempTriggerOR    
                             );






wire TempWpQualifier = |(Wp[10:0] & WpQualif[10:0]);
wire TempBpQualifier = Bp & BpQualif;
wire TempLSSQualifier = LsStatus[3:0] == LSSQualif[3:0];
wire TempIQualifier = IStatus[1:0] == IQualif[1:0];

wire TempQualifierAND =  (  (TempWpQualifier  | ~WpQualifValid)
                          & (TempBpQualifier  | ~BpQualifValid) 
                          & (TempLSSQualifier | ~LSSQualifValid) 
                          & (TempIQualifier   | ~IQualifValid)
                         ) 
                         & (WpQualifValid | BpQualifValid | LSSQualifValid | IQualifValid);

wire TempQualifierOR =   (  (TempWpQualifier  &  WpQualifValid)
                          | (TempBpQualifier  &  BpQualifValid) 
                          | (TempLSSQualifier &  LSSQualifValid) 
                          | (TempIQualifier   &  IQualifValid)
                         );


wire Stop;
wire Qualifier = TraceEnable & ~Stop & (~QualifOper[1]? 1 :                                   
                                         QualifOper[0]? TempQualifierAND  :  TempQualifierOR  
                                       );






wire TempWpStop = |(Wp[10:0] & WpStop[10:0]);
wire TempBpStop = Bp & BpStop;
wire TempLSSStop = LsStatus[3:0] == LSSStop[3:0];
wire TempIStop = IStatus[1:0] == IStop[1:0];

wire TempStopAND =       (  (TempWpStop  | ~WpStopValid)
                          & (TempBpStop  | ~BpStopValid) 
                          & (TempLSSStop | ~LSSStopValid) 
                          & (TempIStop   | ~IStopValid)
                         ) 
                         & (WpStopValid | BpStopValid | LSSStopValid | IStopValid);

wire TempStopOR =        (  (TempWpStop  &  WpStopValid)
                          | (TempBpStop  &  BpStopValid) 
                          | (TempLSSStop &  LSSStopValid) 
                          | (TempIStop   &  IStopValid)
                         );


assign Stop = TraceEnable & (~StopOper[1]? 0 :                         
                              StopOper[0]? TempStopAND  :  TempStopOR  
                            );








always @(posedge Mclk or posedge Reset)
begin
  if(Reset)
    TriggerLatch<=#Tp 0;
  else
  if(TriggerLatch & ~TraceEnable)
    TriggerLatch<=#Tp 0;
  else
  if(Trigger)
    TriggerLatch<=#Tp 1;
end









always @(posedge Mclk or posedge Reset)
begin
  if(Reset)
    begin
      TraceEnable_d<=#Tp 0;
      TraceEnable<=#Tp 0;
    end
  else
    begin
      TraceEnable_d<=#Tp TraceEnable_reg;
      TraceEnable<=#Tp TraceEnable_d;
    end
end









reg BufferFullDetected;
wire [ 8-1:0] RecEnable;

wire BufferFull = Counter[ 5:0]== 32;
wire BufferEmpty = Counter[ 5:0]==0;
wire IncrementCounter = RiscStall_q & ~(BufferFull | BufferFullDetected) & Qualifier & RecEnable[StallCounter];
wire IncrementPointer = RiscStall_q & (~BufferFull | ContinMode) & Qualifier & RecEnable[StallCounter];

wire WriteSample = IncrementPointer;

wire Decrement = ReadBuffer & ~BufferEmpty & (~ContinMode | ContinMode & ~TraceEnable);
wire CounterEn = IncrementCounter ^ Decrement;

wire SyncResetCpuStall;
wire ResetStallCounter;
reg BufferFull_q;
reg BufferFull_2q;

reg Qualifier_mclk;

always @(posedge Mclk)
begin
  Qualifier_mclk<=#Tp Qualifier;
  BufferFull_q<=#Tp BufferFull;
  BufferFull_2q<=#Tp BufferFull_q;
  RiscStall_q <=#Tp RiscStall_O;
end


wire FirstCpuStall =    Qualifier & ~Qualifier_mclk & TriggerLatch              | 
                        Qualifier_mclk & Trigger & ~TriggerLatch                | 
                        Qualifier & Trigger & ~Qualifier_mclk & ~TriggerLatch   ;




wire SyncSetCpuStall = RiscStall_O & ~RiscStall_q |
                        Qualifier_mclk & TriggerLatch &
                       ( 
                        (~ContinMode & ~BufferFull & ~BufferFull_q & StallCounter== 8-1) |
                        (~ContinMode & ~BufferFull_q & BufferFull_2q & StallCounter==0)                   |
                        ( ContinMode & StallCounter== 8-1)
                       );

assign SyncResetCpuStall = ( 
                            (~ContinMode & ~BufferFull & ~BufferFull_q & StallCounter== 8-2) |
                            (~ContinMode &  ~BufferFull & BufferFull_q & StallCounter== 8-1) |
                            ( ContinMode & StallCounter== 8-2)
                           );

assign RiscStall_O = FirstCpuStall | RiscStall;


always @(posedge Mclk or posedge Reset)
begin
  if(Reset)
    Counter<=#Tp 0;
  else
  if(CounterEn)
    if(IncrementCounter)
      Counter[ 5:0]<=#Tp Counter[ 5:0] + 1;
    else
      Counter[ 5:0]<=#Tp Counter[ 5:0] - 1;      
end


always @(posedge Mclk or posedge Reset)
begin
  if(Reset)
    WritePointer<=#Tp 0;
  else
  if(IncrementPointer)
    WritePointer[ 5-1:0]<=#Tp WritePointer[ 5-1:0] + 1;
end

always @(posedge Mclk or posedge Reset)
begin
  if(Reset)
    ReadPointer<=#Tp 0;
  else
  if(Decrement & ~ContinMode | Decrement & ContinMode & ~TraceEnable)
    ReadPointer[ 5-1:0]<=#Tp ReadPointer[ 5-1:0] + 1;
  else
  if(ContinMode & IncrementPointer & (BufferFull | BufferFullDetected))
    ReadPointer[ 5-1:0]<=#Tp WritePointer[ 5-1:0] + 1;
end

always @(posedge Mclk)
begin
  if(~TraceEnable)
    BufferFullDetected<=#Tp 0;
  else
  if(ContinMode & BufferFull)
    BufferFullDetected<=#Tp 1;
end


always @(posedge Mclk or posedge Reset)
begin
  if(Reset)
    RiscStall<=#Tp 0;
  else
  if(SyncResetCpuStall)
    RiscStall<=#Tp 0;
  else
  if(SyncSetCpuStall)
    RiscStall<=#Tp 1;
end


always @(posedge Mclk)
begin
  if(ResetStallCounter)
    StallCounter<=#Tp 0;
  else
  if(RiscStall_q & (~BufferFull | ContinMode))
    StallCounter<=#Tp StallCounter+1;
end

assign ResetStallCounter = StallCounter==( 8-1) & ~BufferFull | Reset;







wire Valid = ~BufferEmpty;







always @ (posedge Mclk)
begin
  if(WriteSample)
    Buffer[WritePointer[ 5-1:0]]<={DataIn, 1'b0, OpSelect[ 3-1:0]};
end

assign TraceChain = {Buffer[ReadPointer], 3'h0, Valid};
  







assign OpSelect[ 3-1:0] = StallCounter[ 3-1:0];








assign RecEnable = {1'b0, RecordINSTR,  RecordWriteSPR,  RecordReadSPR,  RecordSDATA,  RecordLDATA,  RecordLSEA,  RecordPC};


endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\bench_tak.v"

module bench;
	reg rstn;
	reg clk=0;
  reg 			uart_srx=0;
   wire 			uart_stx;
   wire 			jtag_tvref; 
   wire 			jtag_tgnd; 
   reg 			jtag_tck=0;
   reg 			jtag_tms=0;
   reg 			jtag_trst=0;
   reg 			jtag_tdi=0;
   wire 			jtag_tdo;

  
  
initial
begin


             rstn = 0;
	#1000;
   		rstn = 1;
end




always
begin
   #10 clk <= ~clk;
end

 xsv_fpga_top   dut(
		     clk, rstn,
		     uart_stx, uart_srx,
  		     jtag_tvref, jtag_tgnd, jtag_tck, jtag_tms, jtag_trst, jtag_tdi, jtag_tdo
		     );

  

 

  wire [7:0] buffer_reg;
  wire int_req;
  reg sync_reset;

  localparam LF=8'h0a;	
	always @(posedge clk, negedge rstn) begin
		if (!rstn) sync_reset <=1'b1;
		else sync_reset<=1'b0;
	end
	
   uart_read   uart_read_port( .sync_reset(sync_reset), .clk(clk), .rxd(uart_stx),.buffer_reg(buffer_reg), .int_req(int_req));
integer i;
	always @(posedge int_req) begin
		begin :local
		
			reg [7:0] local_mem [0:1000];
			 i=0;
			
			if (i>=1000) $stop;

			if (buffer_reg==LF) begin :local2 
				integer j;
				j=0;
				while( j < i) begin
					$write( "%c",local_mem[j]);
					j=j+1;
				end
				$write("     : time=%t\n",$time);
				i=0;
			end else begin
				
				local_mem[i]=buffer_reg;
				i=i+1;
			 end
		end
		
	end




endmodule

`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\xsv_fpga_top_modified.v"








































































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\xsv_fpga_defines.v"




























































































`line 73 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\xsv_fpga_top_modified.v"




module xsv_fpga_top (

		     
		     
		     
		     clk, rstn,

		     
		     
		     
		     
		     

		     
		     
		     
		     
		     

		     
		     
		     
		     
		     









		     
		     
		     
		     
		     



		     
		     
		     
		     
		     

		     
		     
		     
		     
		     
		     
		     

		     
		     
		     
		     

		     
		     
		     
		     

		     
		     
		     
		     

		     uart_stx, uart_srx,
  		     jtag_tvref, jtag_tgnd, jtag_tck, jtag_tms, jtag_trst, jtag_tdi, jtag_tdo
		     );

   
   
   

   
   
   
   input			clk;
   input			rstn;

   
   
   
   
   
   
   
   
   
   

   
   
   
   
   
   
   
   
   

   
   
   
   
   
   
   
   
   


















   
   
   
   
   
   
   
   
   
   



   
   
   
   
   
   
   
   

   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   

   
   
   
   

   
   
   
   
   

   
   
   
   
   
   

   input 			uart_srx;
   output 			uart_stx;
   output 			jtag_tvref; 
   output 			jtag_tgnd; 
   input 			jtag_tck;
   input 			jtag_tms;
   input 			jtag_trst;
   input 			jtag_tdi;
   output 			jtag_tdo;

   
   
   

   
   
   
   
   
   
   
   
   
   
   
   

   
   
   
   
   
   
   
   
   
   
   
   

   
   
   
   
   
   
   
   

   
   
   
   wire [31:0] 			wb_dm_adr_o;
   wire [31:0] 			wb_dm_dat_i;
   wire [31:0] 			wb_dm_dat_o;
   wire [3:0] 			wb_dm_sel_o;
   wire 			wb_dm_we_o;
   wire 			wb_dm_stb_o;
   wire 			wb_dm_cyc_o;
   wire 			wb_dm_cab_o;
   wire 			wb_dm_ack_i;
   wire 			wb_dm_err_i;

   
   
   
   wire [3:0] 			dbg_lss;
   wire [1:0] 			dbg_is;
   wire [10:0] 			dbg_wp;
   wire 			dbg_bp;
   wire [31:0] 			dbg_dat_dbg;
   wire [31:0] 			dbg_dat_risc;
   wire [31:0] 			dbg_adr;
   wire 			dbg_ewt;
   wire 			dbg_stall;
   wire [2:0] 			dbg_op;

   
   
   
   wire [31:0] 			wb_rim_adr_o;
   wire 			wb_rim_cyc_o;
   wire [31:0] 			wb_rim_dat_i;
   wire [31:0] 			wb_rim_dat_o;
   wire [3:0] 			wb_rim_sel_o;
   wire 			wb_rim_ack_i;
   wire 			wb_rim_err_i;
   wire 			wb_rim_rty_i = 1'b0;
   wire 			wb_rim_we_o;
   wire 			wb_rim_stb_o;
   wire 			wb_rim_cab_o;
   wire [31:0] 			wb_rif_adr;
   reg 				prefix_flash;

   
   
   
   wire [31:0] 			wb_rdm_adr_o;
   wire 			wb_rdm_cyc_o;
   wire [31:0] 			wb_rdm_dat_i;
   wire [31:0] 			wb_rdm_dat_o;
   wire [3:0] 			wb_rdm_sel_o;
   wire 			wb_rdm_ack_i;
   wire 			wb_rdm_err_i;
   wire 			wb_rdm_rty_i = 1'b0;
   wire 			wb_rdm_we_o;
   wire 			wb_rdm_stb_o;
   wire 			wb_rdm_cab_o;
   wire 			wb_rdm_ack;

   
   
   
   wire [19:0] 			pic_ints;

   
   
   
   wire [31:0] 			wb_ss_dat_i;
   wire [31:0] 			wb_ss_dat_o;
   wire [31:0] 			wb_ss_adr_i;
   wire [3:0] 			wb_ss_sel_i;
   wire 			wb_ss_we_i;
   wire 			wb_ss_cyc_i;
   wire 			wb_ss_stb_i;
   wire 			wb_ss_ack_o;
   wire 			wb_ss_err_o;

   
   
   
   
   
   

   
   
   










   
   
   










   
   
   











   
   
   










   
   
   





   
   
   











   
   
   










   
   
   



   
   
   
   wire [31:0] 			wb_us_dat_i;
   wire [31:0] 			wb_us_dat_o;
   wire [31:0] 			wb_us_adr_i;
   wire [3:0] 			wb_us_sel_i;
   wire 			wb_us_we_i;
   wire 			wb_us_cyc_i;
   wire 			wb_us_stb_i;
   wire 			wb_us_ack_o;
   wire 			wb_us_err_o;

   
   
   
   wire 			uart_stx;
   wire 			uart_srx;

   
   
   
   wire 			jtag_tvref;
   wire 			jtag_tgnd;
   wire 			jtag_tdi;
   wire 			jtag_tms;
   wire 			jtag_tck;
   wire 			jtag_trst;
   wire 			jtag_tdo;

   
   
   


   
   
   
   reg 				rst_r;
   reg 				wb_rst;

   
   
   



   wire 			wb_clk;


   
   
   
   always @(posedge wb_clk or negedge rstn)
     if (~rstn)
       rst_r <= 1'b1;
     else
       rst_r <= #1 1'b0;

   
   
   
   always @(posedge wb_clk)
     wb_rst <= #1 rst_r;

   
   
   
   
   





   
   
   






   assign 			wb_clk = clk;




 

   
   
   



   
   
   



   
   
   



   
   
   




   
   
   
   assign 			wb_us_err_o = 1'b0;




   
   
   
   
   
   
   
   
   
   











   assign 			jtag_tvref = 1'b1;
   assign 			jtag_tgnd = 1'b0;
   
   
   
   





     













































   
   
   
   
   

     


































   
   
   
   
   















































   
   
   
   dbg_top dbg_top  (

		     
		     .tms_pad_i	( jtag_tms ),
		     .tck_pad_i	( jtag_tck ),
		     .trst_pad_i	( jtag_trst ),
		     .tdi_pad_i	( jtag_tdi ),
		     .tdo_pad_o	( jtag_tdo ),
		     .tdo_padoen_o	( ),

		     
		     .capture_dr_o	( ), 
		     .shift_dr_o	( ), 
		     .update_dr_o	( ), 
		     .extest_selected_o ( ), 
		     .bs_chain_i	( 1'b0 ),
		     .bs_chain_o	( ),

		     
		     .risc_clk_i	( wb_clk ),
		     .risc_addr_o	( dbg_adr ),
		     .risc_data_i	( dbg_dat_risc ),
		     .risc_data_o	( dbg_dat_dbg ),
		     .wp_i		( dbg_wp ),
		     .bp_i		( dbg_bp ),
		     .opselect_o	( dbg_op ),
		     .lsstatus_i	( dbg_lss ),
		     .istatus_i	( dbg_is ),
		     .risc_stall_o	( dbg_stall ),
		     .reset_o	( ),

		     
		     .wb_clk_i	( wb_clk ),
		     .wb_rst_i	( wb_rst ),

		     
		     .wb_adr_o	( wb_dm_adr_o ),
		     .wb_dat_i	( wb_dm_dat_i ),
		     .wb_dat_o	( wb_dm_dat_o ),
		     .wb_sel_o	( wb_dm_sel_o ),
		     .wb_we_o	( wb_dm_we_o  ),
		     .wb_stb_o	( wb_dm_stb_o ),
		     .wb_cyc_o	( wb_dm_cyc_o ),
		     .wb_cab_o	( wb_dm_cab_o ),
		     .wb_ack_i	( wb_dm_ack_i ),
		     .wb_err_i	( wb_dm_err_i )
		     );


   
   
   
   or1200_top or1200_top (

			  
			  .rst_i		( wb_rst ),
			  .clk_i		( wb_clk ),






			  .clmode_i	( 2'b00 ),



			  
			  .iwb_clk_i	( wb_clk ),
			  .iwb_rst_i	( wb_rst ),
			  .iwb_cyc_o	( wb_rim_cyc_o ),
			  .iwb_adr_o	( wb_rim_adr_o ),
			  .iwb_dat_i	( wb_rim_dat_i ),
			  .iwb_dat_o	( wb_rim_dat_o ),
			  .iwb_sel_o	( wb_rim_sel_o ),
			  .iwb_ack_i	( wb_rim_ack_i ),
			  .iwb_err_i	( wb_rim_err_i ),
			  .iwb_rty_i	( wb_rim_rty_i ),
			  .iwb_we_o	( wb_rim_we_o  ),
			  .iwb_stb_o	( wb_rim_stb_o ),
			  .iwb_cab_o	( wb_rim_cab_o ),

			  
			  .dwb_clk_i	( wb_clk ),
			  .dwb_rst_i	( wb_rst ),
			  .dwb_cyc_o	( wb_rdm_cyc_o ),
			  .dwb_adr_o	( wb_rdm_adr_o ),
			  .dwb_dat_i	( wb_rdm_dat_i ),
			  .dwb_dat_o	( wb_rdm_dat_o ),
			  .dwb_sel_o	( wb_rdm_sel_o ),
			  .dwb_ack_i	( wb_rdm_ack_i ),
			  .dwb_err_i	( wb_rdm_err_i ),
			  .dwb_rty_i	( wb_rdm_rty_i ),
			  .dwb_we_o	( wb_rdm_we_o  ),
			  .dwb_stb_o	( wb_rdm_stb_o ),
			  .dwb_cab_o	( wb_rdm_cab_o ),

			  
			  .dbg_stall_i	( dbg_stall ),
			  .dbg_dat_i	( dbg_dat_dbg ),
			  .dbg_adr_i	( dbg_adr ),
			  .dbg_ewt_i	( 1'b0 ),
			  .dbg_lss_o	( dbg_lss ),
			  .dbg_is_o	( dbg_is ),
			  .dbg_wp_o	( dbg_wp ),
			  .dbg_bp_o	( dbg_bp ),
			  .dbg_dat_o	( dbg_dat_risc ),
			  .dbg_ack_o	( ),
			  .dbg_stb_i	( dbg_op[2] ),
			  .dbg_we_i	( dbg_op[0] ),

			  
			  .pm_clksd_o	( ),
			  .pm_cpustall_i	( 1'b0 ),
			  .pm_dc_gate_o	( ),
			  .pm_ic_gate_o	( ),
			  .pm_dmmu_gate_o	( ),
			  .pm_immu_gate_o	( ),
			  .pm_tt_gate_o	( ),
			  .pm_cpu_gate_o	( ),
			  .pm_wakeup_o	( ),
			  .pm_lvolt_o	( ),

			  
			  
			  .pic_ints_i	( 20'b0 )
			  );

   
   
   




























   
   
   

   onchip_ram_top onchip_ram_top (
		      
		      .wb_clk_i	( wb_clk ),
		      .wb_rst_i	( wb_rst ),

		      
		      .wb_dat_i	( wb_ss_dat_i ),
		      .wb_dat_o	( wb_ss_dat_o ),
		      .wb_adr_i	( wb_ss_adr_i ),
		      .wb_sel_i	( wb_ss_sel_i ),
		      .wb_we_i	( wb_ss_we_i  ),
		      .wb_cyc_i	( wb_ss_cyc_i ),
		      .wb_stb_i	( wb_ss_stb_i ),
		      .wb_ack_o	( wb_ss_ack_o ),
		      .wb_err_o	( wb_ss_err_o )

		      















		      );

   
   
   
   uart_top uart_top (

		      
		      .wb_clk_i	( wb_clk ), 
		      .wb_rst_i	( wb_rst ),

		      
		      .wb_adr_i	( wb_us_adr_i[4:0] ),
		      .wb_dat_i	( wb_us_dat_i ),
		      .wb_dat_o	( wb_us_dat_o ),
		      .wb_we_i	( wb_us_we_i  ),
		      .wb_stb_i	( wb_us_stb_i ),
		      .wb_cyc_i	( wb_us_cyc_i ),
		      .wb_ack_o	( wb_us_ack_o ),
		      .wb_sel_i	( wb_us_sel_i ),

		      

 		      .int_o		(),
		      
		      
		      .stx_pad_o	( uart_stx ),
		      .srx_pad_i	( uart_srx ),

		      
		      .rts_pad_o	( ),
		      .cts_pad_i	( 1'b0 ),
		      .dtr_pad_o	( ),
		      .dsr_pad_i	( 1'b0 ),
		      .ri_pad_i	( 1'b0 ),
		      .dcd_pad_i	( 1'b0 )
		      );

   
   
   









































     










   
   
   




























   
   
   
   
   
   
   
   
   










   
   
   
   tc_top #( 8,
	      8 'h00,
	     8,
	      8 'h04,
	     4,
	      8 'h9,
	     8,
	      8 'h97,
	      8 'h92,
	      8 'h9d,
	      8 'h90,
	      8 'h94,
	      8 'h9e,
	      8 'h9f
	    ) tc_top (

		      
		      .wb_clk_i	( wb_clk ),
		      .wb_rst_i	( wb_rst ),

		      
		      .i0_wb_cyc_i	( 1'b0 ),
		      .i0_wb_stb_i	( 1'b0 ),
		      .i0_wb_cab_i	( 1'b0 ),
		      .i0_wb_adr_i	( 32'h0000_0000 ),
		      .i0_wb_sel_i	( 4'b0000 ),
		      .i0_wb_we_i	( 1'b0 ),
		      .i0_wb_dat_i	( 32'h0000_0000 ),
		      .i0_wb_dat_o	( ),
		      .i0_wb_ack_o	( ),
		      .i0_wb_err_o	( ),

		      
		      .i1_wb_cyc_i	( 1'b0 ),
		      .i1_wb_stb_i	( 1'b0 ),
		      .i1_wb_cab_i	( 1'b0 ),
		      .i1_wb_adr_i	( 32'h0000_0000 ),
		      .i1_wb_sel_i	( 4'b0000 ),
		      .i1_wb_we_i	( 1'b0 ),
		      .i1_wb_dat_i	( 32'h0000_0000 ),
		      .i1_wb_dat_o	( ),
		      .i1_wb_ack_o	( ),
		      .i1_wb_err_o	( ),

		      
		      .i2_wb_cyc_i	( 1'b0 ),
		      .i2_wb_stb_i	( 1'b0 ),
		      .i2_wb_cab_i	( 1'b0 ),
		      .i2_wb_adr_i	( 32'h0000_0000 ),
		      .i2_wb_sel_i	( 4'b0000 ),
		      .i2_wb_we_i	( 1'b0 ),
		      .i2_wb_dat_i	( 32'h0000_0000 ),
		      .i2_wb_dat_o	( ),
		      .i2_wb_ack_o	( ),
		      .i2_wb_err_o	( ),

		      
		      .i3_wb_cyc_i	( wb_dm_cyc_o ),
		      .i3_wb_stb_i	( wb_dm_stb_o ),
		      .i3_wb_cab_i	( wb_dm_cab_o ),
		      .i3_wb_adr_i	( wb_dm_adr_o ),
		      .i3_wb_sel_i	( wb_dm_sel_o ),
		      .i3_wb_we_i	( wb_dm_we_o  ),
		      .i3_wb_dat_i	( wb_dm_dat_o ),
		      .i3_wb_dat_o	( wb_dm_dat_i ),
		      .i3_wb_ack_o	( wb_dm_ack_i ),
		      .i3_wb_err_o	( wb_dm_err_i ),

		      
		      .i4_wb_cyc_i	( wb_rdm_cyc_o ),
		      .i4_wb_stb_i	( wb_rdm_stb_o ),
		      .i4_wb_cab_i	( wb_rdm_cab_o ),
		      .i4_wb_adr_i	( wb_rdm_adr_o ),
		      .i4_wb_sel_i	( wb_rdm_sel_o ),
		      .i4_wb_we_i	( wb_rdm_we_o  ),
		      .i4_wb_dat_i	( wb_rdm_dat_o ),
		      .i4_wb_dat_o	( wb_rdm_dat_i ),

		      .i4_wb_ack_o	( wb_rdm_ack_i ),
		      .i4_wb_err_o	( wb_rdm_err_i ),

		      
		      .i5_wb_cyc_i	( wb_rim_cyc_o ),
		      .i5_wb_stb_i	( wb_rim_stb_o ),
		      .i5_wb_cab_i	( wb_rim_cab_o ),

		      .i5_wb_adr_i	( wb_rim_adr_o ),
		      .i5_wb_sel_i	( wb_rim_sel_o ),
		      .i5_wb_we_i	( wb_rim_we_o  ),
		      .i5_wb_dat_i	( wb_rim_dat_o ),
		      .i5_wb_dat_o	( wb_rim_dat_i ),
		      .i5_wb_ack_o	( wb_rim_ack_i ),
		      .i5_wb_err_o	( wb_rim_err_i ),

		      
		      .i6_wb_cyc_i	( 1'b0 ),
		      .i6_wb_stb_i	( 1'b0 ),
		      .i6_wb_cab_i	( 1'b0 ),
		      .i6_wb_adr_i	( 32'h0000_0000 ),
		      .i6_wb_sel_i	( 4'b0000 ),
		      .i6_wb_we_i	( 1'b0 ),
		      .i6_wb_dat_i	( 32'h0000_0000 ),
		      .i6_wb_dat_o	( ),
		      .i6_wb_ack_o	( ),
		      .i6_wb_err_o	( ),

		      
		      .i7_wb_cyc_i	( 1'b0 ),
		      .i7_wb_stb_i	( 1'b0 ),
		      .i7_wb_cab_i	( 1'b0 ),
		      .i7_wb_adr_i	( 32'h0000_0000 ),
		      .i7_wb_sel_i	( 4'b0000 ),
		      .i7_wb_we_i	( 1'b0 ),
		      .i7_wb_dat_i	( 32'h0000_0000 ),
		      .i7_wb_dat_o	( ),
		      .i7_wb_ack_o	( ),
		      .i7_wb_err_o	( ),

		      
		      .t0_wb_cyc_o	( wb_ss_cyc_i ),
		      .t0_wb_stb_o	( wb_ss_stb_i ),
		      .t0_wb_cab_o	( wb_ss_cab_i ),
		      .t0_wb_adr_o	( wb_ss_adr_i ),
		      .t0_wb_sel_o	( wb_ss_sel_i ),
		      .t0_wb_we_o	( wb_ss_we_i  ),
		      .t0_wb_dat_o	( wb_ss_dat_i ),
		      .t0_wb_dat_i	( wb_ss_dat_o ),
		      .t0_wb_ack_i	( wb_ss_ack_o ),
		      .t0_wb_err_i	( wb_ss_err_o ),

		      
		      .t1_wb_cyc_o	( ),
		      .t1_wb_stb_o	( ),
		      .t1_wb_cab_o	( ),
		      .t1_wb_adr_o	( ),
		      .t1_wb_sel_o	( ),
		      .t1_wb_we_o	( ),
		      .t1_wb_dat_o	( ),
		      .t1_wb_dat_i	( 32'h0000_0000 ),
		      .t1_wb_ack_i	( 1'b0 ),
		      .t1_wb_err_i	( 1'b1 ),

		      
		      .t2_wb_cyc_o	( ),
		      .t2_wb_stb_o	( ),
		      .t2_wb_cab_o	( ),
		      .t2_wb_adr_o	( ),
		      .t2_wb_sel_o	( ),
		      .t2_wb_we_o	( ),
		      .t2_wb_dat_o	( ),
		      .t2_wb_dat_i	( 32'h0000_0000 ),
		      .t2_wb_ack_i	( 1'b0 ),
		      .t2_wb_err_i	( 1'b1 ),

		      
		      .t3_wb_cyc_o	( ),
		      .t3_wb_stb_o	( ),
		      .t3_wb_cab_o	( ),
		      .t3_wb_adr_o	( ),
		      .t3_wb_sel_o	( ),
		      .t3_wb_we_o	( ),
		      .t3_wb_dat_o	( ),
		      .t3_wb_dat_i	( 32'h0000_0000 ),
		      .t3_wb_ack_i	( 1'b0 ),
		      .t3_wb_err_i	( 1'b1 ),

		      
		      .t4_wb_cyc_o	( ),
		      .t4_wb_stb_o	( ),
		      .t4_wb_cab_o	( ),
		      .t4_wb_adr_o	( ),
		      .t4_wb_sel_o	( ),
		      .t4_wb_we_o	( ),
		      .t4_wb_dat_o	( ),
		      .t4_wb_dat_i	( 32'h0000_0000 ),
		      .t4_wb_ack_i	( 1'b0 ),
		      .t4_wb_err_i	( 1'b1 ),

		      
		      .t5_wb_cyc_o	( wb_us_cyc_i ),
		      .t5_wb_stb_o	( wb_us_stb_i ),
		      .t5_wb_cab_o	( wb_us_cab_i ),
		      .t5_wb_adr_o	( wb_us_adr_i ),
		      .t5_wb_sel_o	( wb_us_sel_i ),
		      .t5_wb_we_o	( wb_us_we_i  ),
		      .t5_wb_dat_o	( wb_us_dat_i ),
		      .t5_wb_dat_i	( wb_us_dat_o ),
		      .t5_wb_ack_i	( wb_us_ack_o ),
		      .t5_wb_err_i	( wb_us_err_o ),

		      
		      .t6_wb_cyc_o	( ),
		      .t6_wb_stb_o	( ),
		      .t6_wb_cab_o	( ),
		      .t6_wb_adr_o	( ),
		      .t6_wb_sel_o	( ),
		      .t6_wb_we_o	( ),
		      .t6_wb_dat_o	( ),
		      .t6_wb_dat_i	( 32'h0000_0000 ),
		      .t6_wb_ack_i	( 1'b0 ),
		      .t6_wb_err_i	( 1'b1 ),

		      
		      .t7_wb_cyc_o	( ),
		      .t7_wb_stb_o	( ),
		      .t7_wb_cab_o	( ),
		      .t7_wb_adr_o	( ),
		      .t7_wb_sel_o	( ),
		      .t7_wb_we_o	( ),
		      .t7_wb_dat_o	( ),
		      .t7_wb_dat_i	( 32'h0000_0000 ),
		      .t7_wb_ack_i	( 1'b0 ),
		      .t7_wb_err_i	( 1'b1 ),

		      
		      .t8_wb_cyc_o	( ),
		      .t8_wb_stb_o	( ),
		      .t8_wb_cab_o	( ),
		      .t8_wb_adr_o	( ),
		      .t8_wb_sel_o	( ),
		      .t8_wb_we_o	( ),
		      .t8_wb_dat_o	( ),
		      .t8_wb_dat_i	( 32'h0000_0000 ),
		      .t8_wb_ack_i	( 1'b0 ),
		      .t8_wb_err_i	( 1'b1 )
		      );

   
   
   
   

endmodule


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\tc_top.v"




























































`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\dbg_interface\timescale.v"
































































`timescale 1ns / 1ns

`line 61 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\tc_top.v"




































module tc_top (
	wb_clk_i,
	wb_rst_i,

	i0_wb_cyc_i,
	i0_wb_stb_i,
	i0_wb_cab_i,
	i0_wb_adr_i,
	i0_wb_sel_i,
	i0_wb_we_i,
	i0_wb_dat_i,
	i0_wb_dat_o,
	i0_wb_ack_o,
	i0_wb_err_o,

	i1_wb_cyc_i,
	i1_wb_stb_i,
	i1_wb_cab_i,
	i1_wb_adr_i,
	i1_wb_sel_i,
	i1_wb_we_i,
	i1_wb_dat_i,
	i1_wb_dat_o,
	i1_wb_ack_o,
	i1_wb_err_o,

	i2_wb_cyc_i,
	i2_wb_stb_i,
	i2_wb_cab_i,
	i2_wb_adr_i,
	i2_wb_sel_i,
	i2_wb_we_i,
	i2_wb_dat_i,
	i2_wb_dat_o,
	i2_wb_ack_o,
	i2_wb_err_o,

	i3_wb_cyc_i,
	i3_wb_stb_i,
	i3_wb_cab_i,
	i3_wb_adr_i,
	i3_wb_sel_i,
	i3_wb_we_i,
	i3_wb_dat_i,
	i3_wb_dat_o,
	i3_wb_ack_o,
	i3_wb_err_o,

	i4_wb_cyc_i,
	i4_wb_stb_i,
	i4_wb_cab_i,
	i4_wb_adr_i,
	i4_wb_sel_i,
	i4_wb_we_i,
	i4_wb_dat_i,
	i4_wb_dat_o,
	i4_wb_ack_o,
	i4_wb_err_o,

	i5_wb_cyc_i,
	i5_wb_stb_i,
	i5_wb_cab_i,
	i5_wb_adr_i,
	i5_wb_sel_i,
	i5_wb_we_i,
	i5_wb_dat_i,
	i5_wb_dat_o,
	i5_wb_ack_o,
	i5_wb_err_o,

	i6_wb_cyc_i,
	i6_wb_stb_i,
	i6_wb_cab_i,
	i6_wb_adr_i,
	i6_wb_sel_i,
	i6_wb_we_i,
	i6_wb_dat_i,
	i6_wb_dat_o,
	i6_wb_ack_o,
	i6_wb_err_o,

	i7_wb_cyc_i,
	i7_wb_stb_i,
	i7_wb_cab_i,
	i7_wb_adr_i,
	i7_wb_sel_i,
	i7_wb_we_i,
	i7_wb_dat_i,
	i7_wb_dat_o,
	i7_wb_ack_o,
	i7_wb_err_o,

	t0_wb_cyc_o,
	t0_wb_stb_o,
	t0_wb_cab_o,
	t0_wb_adr_o,
	t0_wb_sel_o,
	t0_wb_we_o,
	t0_wb_dat_o,
	t0_wb_dat_i,
	t0_wb_ack_i,
	t0_wb_err_i,

	t1_wb_cyc_o,
	t1_wb_stb_o,
	t1_wb_cab_o,
	t1_wb_adr_o,
	t1_wb_sel_o,
	t1_wb_we_o,
	t1_wb_dat_o,
	t1_wb_dat_i,
	t1_wb_ack_i,
	t1_wb_err_i,

	t2_wb_cyc_o,
	t2_wb_stb_o,
	t2_wb_cab_o,
	t2_wb_adr_o,
	t2_wb_sel_o,
	t2_wb_we_o,
	t2_wb_dat_o,
	t2_wb_dat_i,
	t2_wb_ack_i,
	t2_wb_err_i,

	t3_wb_cyc_o,
	t3_wb_stb_o,
	t3_wb_cab_o,
	t3_wb_adr_o,
	t3_wb_sel_o,
	t3_wb_we_o,
	t3_wb_dat_o,
	t3_wb_dat_i,
	t3_wb_ack_i,
	t3_wb_err_i,

	t4_wb_cyc_o,
	t4_wb_stb_o,
	t4_wb_cab_o,
	t4_wb_adr_o,
	t4_wb_sel_o,
	t4_wb_we_o,
	t4_wb_dat_o,
	t4_wb_dat_i,
	t4_wb_ack_i,
	t4_wb_err_i,

	t5_wb_cyc_o,
	t5_wb_stb_o,
	t5_wb_cab_o,
	t5_wb_adr_o,
	t5_wb_sel_o,
	t5_wb_we_o,
	t5_wb_dat_o,
	t5_wb_dat_i,
	t5_wb_ack_i,
	t5_wb_err_i,

	t6_wb_cyc_o,
	t6_wb_stb_o,
	t6_wb_cab_o,
	t6_wb_adr_o,
	t6_wb_sel_o,
	t6_wb_we_o,
	t6_wb_dat_o,
	t6_wb_dat_i,
	t6_wb_ack_i,
	t6_wb_err_i,

	t7_wb_cyc_o,
	t7_wb_stb_o,
	t7_wb_cab_o,
	t7_wb_adr_o,
	t7_wb_sel_o,
	t7_wb_we_o,
	t7_wb_dat_o,
	t7_wb_dat_i,
	t7_wb_ack_i,
	t7_wb_err_i,

	t8_wb_cyc_o,
	t8_wb_stb_o,
	t8_wb_cab_o,
	t8_wb_adr_o,
	t8_wb_sel_o,
	t8_wb_we_o,
	t8_wb_dat_o,
	t8_wb_dat_i,
	t8_wb_ack_i,
	t8_wb_err_i

);




parameter		t0_addr_w = 4;
parameter		t0_addr = 4'd8;
parameter		t1_addr_w = 4;
parameter		t1_addr = 4'd0;
parameter		t28c_addr_w = 4;
parameter		t28_addr = 4'd0;
parameter		t28i_addr_w = 4;
parameter		t2_addr = 4'd1;
parameter		t3_addr = 4'd2;
parameter		t4_addr = 4'd3;
parameter		t5_addr = 4'd4;
parameter		t6_addr = 4'd5;
parameter		t7_addr = 4'd6;
parameter		t8_addr = 4'd7;




input			wb_clk_i;
input			wb_rst_i;




input			i0_wb_cyc_i;
input			i0_wb_stb_i;
input			i0_wb_cab_i;
input	[ 32-1:0]	i0_wb_adr_i;
input	[ 4-1:0]	i0_wb_sel_i;
input			i0_wb_we_i;
input	[ 32-1:0]	i0_wb_dat_i;
output	[ 32-1:0]	i0_wb_dat_o;
output			i0_wb_ack_o;
output			i0_wb_err_o;




input			i1_wb_cyc_i;
input			i1_wb_stb_i;
input			i1_wb_cab_i;
input	[ 32-1:0]	i1_wb_adr_i;
input	[ 4-1:0]	i1_wb_sel_i;
input			i1_wb_we_i;
input	[ 32-1:0]	i1_wb_dat_i;
output	[ 32-1:0]	i1_wb_dat_o;
output			i1_wb_ack_o;
output			i1_wb_err_o;




input			i2_wb_cyc_i;
input			i2_wb_stb_i;
input			i2_wb_cab_i;
input	[ 32-1:0]	i2_wb_adr_i;
input	[ 4-1:0]	i2_wb_sel_i;
input			i2_wb_we_i;
input	[ 32-1:0]	i2_wb_dat_i;
output	[ 32-1:0]	i2_wb_dat_o;
output			i2_wb_ack_o;
output			i2_wb_err_o;




input			i3_wb_cyc_i;
input			i3_wb_stb_i;
input			i3_wb_cab_i;
input	[ 32-1:0]	i3_wb_adr_i;
input	[ 4-1:0]	i3_wb_sel_i;
input			i3_wb_we_i;
input	[ 32-1:0]	i3_wb_dat_i;
output	[ 32-1:0]	i3_wb_dat_o;
output			i3_wb_ack_o;
output			i3_wb_err_o;




input			i4_wb_cyc_i;
input			i4_wb_stb_i;
input			i4_wb_cab_i;
input	[ 32-1:0]	i4_wb_adr_i;
input	[ 4-1:0]	i4_wb_sel_i;
input			i4_wb_we_i;
input	[ 32-1:0]	i4_wb_dat_i;
output	[ 32-1:0]	i4_wb_dat_o;
output			i4_wb_ack_o;
output			i4_wb_err_o;




input			i5_wb_cyc_i;
input			i5_wb_stb_i;
input			i5_wb_cab_i;
input	[ 32-1:0]	i5_wb_adr_i;
input	[ 4-1:0]	i5_wb_sel_i;
input			i5_wb_we_i;
input	[ 32-1:0]	i5_wb_dat_i;
output	[ 32-1:0]	i5_wb_dat_o;
output			i5_wb_ack_o;
output			i5_wb_err_o;




input			i6_wb_cyc_i;
input			i6_wb_stb_i;
input			i6_wb_cab_i;
input	[ 32-1:0]	i6_wb_adr_i;
input	[ 4-1:0]	i6_wb_sel_i;
input			i6_wb_we_i;
input	[ 32-1:0]	i6_wb_dat_i;
output	[ 32-1:0]	i6_wb_dat_o;
output			i6_wb_ack_o;
output			i6_wb_err_o;




input			i7_wb_cyc_i;
input			i7_wb_stb_i;
input			i7_wb_cab_i;
input	[ 32-1:0]	i7_wb_adr_i;
input	[ 4-1:0]	i7_wb_sel_i;
input			i7_wb_we_i;
input	[ 32-1:0]	i7_wb_dat_i;
output	[ 32-1:0]	i7_wb_dat_o;
output			i7_wb_ack_o;
output			i7_wb_err_o;




output			t0_wb_cyc_o;
output			t0_wb_stb_o;
output			t0_wb_cab_o;
output	[ 32-1:0]	t0_wb_adr_o;
output	[ 4-1:0]	t0_wb_sel_o;
output			t0_wb_we_o;
output	[ 32-1:0]	t0_wb_dat_o;
input	[ 32-1:0]	t0_wb_dat_i;
input			t0_wb_ack_i;
input			t0_wb_err_i;




output			t1_wb_cyc_o;
output			t1_wb_stb_o;
output			t1_wb_cab_o;
output	[ 32-1:0]	t1_wb_adr_o;
output	[ 4-1:0]	t1_wb_sel_o;
output			t1_wb_we_o;
output	[ 32-1:0]	t1_wb_dat_o;
input	[ 32-1:0]	t1_wb_dat_i;
input			t1_wb_ack_i;
input			t1_wb_err_i;




output			t2_wb_cyc_o;
output			t2_wb_stb_o;
output			t2_wb_cab_o;
output	[ 32-1:0]	t2_wb_adr_o;
output	[ 4-1:0]	t2_wb_sel_o;
output			t2_wb_we_o;
output	[ 32-1:0]	t2_wb_dat_o;
input	[ 32-1:0]	t2_wb_dat_i;
input			t2_wb_ack_i;
input			t2_wb_err_i;




output			t3_wb_cyc_o;
output			t3_wb_stb_o;
output			t3_wb_cab_o;
output	[ 32-1:0]	t3_wb_adr_o;
output	[ 4-1:0]	t3_wb_sel_o;
output			t3_wb_we_o;
output	[ 32-1:0]	t3_wb_dat_o;
input	[ 32-1:0]	t3_wb_dat_i;
input			t3_wb_ack_i;
input			t3_wb_err_i;




output			t4_wb_cyc_o;
output			t4_wb_stb_o;
output			t4_wb_cab_o;
output	[ 32-1:0]	t4_wb_adr_o;
output	[ 4-1:0]	t4_wb_sel_o;
output			t4_wb_we_o;
output	[ 32-1:0]	t4_wb_dat_o;
input	[ 32-1:0]	t4_wb_dat_i;
input			t4_wb_ack_i;
input			t4_wb_err_i;




output			t5_wb_cyc_o;
output			t5_wb_stb_o;
output			t5_wb_cab_o;
output	[ 32-1:0]	t5_wb_adr_o;
output	[ 4-1:0]	t5_wb_sel_o;
output			t5_wb_we_o;
output	[ 32-1:0]	t5_wb_dat_o;
input	[ 32-1:0]	t5_wb_dat_i;
input			t5_wb_ack_i;
input			t5_wb_err_i;




output			t6_wb_cyc_o;
output			t6_wb_stb_o;
output			t6_wb_cab_o;
output	[ 32-1:0]	t6_wb_adr_o;
output	[ 4-1:0]	t6_wb_sel_o;
output			t6_wb_we_o;
output	[ 32-1:0]	t6_wb_dat_o;
input	[ 32-1:0]	t6_wb_dat_i;
input			t6_wb_ack_i;
input			t6_wb_err_i;




output			t7_wb_cyc_o;
output			t7_wb_stb_o;
output			t7_wb_cab_o;
output	[ 32-1:0]	t7_wb_adr_o;
output	[ 4-1:0]	t7_wb_sel_o;
output			t7_wb_we_o;
output	[ 32-1:0]	t7_wb_dat_o;
input	[ 32-1:0]	t7_wb_dat_i;
input			t7_wb_ack_i;
input			t7_wb_err_i;




output			t8_wb_cyc_o;
output			t8_wb_stb_o;
output			t8_wb_cab_o;
output	[ 32-1:0]	t8_wb_adr_o;
output	[ 4-1:0]	t8_wb_sel_o;
output			t8_wb_we_o;
output	[ 32-1:0]	t8_wb_dat_o;
input	[ 32-1:0]	t8_wb_dat_i;
input			t8_wb_ack_i;
input			t8_wb_err_i;








wire	[ 32-1:0]	xi0_wb_dat_o;
wire			xi0_wb_ack_o;
wire			xi0_wb_err_o;
wire	[ 32-1:0]	xi1_wb_dat_o;
wire			xi1_wb_ack_o;
wire			xi1_wb_err_o;
wire	[ 32-1:0]	xi2_wb_dat_o;
wire			xi2_wb_ack_o;
wire			xi2_wb_err_o;
wire	[ 32-1:0]	xi3_wb_dat_o;
wire			xi3_wb_ack_o;
wire			xi3_wb_err_o;
wire	[ 32-1:0]	xi4_wb_dat_o;
wire			xi4_wb_ack_o;
wire			xi4_wb_err_o;
wire	[ 32-1:0]	xi5_wb_dat_o;
wire			xi5_wb_ack_o;
wire			xi5_wb_err_o;
wire	[ 32-1:0]	xi6_wb_dat_o;
wire			xi6_wb_ack_o;
wire			xi6_wb_err_o;
wire	[ 32-1:0]	xi7_wb_dat_o;
wire			xi7_wb_ack_o;
wire			xi7_wb_err_o;
wire	[ 32-1:0]	yi0_wb_dat_o;
wire			yi0_wb_ack_o;
wire			yi0_wb_err_o;
wire	[ 32-1:0]	yi1_wb_dat_o;
wire			yi1_wb_ack_o;
wire			yi1_wb_err_o;
wire	[ 32-1:0]	yi2_wb_dat_o;
wire			yi2_wb_ack_o;
wire			yi2_wb_err_o;
wire	[ 32-1:0]	yi3_wb_dat_o;
wire			yi3_wb_ack_o;
wire			yi3_wb_err_o;
wire	[ 32-1:0]	yi4_wb_dat_o;
wire			yi4_wb_ack_o;
wire			yi4_wb_err_o;
wire	[ 32-1:0]	yi5_wb_dat_o;
wire			yi5_wb_ack_o;
wire			yi5_wb_err_o;
wire	[ 32-1:0]	yi6_wb_dat_o;
wire			yi6_wb_ack_o;
wire			yi6_wb_err_o;
wire	[ 32-1:0]	yi7_wb_dat_o;
wire			yi7_wb_ack_o;
wire			yi7_wb_err_o;





wire			z_wb_cyc_i;
wire			z_wb_stb_i;
wire			z_wb_cab_i;
wire	[ 32-1:0]	z_wb_adr_i;
wire	[ 4-1:0]	z_wb_sel_i;
wire			z_wb_we_i;
wire	[ 32-1:0]	z_wb_dat_i;
wire	[ 32-1:0]	z_wb_dat_t;
wire			z_wb_ack_t;
wire			z_wb_err_t;




assign i0_wb_dat_o = xi0_wb_dat_o | yi0_wb_dat_o;
assign i0_wb_ack_o = xi0_wb_ack_o | yi0_wb_ack_o;
assign i0_wb_err_o = xi0_wb_err_o | yi0_wb_err_o;
assign i1_wb_dat_o = xi1_wb_dat_o | yi1_wb_dat_o;
assign i1_wb_ack_o = xi1_wb_ack_o | yi1_wb_ack_o;
assign i1_wb_err_o = xi1_wb_err_o | yi1_wb_err_o;
assign i2_wb_dat_o = xi2_wb_dat_o | yi2_wb_dat_o;
assign i2_wb_ack_o = xi2_wb_ack_o | yi2_wb_ack_o;
assign i2_wb_err_o = xi2_wb_err_o | yi2_wb_err_o;
assign i3_wb_dat_o = xi3_wb_dat_o | yi3_wb_dat_o;
assign i3_wb_ack_o = xi3_wb_ack_o | yi3_wb_ack_o;
assign i3_wb_err_o = xi3_wb_err_o | yi3_wb_err_o;
assign i4_wb_dat_o = xi4_wb_dat_o | yi4_wb_dat_o;
assign i4_wb_ack_o = xi4_wb_ack_o | yi4_wb_ack_o;
assign i4_wb_err_o = xi4_wb_err_o | yi4_wb_err_o;
assign i5_wb_dat_o = xi5_wb_dat_o | yi5_wb_dat_o;
assign i5_wb_ack_o = xi5_wb_ack_o | yi5_wb_ack_o;
assign i5_wb_err_o = xi5_wb_err_o | yi5_wb_err_o;
assign i6_wb_dat_o = xi6_wb_dat_o | yi6_wb_dat_o;
assign i6_wb_ack_o = xi6_wb_ack_o | yi6_wb_ack_o;
assign i6_wb_err_o = xi6_wb_err_o | yi6_wb_err_o;
assign i7_wb_dat_o = xi7_wb_dat_o | yi7_wb_dat_o;
assign i7_wb_ack_o = xi7_wb_ack_o | yi7_wb_ack_o;
assign i7_wb_err_o = xi7_wb_err_o | yi7_wb_err_o;




tc_mi_to_st #(t0_addr_w, t0_addr,
	0, t0_addr_w, t0_addr) t0_ch(
	.wb_clk_i(wb_clk_i),
	.wb_rst_i(wb_rst_i),

	.i0_wb_cyc_i(i0_wb_cyc_i),
	.i0_wb_stb_i(i0_wb_stb_i),
	.i0_wb_cab_i(i0_wb_cab_i),
	.i0_wb_adr_i(i0_wb_adr_i),
	.i0_wb_sel_i(i0_wb_sel_i),
	.i0_wb_we_i(i0_wb_we_i),
	.i0_wb_dat_i(i0_wb_dat_i),
	.i0_wb_dat_o(xi0_wb_dat_o),
	.i0_wb_ack_o(xi0_wb_ack_o),
	.i0_wb_err_o(xi0_wb_err_o),

	.i1_wb_cyc_i(i1_wb_cyc_i),
	.i1_wb_stb_i(i1_wb_stb_i),
	.i1_wb_cab_i(i1_wb_cab_i),
	.i1_wb_adr_i(i1_wb_adr_i),
	.i1_wb_sel_i(i1_wb_sel_i),
	.i1_wb_we_i(i1_wb_we_i),
	.i1_wb_dat_i(i1_wb_dat_i),
	.i1_wb_dat_o(xi1_wb_dat_o),
	.i1_wb_ack_o(xi1_wb_ack_o),
	.i1_wb_err_o(xi1_wb_err_o),

	.i2_wb_cyc_i(i2_wb_cyc_i),
	.i2_wb_stb_i(i2_wb_stb_i),
	.i2_wb_cab_i(i2_wb_cab_i),
	.i2_wb_adr_i(i2_wb_adr_i),
	.i2_wb_sel_i(i2_wb_sel_i),
	.i2_wb_we_i(i2_wb_we_i),
	.i2_wb_dat_i(i2_wb_dat_i),
	.i2_wb_dat_o(xi2_wb_dat_o),
	.i2_wb_ack_o(xi2_wb_ack_o),
	.i2_wb_err_o(xi2_wb_err_o),

	.i3_wb_cyc_i(i3_wb_cyc_i),
	.i3_wb_stb_i(i3_wb_stb_i),
	.i3_wb_cab_i(i3_wb_cab_i),
	.i3_wb_adr_i(i3_wb_adr_i),
	.i3_wb_sel_i(i3_wb_sel_i),
	.i3_wb_we_i(i3_wb_we_i),
	.i3_wb_dat_i(i3_wb_dat_i),
	.i3_wb_dat_o(xi3_wb_dat_o),
	.i3_wb_ack_o(xi3_wb_ack_o),
	.i3_wb_err_o(xi3_wb_err_o),

	.i4_wb_cyc_i(i4_wb_cyc_i),
	.i4_wb_stb_i(i4_wb_stb_i),
	.i4_wb_cab_i(i4_wb_cab_i),
	.i4_wb_adr_i(i4_wb_adr_i),
	.i4_wb_sel_i(i4_wb_sel_i),
	.i4_wb_we_i(i4_wb_we_i),
	.i4_wb_dat_i(i4_wb_dat_i),
	.i4_wb_dat_o(xi4_wb_dat_o),
	.i4_wb_ack_o(xi4_wb_ack_o),
	.i4_wb_err_o(xi4_wb_err_o),

	.i5_wb_cyc_i(i5_wb_cyc_i),
	.i5_wb_stb_i(i5_wb_stb_i),
	.i5_wb_cab_i(i5_wb_cab_i),
	.i5_wb_adr_i(i5_wb_adr_i),
	.i5_wb_sel_i(i5_wb_sel_i),
	.i5_wb_we_i(i5_wb_we_i),
	.i5_wb_dat_i(i5_wb_dat_i),
	.i5_wb_dat_o(xi5_wb_dat_o),
	.i5_wb_ack_o(xi5_wb_ack_o),
	.i5_wb_err_o(xi5_wb_err_o),

	.i6_wb_cyc_i(i6_wb_cyc_i),
	.i6_wb_stb_i(i6_wb_stb_i),
	.i6_wb_cab_i(i6_wb_cab_i),
	.i6_wb_adr_i(i6_wb_adr_i),
	.i6_wb_sel_i(i6_wb_sel_i),
	.i6_wb_we_i(i6_wb_we_i),
	.i6_wb_dat_i(i6_wb_dat_i),
	.i6_wb_dat_o(xi6_wb_dat_o),
	.i6_wb_ack_o(xi6_wb_ack_o),
	.i6_wb_err_o(xi6_wb_err_o),

	.i7_wb_cyc_i(i7_wb_cyc_i),
	.i7_wb_stb_i(i7_wb_stb_i),
	.i7_wb_cab_i(i7_wb_cab_i),
	.i7_wb_adr_i(i7_wb_adr_i),
	.i7_wb_sel_i(i7_wb_sel_i),
	.i7_wb_we_i(i7_wb_we_i),
	.i7_wb_dat_i(i7_wb_dat_i),
	.i7_wb_dat_o(xi7_wb_dat_o),
	.i7_wb_ack_o(xi7_wb_ack_o),
	.i7_wb_err_o(xi7_wb_err_o),

	.t0_wb_cyc_o(t0_wb_cyc_o),
	.t0_wb_stb_o(t0_wb_stb_o),
	.t0_wb_cab_o(t0_wb_cab_o),
	.t0_wb_adr_o(t0_wb_adr_o),
	.t0_wb_sel_o(t0_wb_sel_o),
	.t0_wb_we_o(t0_wb_we_o),
	.t0_wb_dat_o(t0_wb_dat_o),
	.t0_wb_dat_i(t0_wb_dat_i),
	.t0_wb_ack_i(t0_wb_ack_i),
	.t0_wb_err_i(t0_wb_err_i)

);




tc_mi_to_st #(t1_addr_w, t1_addr,
	1, t28c_addr_w, t28_addr) t18_ch_upper(
	.wb_clk_i(wb_clk_i),
	.wb_rst_i(wb_rst_i),

	.i0_wb_cyc_i(i0_wb_cyc_i),
	.i0_wb_stb_i(i0_wb_stb_i),
	.i0_wb_cab_i(i0_wb_cab_i),
	.i0_wb_adr_i(i0_wb_adr_i),
	.i0_wb_sel_i(i0_wb_sel_i),
	.i0_wb_we_i(i0_wb_we_i),
	.i0_wb_dat_i(i0_wb_dat_i),
	.i0_wb_dat_o(yi0_wb_dat_o),
	.i0_wb_ack_o(yi0_wb_ack_o),
	.i0_wb_err_o(yi0_wb_err_o),

	.i1_wb_cyc_i(i1_wb_cyc_i),
	.i1_wb_stb_i(i1_wb_stb_i),
	.i1_wb_cab_i(i1_wb_cab_i),
	.i1_wb_adr_i(i1_wb_adr_i),
	.i1_wb_sel_i(i1_wb_sel_i),
	.i1_wb_we_i(i1_wb_we_i),
	.i1_wb_dat_i(i1_wb_dat_i),
	.i1_wb_dat_o(yi1_wb_dat_o),
	.i1_wb_ack_o(yi1_wb_ack_o),
	.i1_wb_err_o(yi1_wb_err_o),

	.i2_wb_cyc_i(i2_wb_cyc_i),
	.i2_wb_stb_i(i2_wb_stb_i),
	.i2_wb_cab_i(i2_wb_cab_i),
	.i2_wb_adr_i(i2_wb_adr_i),
	.i2_wb_sel_i(i2_wb_sel_i),
	.i2_wb_we_i(i2_wb_we_i),
	.i2_wb_dat_i(i2_wb_dat_i),
	.i2_wb_dat_o(yi2_wb_dat_o),
	.i2_wb_ack_o(yi2_wb_ack_o),
	.i2_wb_err_o(yi2_wb_err_o),

	.i3_wb_cyc_i(i3_wb_cyc_i),
	.i3_wb_stb_i(i3_wb_stb_i),
	.i3_wb_cab_i(i3_wb_cab_i),
	.i3_wb_adr_i(i3_wb_adr_i),
	.i3_wb_sel_i(i3_wb_sel_i),
	.i3_wb_we_i(i3_wb_we_i),
	.i3_wb_dat_i(i3_wb_dat_i),
	.i3_wb_dat_o(yi3_wb_dat_o),
	.i3_wb_ack_o(yi3_wb_ack_o),
	.i3_wb_err_o(yi3_wb_err_o),

	.i4_wb_cyc_i(i4_wb_cyc_i),
	.i4_wb_stb_i(i4_wb_stb_i),
	.i4_wb_cab_i(i4_wb_cab_i),
	.i4_wb_adr_i(i4_wb_adr_i),
	.i4_wb_sel_i(i4_wb_sel_i),
	.i4_wb_we_i(i4_wb_we_i),
	.i4_wb_dat_i(i4_wb_dat_i),
	.i4_wb_dat_o(yi4_wb_dat_o),
	.i4_wb_ack_o(yi4_wb_ack_o),
	.i4_wb_err_o(yi4_wb_err_o),

	.i5_wb_cyc_i(i5_wb_cyc_i),
	.i5_wb_stb_i(i5_wb_stb_i),
	.i5_wb_cab_i(i5_wb_cab_i),
	.i5_wb_adr_i(i5_wb_adr_i),
	.i5_wb_sel_i(i5_wb_sel_i),
	.i5_wb_we_i(i5_wb_we_i),
	.i5_wb_dat_i(i5_wb_dat_i),
	.i5_wb_dat_o(yi5_wb_dat_o),
	.i5_wb_ack_o(yi5_wb_ack_o),
	.i5_wb_err_o(yi5_wb_err_o),

	.i6_wb_cyc_i(i6_wb_cyc_i),
	.i6_wb_stb_i(i6_wb_stb_i),
	.i6_wb_cab_i(i6_wb_cab_i),
	.i6_wb_adr_i(i6_wb_adr_i),
	.i6_wb_sel_i(i6_wb_sel_i),
	.i6_wb_we_i(i6_wb_we_i),
	.i6_wb_dat_i(i6_wb_dat_i),
	.i6_wb_dat_o(yi6_wb_dat_o),
	.i6_wb_ack_o(yi6_wb_ack_o),
	.i6_wb_err_o(yi6_wb_err_o),

	.i7_wb_cyc_i(i7_wb_cyc_i),
	.i7_wb_stb_i(i7_wb_stb_i),
	.i7_wb_cab_i(i7_wb_cab_i),
	.i7_wb_adr_i(i7_wb_adr_i),
	.i7_wb_sel_i(i7_wb_sel_i),
	.i7_wb_we_i(i7_wb_we_i),
	.i7_wb_dat_i(i7_wb_dat_i),
	.i7_wb_dat_o(yi7_wb_dat_o),
	.i7_wb_ack_o(yi7_wb_ack_o),
	.i7_wb_err_o(yi7_wb_err_o),

	.t0_wb_cyc_o(z_wb_cyc_i),
	.t0_wb_stb_o(z_wb_stb_i),
	.t0_wb_cab_o(z_wb_cab_i),
	.t0_wb_adr_o(z_wb_adr_i),
	.t0_wb_sel_o(z_wb_sel_i),
	.t0_wb_we_o(z_wb_we_i),
	.t0_wb_dat_o(z_wb_dat_i),
	.t0_wb_dat_i(z_wb_dat_t),
	.t0_wb_ack_i(z_wb_ack_t),
	.t0_wb_err_i(z_wb_err_t)

);




tc_si_to_mt #(t1_addr_w, t1_addr, t28i_addr_w, t2_addr, t3_addr,
	t4_addr, t5_addr, t6_addr, t7_addr, t8_addr) t18_ch_lower(

	.i0_wb_cyc_i(z_wb_cyc_i),
	.i0_wb_stb_i(z_wb_stb_i),
	.i0_wb_cab_i(z_wb_cab_i),
	.i0_wb_adr_i(z_wb_adr_i),
	.i0_wb_sel_i(z_wb_sel_i),
	.i0_wb_we_i(z_wb_we_i),
	.i0_wb_dat_i(z_wb_dat_i),
	.i0_wb_dat_o(z_wb_dat_t),
	.i0_wb_ack_o(z_wb_ack_t),
	.i0_wb_err_o(z_wb_err_t),

	.t0_wb_cyc_o(t1_wb_cyc_o),
	.t0_wb_stb_o(t1_wb_stb_o),
	.t0_wb_cab_o(t1_wb_cab_o),
	.t0_wb_adr_o(t1_wb_adr_o),
	.t0_wb_sel_o(t1_wb_sel_o),
	.t0_wb_we_o(t1_wb_we_o),
	.t0_wb_dat_o(t1_wb_dat_o),
	.t0_wb_dat_i(t1_wb_dat_i),
	.t0_wb_ack_i(t1_wb_ack_i),
	.t0_wb_err_i(t1_wb_err_i),

	.t1_wb_cyc_o(t2_wb_cyc_o),
	.t1_wb_stb_o(t2_wb_stb_o),
	.t1_wb_cab_o(t2_wb_cab_o),
	.t1_wb_adr_o(t2_wb_adr_o),
	.t1_wb_sel_o(t2_wb_sel_o),
	.t1_wb_we_o(t2_wb_we_o),
	.t1_wb_dat_o(t2_wb_dat_o),
	.t1_wb_dat_i(t2_wb_dat_i),
	.t1_wb_ack_i(t2_wb_ack_i),
	.t1_wb_err_i(t2_wb_err_i),

	.t2_wb_cyc_o(t3_wb_cyc_o),
	.t2_wb_stb_o(t3_wb_stb_o),
	.t2_wb_cab_o(t3_wb_cab_o),
	.t2_wb_adr_o(t3_wb_adr_o),
	.t2_wb_sel_o(t3_wb_sel_o),
	.t2_wb_we_o(t3_wb_we_o),
	.t2_wb_dat_o(t3_wb_dat_o),
	.t2_wb_dat_i(t3_wb_dat_i),
	.t2_wb_ack_i(t3_wb_ack_i),
	.t2_wb_err_i(t3_wb_err_i),

	.t3_wb_cyc_o(t4_wb_cyc_o),
	.t3_wb_stb_o(t4_wb_stb_o),
	.t3_wb_cab_o(t4_wb_cab_o),
	.t3_wb_adr_o(t4_wb_adr_o),
	.t3_wb_sel_o(t4_wb_sel_o),
	.t3_wb_we_o(t4_wb_we_o),
	.t3_wb_dat_o(t4_wb_dat_o),
	.t3_wb_dat_i(t4_wb_dat_i),
	.t3_wb_ack_i(t4_wb_ack_i),
	.t3_wb_err_i(t4_wb_err_i),

	.t4_wb_cyc_o(t5_wb_cyc_o),
	.t4_wb_stb_o(t5_wb_stb_o),
	.t4_wb_cab_o(t5_wb_cab_o),
	.t4_wb_adr_o(t5_wb_adr_o),
	.t4_wb_sel_o(t5_wb_sel_o),
	.t4_wb_we_o(t5_wb_we_o),
	.t4_wb_dat_o(t5_wb_dat_o),
	.t4_wb_dat_i(t5_wb_dat_i),
	.t4_wb_ack_i(t5_wb_ack_i),
	.t4_wb_err_i(t5_wb_err_i),

	.t5_wb_cyc_o(t6_wb_cyc_o),
	.t5_wb_stb_o(t6_wb_stb_o),
	.t5_wb_cab_o(t6_wb_cab_o),
	.t5_wb_adr_o(t6_wb_adr_o),
	.t5_wb_sel_o(t6_wb_sel_o),
	.t5_wb_we_o(t6_wb_we_o),
	.t5_wb_dat_o(t6_wb_dat_o),
	.t5_wb_dat_i(t6_wb_dat_i),
	.t5_wb_ack_i(t6_wb_ack_i),
	.t5_wb_err_i(t6_wb_err_i),

	.t6_wb_cyc_o(t7_wb_cyc_o),
	.t6_wb_stb_o(t7_wb_stb_o),
	.t6_wb_cab_o(t7_wb_cab_o),
	.t6_wb_adr_o(t7_wb_adr_o),
	.t6_wb_sel_o(t7_wb_sel_o),
	.t6_wb_we_o(t7_wb_we_o),
	.t6_wb_dat_o(t7_wb_dat_o),
	.t6_wb_dat_i(t7_wb_dat_i),
	.t6_wb_ack_i(t7_wb_ack_i),
	.t6_wb_err_i(t7_wb_err_i),

	.t7_wb_cyc_o(t8_wb_cyc_o),
	.t7_wb_stb_o(t8_wb_stb_o),
	.t7_wb_cab_o(t8_wb_cab_o),
	.t7_wb_adr_o(t8_wb_adr_o),
	.t7_wb_sel_o(t8_wb_sel_o),
	.t7_wb_we_o(t8_wb_we_o),
	.t7_wb_dat_o(t8_wb_dat_o),
	.t7_wb_dat_i(t8_wb_dat_i),
	.t7_wb_ack_i(t8_wb_ack_i),
	.t7_wb_err_i(t8_wb_err_i)

);

endmodule




module tc_mi_to_st (
	wb_clk_i,
	wb_rst_i,

	i0_wb_cyc_i,
	i0_wb_stb_i,
	i0_wb_cab_i,
	i0_wb_adr_i,
	i0_wb_sel_i,
	i0_wb_we_i,
	i0_wb_dat_i,
	i0_wb_dat_o,
	i0_wb_ack_o,
	i0_wb_err_o,

	i1_wb_cyc_i,
	i1_wb_stb_i,
	i1_wb_cab_i,
	i1_wb_adr_i,
	i1_wb_sel_i,
	i1_wb_we_i,
	i1_wb_dat_i,
	i1_wb_dat_o,
	i1_wb_ack_o,
	i1_wb_err_o,

	i2_wb_cyc_i,
	i2_wb_stb_i,
	i2_wb_cab_i,
	i2_wb_adr_i,
	i2_wb_sel_i,
	i2_wb_we_i,
	i2_wb_dat_i,
	i2_wb_dat_o,
	i2_wb_ack_o,
	i2_wb_err_o,

	i3_wb_cyc_i,
	i3_wb_stb_i,
	i3_wb_cab_i,
	i3_wb_adr_i,
	i3_wb_sel_i,
	i3_wb_we_i,
	i3_wb_dat_i,
	i3_wb_dat_o,
	i3_wb_ack_o,
	i3_wb_err_o,

	i4_wb_cyc_i,
	i4_wb_stb_i,
	i4_wb_cab_i,
	i4_wb_adr_i,
	i4_wb_sel_i,
	i4_wb_we_i,
	i4_wb_dat_i,
	i4_wb_dat_o,
	i4_wb_ack_o,
	i4_wb_err_o,

	i5_wb_cyc_i,
	i5_wb_stb_i,
	i5_wb_cab_i,
	i5_wb_adr_i,
	i5_wb_sel_i,
	i5_wb_we_i,
	i5_wb_dat_i,
	i5_wb_dat_o,
	i5_wb_ack_o,
	i5_wb_err_o,

	i6_wb_cyc_i,
	i6_wb_stb_i,
	i6_wb_cab_i,
	i6_wb_adr_i,
	i6_wb_sel_i,
	i6_wb_we_i,
	i6_wb_dat_i,
	i6_wb_dat_o,
	i6_wb_ack_o,
	i6_wb_err_o,

	i7_wb_cyc_i,
	i7_wb_stb_i,
	i7_wb_cab_i,
	i7_wb_adr_i,
	i7_wb_sel_i,
	i7_wb_we_i,
	i7_wb_dat_i,
	i7_wb_dat_o,
	i7_wb_ack_o,
	i7_wb_err_o,

	t0_wb_cyc_o,
	t0_wb_stb_o,
	t0_wb_cab_o,
	t0_wb_adr_o,
	t0_wb_sel_o,
	t0_wb_we_o,
	t0_wb_dat_o,
	t0_wb_dat_i,
	t0_wb_ack_i,
	t0_wb_err_i

);




parameter		t0_addr_w = 2;
parameter		t0_addr = 2'b00;
parameter		multitarg = 1'b0;
parameter		t17_addr_w = 2;
parameter		t17_addr = 2'b00;




input			wb_clk_i;
input			wb_rst_i;




input			i0_wb_cyc_i;
input			i0_wb_stb_i;
input			i0_wb_cab_i;
input	[ 32-1:0]	i0_wb_adr_i;
input	[ 4-1:0]	i0_wb_sel_i;
input			i0_wb_we_i;
input	[ 32-1:0]	i0_wb_dat_i;
output	[ 32-1:0]	i0_wb_dat_o;
output			i0_wb_ack_o;
output			i0_wb_err_o;




input			i1_wb_cyc_i;
input			i1_wb_stb_i;
input			i1_wb_cab_i;
input	[ 32-1:0]	i1_wb_adr_i;
input	[ 4-1:0]	i1_wb_sel_i;
input			i1_wb_we_i;
input	[ 32-1:0]	i1_wb_dat_i;
output	[ 32-1:0]	i1_wb_dat_o;
output			i1_wb_ack_o;
output			i1_wb_err_o;




input			i2_wb_cyc_i;
input			i2_wb_stb_i;
input			i2_wb_cab_i;
input	[ 32-1:0]	i2_wb_adr_i;
input	[ 4-1:0]	i2_wb_sel_i;
input			i2_wb_we_i;
input	[ 32-1:0]	i2_wb_dat_i;
output	[ 32-1:0]	i2_wb_dat_o;
output			i2_wb_ack_o;
output			i2_wb_err_o;




input			i3_wb_cyc_i;
input			i3_wb_stb_i;
input			i3_wb_cab_i;
input	[ 32-1:0]	i3_wb_adr_i;
input	[ 4-1:0]	i3_wb_sel_i;
input			i3_wb_we_i;
input	[ 32-1:0]	i3_wb_dat_i;
output	[ 32-1:0]	i3_wb_dat_o;
output			i3_wb_ack_o;
output			i3_wb_err_o;




input			i4_wb_cyc_i;
input			i4_wb_stb_i;
input			i4_wb_cab_i;
input	[ 32-1:0]	i4_wb_adr_i;
input	[ 4-1:0]	i4_wb_sel_i;
input			i4_wb_we_i;
input	[ 32-1:0]	i4_wb_dat_i;
output	[ 32-1:0]	i4_wb_dat_o;
output			i4_wb_ack_o;
output			i4_wb_err_o;




input			i5_wb_cyc_i;
input			i5_wb_stb_i;
input			i5_wb_cab_i;
input	[ 32-1:0]	i5_wb_adr_i;
input	[ 4-1:0]	i5_wb_sel_i;
input			i5_wb_we_i;
input	[ 32-1:0]	i5_wb_dat_i;
output	[ 32-1:0]	i5_wb_dat_o;
output			i5_wb_ack_o;
output			i5_wb_err_o;




input			i6_wb_cyc_i;
input			i6_wb_stb_i;
input			i6_wb_cab_i;
input	[ 32-1:0]	i6_wb_adr_i;
input	[ 4-1:0]	i6_wb_sel_i;
input			i6_wb_we_i;
input	[ 32-1:0]	i6_wb_dat_i;
output	[ 32-1:0]	i6_wb_dat_o;
output			i6_wb_ack_o;
output			i6_wb_err_o;




input			i7_wb_cyc_i;
input			i7_wb_stb_i;
input			i7_wb_cab_i;
input	[ 32-1:0]	i7_wb_adr_i;
input	[ 4-1:0]	i7_wb_sel_i;
input			i7_wb_we_i;
input	[ 32-1:0]	i7_wb_dat_i;
output	[ 32-1:0]	i7_wb_dat_o;
output			i7_wb_ack_o;
output			i7_wb_err_o;




output			t0_wb_cyc_o;
output			t0_wb_stb_o;
output			t0_wb_cab_o;
output	[ 32-1:0]	t0_wb_adr_o;
output	[ 4-1:0]	t0_wb_sel_o;
output			t0_wb_we_o;
output	[ 32-1:0]	t0_wb_dat_o;
input	[ 32-1:0]	t0_wb_dat_i;
input			t0_wb_ack_i;
input			t0_wb_err_i;




wire	[ 1 + 1 + 1 +  32 +  4 + 1 +  32-1:0]	i0_in, i1_in,
			i2_in, i3_in,
			i4_in, i5_in,
			i6_in, i7_in;
wire	[  32 + 1 + 1-1:0]	i0_out, i1_out,
			i2_out, i3_out,
			i4_out, i5_out,
			i6_out, i7_out;
wire	[ 1 + 1 + 1 +  32 +  4 + 1 +  32-1:0]	t0_out;
wire	[  32 + 1 + 1-1:0]	t0_in;
wire	[7:0]		req_i;
wire	[2:0]		req_won;
reg			req_cont;
reg	[2:0]		req_r;




assign i0_in = {i0_wb_cyc_i, i0_wb_stb_i, i0_wb_cab_i, i0_wb_adr_i,
		i0_wb_sel_i, i0_wb_we_i, i0_wb_dat_i};
assign {i0_wb_dat_o, i0_wb_ack_o, i0_wb_err_o} = i0_out;




assign i1_in = {i1_wb_cyc_i, i1_wb_stb_i, i1_wb_cab_i, i1_wb_adr_i,
		i1_wb_sel_i, i1_wb_we_i, i1_wb_dat_i};
assign {i1_wb_dat_o, i1_wb_ack_o, i1_wb_err_o} = i1_out;




assign i2_in = {i2_wb_cyc_i, i2_wb_stb_i, i2_wb_cab_i, i2_wb_adr_i,
		i2_wb_sel_i, i2_wb_we_i, i2_wb_dat_i};
assign {i2_wb_dat_o, i2_wb_ack_o, i2_wb_err_o} = i2_out;




assign i3_in = {i3_wb_cyc_i, i3_wb_stb_i, i3_wb_cab_i, i3_wb_adr_i,
		i3_wb_sel_i, i3_wb_we_i, i3_wb_dat_i};
assign {i3_wb_dat_o, i3_wb_ack_o, i3_wb_err_o} = i3_out;




assign i4_in = {i4_wb_cyc_i, i4_wb_stb_i, i4_wb_cab_i, i4_wb_adr_i,
		i4_wb_sel_i, i4_wb_we_i, i4_wb_dat_i};
assign {i4_wb_dat_o, i4_wb_ack_o, i4_wb_err_o} = i4_out;




assign i5_in = {i5_wb_cyc_i, i5_wb_stb_i, i5_wb_cab_i, i5_wb_adr_i,
		i5_wb_sel_i, i5_wb_we_i, i5_wb_dat_i};
assign {i5_wb_dat_o, i5_wb_ack_o, i5_wb_err_o} = i5_out;




assign i6_in = {i6_wb_cyc_i, i6_wb_stb_i, i6_wb_cab_i, i6_wb_adr_i,
		i6_wb_sel_i, i6_wb_we_i, i6_wb_dat_i};
assign {i6_wb_dat_o, i6_wb_ack_o, i6_wb_err_o} = i6_out;




assign i7_in = {i7_wb_cyc_i, i7_wb_stb_i, i7_wb_cab_i, i7_wb_adr_i,
		i7_wb_sel_i, i7_wb_we_i, i7_wb_dat_i};
assign {i7_wb_dat_o, i7_wb_ack_o, i7_wb_err_o} = i7_out;




assign {t0_wb_cyc_o, t0_wb_stb_o, t0_wb_cab_o, t0_wb_adr_o,
		t0_wb_sel_o, t0_wb_we_o, t0_wb_dat_o} = t0_out;
assign t0_in = {t0_wb_dat_i, t0_wb_ack_i, t0_wb_err_i};






assign i0_out = (req_won == 3'd0) ? t0_in : {  32 + 1 + 1{1'b0}};
assign i1_out = (req_won == 3'd1) ? t0_in : {  32 + 1 + 1{1'b0}};
assign i2_out = (req_won == 3'd2) ? t0_in : {  32 + 1 + 1{1'b0}};
assign i3_out = (req_won == 3'd3) ? t0_in : {  32 + 1 + 1{1'b0}};
assign i4_out = (req_won == 3'd4) ? t0_in : {  32 + 1 + 1{1'b0}};
assign i5_out = (req_won == 3'd5) ? t0_in : {  32 + 1 + 1{1'b0}};
assign i6_out = (req_won == 3'd6) ? t0_in : {  32 + 1 + 1{1'b0}};
assign i7_out = (req_won == 3'd7) ? t0_in : {  32 + 1 + 1{1'b0}};








assign t0_out = (req_won == 3'd0) ? i0_in :
		(req_won == 3'd1) ? i1_in :
		(req_won == 3'd2) ? i2_in :
		(req_won == 3'd3) ? i3_in :
		(req_won == 3'd4) ? i4_in :
		(req_won == 3'd5) ? i5_in :
		(req_won == 3'd6) ? i6_in :
		(req_won == 3'd7) ? i7_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};




assign req_i[0] = i0_wb_cyc_i &
	((i0_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));
assign req_i[1] = i1_wb_cyc_i &
	((i1_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i1_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));
assign req_i[2] = i2_wb_cyc_i &
	((i2_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i2_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));
assign req_i[3] = i3_wb_cyc_i &
	((i3_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i3_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));
assign req_i[4] = i4_wb_cyc_i &
	((i4_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i4_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));
assign req_i[5] = i5_wb_cyc_i &
	((i5_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i5_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));
assign req_i[6] = i6_wb_cyc_i &
	((i6_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i6_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));
assign req_i[7] = i7_wb_cyc_i &
	((i7_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr) |
	 multitarg & (i7_wb_adr_i[ 32-1: 32-t17_addr_w] == t17_addr));










assign req_won = req_cont ? req_r :
		 req_i[0] ? 3'd0 :
		 req_i[1] ? 3'd1 :
		 req_i[2] ? 3'd2 :
		 req_i[3] ? 3'd3 :
		 req_i[4] ? 3'd4 :
		 req_i[5] ? 3'd5 :
		 req_i[6] ? 3'd6 :
		 req_i[7] ? 3'd7 : 3'd0;





always @(req_r or req_i)
	case (req_r)	
		3'd0: req_cont = req_i[0];
		3'd1: req_cont = req_i[1];
		3'd2: req_cont = req_i[2];
		3'd3: req_cont = req_i[3];
		3'd4: req_cont = req_i[4];
		3'd5: req_cont = req_i[5];
		3'd6: req_cont = req_i[6];
		3'd7: req_cont = req_i[7];
	endcase




always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		req_r <= #1 3'd0;
	else
		req_r <= #1 req_won;

endmodule	




module tc_si_to_mt (

	i0_wb_cyc_i,
	i0_wb_stb_i,
	i0_wb_cab_i,
	i0_wb_adr_i,
	i0_wb_sel_i,
	i0_wb_we_i,
	i0_wb_dat_i,
	i0_wb_dat_o,
	i0_wb_ack_o,
	i0_wb_err_o,

	t0_wb_cyc_o,
	t0_wb_stb_o,
	t0_wb_cab_o,
	t0_wb_adr_o,
	t0_wb_sel_o,
	t0_wb_we_o,
	t0_wb_dat_o,
	t0_wb_dat_i,
	t0_wb_ack_i,
	t0_wb_err_i,

	t1_wb_cyc_o,
	t1_wb_stb_o,
	t1_wb_cab_o,
	t1_wb_adr_o,
	t1_wb_sel_o,
	t1_wb_we_o,
	t1_wb_dat_o,
	t1_wb_dat_i,
	t1_wb_ack_i,
	t1_wb_err_i,

	t2_wb_cyc_o,
	t2_wb_stb_o,
	t2_wb_cab_o,
	t2_wb_adr_o,
	t2_wb_sel_o,
	t2_wb_we_o,
	t2_wb_dat_o,
	t2_wb_dat_i,
	t2_wb_ack_i,
	t2_wb_err_i,

	t3_wb_cyc_o,
	t3_wb_stb_o,
	t3_wb_cab_o,
	t3_wb_adr_o,
	t3_wb_sel_o,
	t3_wb_we_o,
	t3_wb_dat_o,
	t3_wb_dat_i,
	t3_wb_ack_i,
	t3_wb_err_i,

	t4_wb_cyc_o,
	t4_wb_stb_o,
	t4_wb_cab_o,
	t4_wb_adr_o,
	t4_wb_sel_o,
	t4_wb_we_o,
	t4_wb_dat_o,
	t4_wb_dat_i,
	t4_wb_ack_i,
	t4_wb_err_i,

	t5_wb_cyc_o,
	t5_wb_stb_o,
	t5_wb_cab_o,
	t5_wb_adr_o,
	t5_wb_sel_o,
	t5_wb_we_o,
	t5_wb_dat_o,
	t5_wb_dat_i,
	t5_wb_ack_i,
	t5_wb_err_i,

	t6_wb_cyc_o,
	t6_wb_stb_o,
	t6_wb_cab_o,
	t6_wb_adr_o,
	t6_wb_sel_o,
	t6_wb_we_o,
	t6_wb_dat_o,
	t6_wb_dat_i,
	t6_wb_ack_i,
	t6_wb_err_i,

	t7_wb_cyc_o,
	t7_wb_stb_o,
	t7_wb_cab_o,
	t7_wb_adr_o,
	t7_wb_sel_o,
	t7_wb_we_o,
	t7_wb_dat_o,
	t7_wb_dat_i,
	t7_wb_ack_i,
	t7_wb_err_i

);




parameter		t0_addr_w = 3;
parameter		t0_addr = 3'd0;
parameter		t17_addr_w = 3;
parameter		t1_addr = 3'd1;
parameter		t2_addr = 3'd2;
parameter		t3_addr = 3'd3;
parameter		t4_addr = 3'd4;
parameter		t5_addr = 3'd5;
parameter		t6_addr = 3'd6;
parameter		t7_addr = 3'd7;








input			i0_wb_cyc_i;
input			i0_wb_stb_i;
input			i0_wb_cab_i;
input	[ 32-1:0]	i0_wb_adr_i;
input	[ 4-1:0]	i0_wb_sel_i;
input			i0_wb_we_i;
input	[ 32-1:0]	i0_wb_dat_i;
output	[ 32-1:0]	i0_wb_dat_o;
output			i0_wb_ack_o;
output			i0_wb_err_o;




output			t0_wb_cyc_o;
output			t0_wb_stb_o;
output			t0_wb_cab_o;
output	[ 32-1:0]	t0_wb_adr_o;
output	[ 4-1:0]	t0_wb_sel_o;
output			t0_wb_we_o;
output	[ 32-1:0]	t0_wb_dat_o;
input	[ 32-1:0]	t0_wb_dat_i;
input			t0_wb_ack_i;
input			t0_wb_err_i;




output			t1_wb_cyc_o;
output			t1_wb_stb_o;
output			t1_wb_cab_o;
output	[ 32-1:0]	t1_wb_adr_o;
output	[ 4-1:0]	t1_wb_sel_o;
output			t1_wb_we_o;
output	[ 32-1:0]	t1_wb_dat_o;
input	[ 32-1:0]	t1_wb_dat_i;
input			t1_wb_ack_i;
input			t1_wb_err_i;




output			t2_wb_cyc_o;
output			t2_wb_stb_o;
output			t2_wb_cab_o;
output	[ 32-1:0]	t2_wb_adr_o;
output	[ 4-1:0]	t2_wb_sel_o;
output			t2_wb_we_o;
output	[ 32-1:0]	t2_wb_dat_o;
input	[ 32-1:0]	t2_wb_dat_i;
input			t2_wb_ack_i;
input			t2_wb_err_i;




output			t3_wb_cyc_o;
output			t3_wb_stb_o;
output			t3_wb_cab_o;
output	[ 32-1:0]	t3_wb_adr_o;
output	[ 4-1:0]	t3_wb_sel_o;
output			t3_wb_we_o;
output	[ 32-1:0]	t3_wb_dat_o;
input	[ 32-1:0]	t3_wb_dat_i;
input			t3_wb_ack_i;
input			t3_wb_err_i;




output			t4_wb_cyc_o;
output			t4_wb_stb_o;
output			t4_wb_cab_o;
output	[ 32-1:0]	t4_wb_adr_o;
output	[ 4-1:0]	t4_wb_sel_o;
output			t4_wb_we_o;
output	[ 32-1:0]	t4_wb_dat_o;
input	[ 32-1:0]	t4_wb_dat_i;
input			t4_wb_ack_i;
input			t4_wb_err_i;




output			t5_wb_cyc_o;
output			t5_wb_stb_o;
output			t5_wb_cab_o;
output	[ 32-1:0]	t5_wb_adr_o;
output	[ 4-1:0]	t5_wb_sel_o;
output			t5_wb_we_o;
output	[ 32-1:0]	t5_wb_dat_o;
input	[ 32-1:0]	t5_wb_dat_i;
input			t5_wb_ack_i;
input			t5_wb_err_i;




output			t6_wb_cyc_o;
output			t6_wb_stb_o;
output			t6_wb_cab_o;
output	[ 32-1:0]	t6_wb_adr_o;
output	[ 4-1:0]	t6_wb_sel_o;
output			t6_wb_we_o;
output	[ 32-1:0]	t6_wb_dat_o;
input	[ 32-1:0]	t6_wb_dat_i;
input			t6_wb_ack_i;
input			t6_wb_err_i;




output			t7_wb_cyc_o;
output			t7_wb_stb_o;
output			t7_wb_cab_o;
output	[ 32-1:0]	t7_wb_adr_o;
output	[ 4-1:0]	t7_wb_sel_o;
output			t7_wb_we_o;
output	[ 32-1:0]	t7_wb_dat_o;
input	[ 32-1:0]	t7_wb_dat_i;
input			t7_wb_ack_i;
input			t7_wb_err_i;




wire	[ 1 + 1 + 1 +  32 +  4 + 1 +  32-1:0]	i0_in;
wire	[  32 + 1 + 1-1:0]	i0_out;
wire	[ 1 + 1 + 1 +  32 +  4 + 1 +  32-1:0]	t0_out, t1_out,
			t2_out, t3_out,
			t4_out, t5_out,
			t6_out, t7_out;
wire	[  32 + 1 + 1-1:0]	t0_in, t1_in,
			t2_in, t3_in,
			t4_in, t5_in,
			t6_in, t7_in;
wire	[7:0]		req_t;




assign i0_in = {i0_wb_cyc_i, i0_wb_stb_i, i0_wb_cab_i, i0_wb_adr_i,
		i0_wb_sel_i, i0_wb_we_i, i0_wb_dat_i};
assign {i0_wb_dat_o, i0_wb_ack_o, i0_wb_err_o} = i0_out;




assign {t0_wb_cyc_o, t0_wb_stb_o, t0_wb_cab_o, t0_wb_adr_o,
		t0_wb_sel_o, t0_wb_we_o, t0_wb_dat_o} = t0_out;
assign t0_in = {t0_wb_dat_i, t0_wb_ack_i, t0_wb_err_i};




assign {t1_wb_cyc_o, t1_wb_stb_o, t1_wb_cab_o, t1_wb_adr_o,
		t1_wb_sel_o, t1_wb_we_o, t1_wb_dat_o} = t1_out;
assign t1_in = {t1_wb_dat_i, t1_wb_ack_i, t1_wb_err_i};




assign {t2_wb_cyc_o, t2_wb_stb_o, t2_wb_cab_o, t2_wb_adr_o,
		t2_wb_sel_o, t2_wb_we_o, t2_wb_dat_o} = t2_out;
assign t2_in = {t2_wb_dat_i, t2_wb_ack_i, t2_wb_err_i};




assign {t3_wb_cyc_o, t3_wb_stb_o, t3_wb_cab_o, t3_wb_adr_o,
		t3_wb_sel_o, t3_wb_we_o, t3_wb_dat_o} = t3_out;
assign t3_in = {t3_wb_dat_i, t3_wb_ack_i, t3_wb_err_i};




assign {t4_wb_cyc_o, t4_wb_stb_o, t4_wb_cab_o, t4_wb_adr_o,
		t4_wb_sel_o, t4_wb_we_o, t4_wb_dat_o} = t4_out;
assign t4_in = {t4_wb_dat_i, t4_wb_ack_i, t4_wb_err_i};




assign {t5_wb_cyc_o, t5_wb_stb_o, t5_wb_cab_o, t5_wb_adr_o,
		t5_wb_sel_o, t5_wb_we_o, t5_wb_dat_o} = t5_out;
assign t5_in = {t5_wb_dat_i, t5_wb_ack_i, t5_wb_err_i};




assign {t6_wb_cyc_o, t6_wb_stb_o, t6_wb_cab_o, t6_wb_adr_o,
		t6_wb_sel_o, t6_wb_we_o, t6_wb_dat_o} = t6_out;
assign t6_in = {t6_wb_dat_i, t6_wb_ack_i, t6_wb_err_i};




assign {t7_wb_cyc_o, t7_wb_stb_o, t7_wb_cab_o, t7_wb_adr_o,
		t7_wb_sel_o, t7_wb_we_o, t7_wb_dat_o} = t7_out;
assign t7_in = {t7_wb_dat_i, t7_wb_ack_i, t7_wb_err_i};






assign t0_out = req_t[0] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};
assign t1_out = req_t[1] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};
assign t2_out = req_t[2] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};
assign t3_out = req_t[3] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};
assign t4_out = req_t[4] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};
assign t5_out = req_t[5] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};
assign t6_out = req_t[6] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};
assign t7_out = req_t[7] ? i0_in : { 1 + 1 + 1 +  32 +  4 + 1 +  32{1'b0}};








assign i0_out = req_t[0] ? t0_in :
		req_t[1] ? t1_in :
		req_t[2] ? t2_in :
		req_t[3] ? t3_in :
		req_t[4] ? t4_in :
		req_t[5] ? t5_in :
		req_t[6] ? t6_in :
		req_t[7] ? t7_in : {  32 + 1 + 1{1'b0}};




assign req_t[0] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t0_addr_w] == t0_addr);
assign req_t[1] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t1_addr);
assign req_t[2] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t2_addr);
assign req_t[3] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t3_addr);
assign req_t[4] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t4_addr);
assign req_t[5] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t5_addr);
assign req_t[6] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t6_addr);
assign req_t[7] = i0_wb_cyc_i & (i0_wb_adr_i[ 32-1: 32-t17_addr_w] == t7_addr);

endmodule	


`line 1 "D:\Documents and Settings\tak sugawara\My Documents\english\benchmarks\verilog\uart_read.v"









module	uart_read( sync_reset, clk, rxd,buffer_reg, int_req);
	input sync_reset;
	input	clk, rxd;
	output	[7:0] buffer_reg;
	output	int_req;
	






	
	reg	        rxq1;
	reg		[8:0] clk_ctr;
	reg		[2:0] bit_ctr;
	reg		[2:0] ua_state;
	reg		[7:0] rx_sr;             
	reg		int_req;
	reg		[7:0] buffer_reg;	

	wire	 clk_ctr_equ15, clk_ctr_equ31, bit_ctr_equ7, 
			   clk_ctr_enable_state, bit_ctr_enable_state  ;
	wire 	clk_ctr_equ0;
	    

	
	 



	always @(posedge clk ) begin
		rxq1 <=rxd ;
	end
	

	always @(posedge clk ) begin
		if (sync_reset)
			clk_ctr <= 0;
		else if (clk_ctr_enable_state && clk_ctr_equ31)  clk_ctr<=0;	
		else if (clk_ctr_enable_state)	                 clk_ctr <= clk_ctr + 1;
		else	clk_ctr <= 0;
	end
	assign	clk_ctr_equ15 =  (clk_ctr== 216)  ;
	assign	clk_ctr_equ31 =  (clk_ctr== (  216 * 2 + 1 )) ;
	assign  clk_ctr_equ0=    (clk_ctr== (  216 + 3 ));	


	
	always @(posedge clk) begin
		if (sync_reset)
			bit_ctr <= 0;
		else if (bit_ctr_enable_state) begin
			if (clk_ctr_equ15)
				bit_ctr <= bit_ctr + 1;
		end
		else
			bit_ctr <= 0;
	end

	assign	bit_ctr_equ7 = (bit_ctr==7);

	
	assign	clk_ctr_enable_state =  ua_state !=3'b000  && ua_state<=3'b011;
	assign	bit_ctr_enable_state = ua_state==3'h2;


	always @(posedge clk ) begin
		if (sync_reset) ua_state <= 3'h0;
		else begin
			case (ua_state)
				3'h0:	if (rxq1==0) ua_state <= 3'h1;  
				3'h1:	if (clk_ctr_equ15) ua_state <= 3'h2;					
				3'h2:	if (bit_ctr_equ7 & clk_ctr_equ15) ua_state <= 3'h3;	
				3'h3:	if (clk_ctr_equ15)     ua_state <=3'h4; 								
				3'h4:   ua_state <= 3'b000;
				default: ua_state <= 3'b000;			
			endcase
		end
	end



	always @(posedge clk ) begin
		if (sync_reset) 			   buffer_reg<=8'h00;
		else if (ua_state==3'h3 && clk_ctr_equ0)  buffer_reg<=rx_sr;
	end


	always @(posedge clk ) begin
		if (sync_reset) 			    int_req<=1'b0;
		else if (ua_state==3'h4	)   int_req<=1'b1;	
		else 					    int_req<=1'b0;
	end



	always @(posedge clk ) begin
		if (sync_reset) rx_sr <= 0;
		else if (clk_ctr_equ15) rx_sr <= {rxq1, rx_sr[7:1]};
	end
	
endmodule


